      real*8 function kern(xv,wgt)
c*********************************************************************
c MC kernel for the phase-space slicing branch of RacoonWW
c July 27, 2000,  Doreen Wackeroth 
c last changes: 04/10/2002
c*********************************************************************
      implicit none
      integer nndim,ihist,it,ncall2,iti(5),itig,itiq
      integer nmax
      parameter(nmax=10)
      integer npart,nout
      integer ntot(2),ncut(2),ncut1_k(2),ncut2_k(2),
     $     ncut3_k(2),ncut4_k(2),ncut5_k(2),ncut6_k(2),
     $     ncut_r(2),ncutq_r(2)
      integer ch,chg,nch(5),nchg,nchq,icoll
      integer maxe,nsubevent
      parameter(maxe=29)
      integer ix
      parameter(ix=1000)
      integer dpa,wflag(maxe)
      integer mapi(8,ix),mapich(8),mapig(8,ix),mapigch(8),
     $     mapiq(8,ix),mapiqch(8)
      integer ii(5,ix),iich(5),iig(5,ix),iigch(5),
     $     iiq(5,ix),iiqch(5),ccuts(3)
      integer init1(ix),ni1(ix),init2(ix),ni2(ix),init3(ix),ni3(ix),
     $     init4(ix),ni4(ix),init5(ix),ni5(ix),initg(ix),nig(ix),
     $     initq(ix),niq(ix)
      integer opt,istep(5),nopt,iopt,istepg,noptg,ioptg,istepq
      integer qborn,qreal,qqcd,qbos,qferm,qsoft,qnf,qfast,sqqcd
      integer smc,sborn4,sborn5,sborng5,sisr,src,son,sqcdepem,
     $     ssigepem4,ssigepem5,ssigepemg5,scoultree,sunw,spaw,satgc
      integer qsigepem4,qsigepem5,qqcdepem
      integer type,nc,cc,sym,perm
      integer qprop,quark(6),iso(6),gen(6),dir(7),pol(7),color
      integer dsdc,dsdcg
      integer srecomb,srecombg,scuts
      integer i,j,icut,icuti1,icuti2,nocut
      integer iout
      real*8 p(4,nmax),sinv(nmax,nmax)
      real*8 b(4,2),bh(4,2)
      real*8 bon(4,2),pson(4,nmax),sinvo(nmax,nmax)
      real*8 rs
      real*8 lambda,lambda2,deltas,loglow,logup,deltac
      real*8 deltags,deltagc
      real*8 conti(maxe),conti_tot(maxe),dconti_tot(maxe)
      real*8 xv(15),rand,wgt
      real*8 x(11),xc
      real*8 dot_4,wps
      real*8 M2,M2_epem_4f,M2_epem_4fA,M2_epem_4fG,M2_Born_offsh
      real*8 M2flip(6)
      real*8 smin,gq,gq0
      real*8 kern_b,kern_r,kern_c,kern_s,kern_w,
     $     kerni_c(3),kerni_b(3),kernq_r,kerngi_b(3)
      real*8 s,sh,z,zc,soft,lls,epmin,dqedf,dqcdf,dsoft2,softg
      real*8 ephoton,egluon,epgmin,llgs,lli,llgi
      real*8 beti,llq,struci,glleep,glleem,lleps,colli,beta
      real*8 glleep2,glleem2
      real*8 oxp,oxm,dxp,dxm,xp,xm
      real*8 coul,coulsing,sp,kp2off,km2off,qp(0:3),qwp(0:3),qwm(0:3)
      real*8 bb,spk,kp2koff,km2koff,qpk(0:3),qwpk(0:3),qwmk(0:3)
      real*8 ps(7,0:3),pon(7,0:3),pout(7,0:3),pss(7,0:3)
      real*8 mif(6)
      real*8 pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2,
     $     mw,mw2,gw,mz,mz2,gz,mh,mh2,
     $     mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
      real*8 mv(3),mv2(3),gv(3),qcdfac,qcdfac2,q(6)
      real*8 ecut(7),scut(7,7),ccut(7,7),precomb(4),precombg(2)
      real*8 mbcmb,yfsv,mat2,mat2g
      real*8 alp1(ix),alp2(ix),alp3(ix),alp4(ix),alp5(ix),alpg(ix),
     $     alpq(ix),bet1(0:ix),bet2(0:ix),bet3(0:ix),bet4(0:ix),
     $     bet5(0:ix),betg(0:ix),betq(0:ix),vzi(3,ix),vzich(3),
     $     vzig(3,ix),vzigch(3),vziq(3,ix),vziqch(3),
     $     nui(8,ix),nuich(8),alptot,alpsum,
     $     alpm1(ix,0:20),alpm2(ix,0:20),alpm3(ix,0:20),alpm4(ix,0:20),
     $     alpm5(ix,0:20),alpgm(ix,0:20),alpqm(ix,0:20)
      real*8 gi(ix),gig(ix),gtot,gtotg,walpi1(ix),walpi1_opt(ix),
     $     walpig(ix),walpig_opt(ix),diffi1(0:20),diff1,
     $     diffig(0:20),diffg,
     $     walpiq(ix),walpiq_opt(ix),diffiq(0:20),diffq
      real*8 walpi2(ix),walpi2_opt(ix),
     $     walpi3(ix),walpi3_opt(ix),diffi2(0:20),diff2,
     $     diffi3(0:20),diff3,
     $     walpi4(ix),walpi4_opt(ix),diffi4(0:20),diff4,
     $     walpi5(ix),walpi5_opt(ix),diffi5(0:20),diff5
      real*8 conti_opt(5),w_opt(5),wmax(7),contig_opt,wg_opt,wgmax
      real*8 contiq_opt,wq_opt,wqmax,intq_opt(20),dintq_opt(20)
      real*8 int1_opt(20),dint1_opt(20),intg_opt(20),dintg_opt(20)
      real*8 int2_opt(20),dint2_opt(20),int3_opt(20),dint3_opt(20)
      real*8 int4_opt(20),dint4_opt(20),int5_opt(20),dint5_opt(20)
      real*8 conv,scale
      real*8 weight(maxe),pbeam(2,0:3),pe(7,0:3,maxe)
      real*8 weightborn,pborn(7,0:3)
      real*8 atotsq(maxe),a1sq(maxe),a2sq(maxe)
      real*8 atotsq4,a1sq4,a2sq4,atotsq5,a1sq5,a2sq5
c atgc
      real*8 gtgc(11,2)
      integer qatgc
      complex*16 cvf(-1:1,3,6),cvw(2)
      complex*16 mat(10,-1:1),matcmb(10,-1:1),matb(-1:1),fb(10,-1:1)
      character*6 fname(6),dfname(6)
      complex*16 ieps,spence

      common/par_integration/nndim,ihist,it,ncall2
      common/par_npart/npart
      common/par_n/ntot,ncut,ncut1_k,ncut2_k,ncut3_k,ncut4_k,
     $     ncut5_k,ncut6_k,ncut_r,ncutq_r
      common/itcount/iti,itig,itiq
      common/dpa_para/dpa
      common/chint/nch,nchg,nchq
      common/inicoll/icoll
      common/mapint/mapi,mapig,mapiq
      common/inint/ii,iig,iiq
      common/config_cuts/ccuts
      common/optimisation/opt,istep,nopt,iopt,istepg,istepq,noptg,ioptg
      common/rcoptions/qborn,qreal,qqcd,qbos,qferm,qsoft,qnf,qfast
      common/options/smc,sborn4,sborn5,sborng5,sisr,src,son,sqcdepem,
     $     ssigepem4,ssigepem5,ssigepemg5,scoultree,sunw,spaw,satgc
      common/contrib/qsigepem4,qsigepem5,qqcdepem
      common/processtype/type,nc,cc,sym,perm
      common/choice/dsdc,dsdcg
      common/par_config/p,sinv
      common/par_beam/b,bh
      common/paron_config/bon,pson,sinvo
      common/par_gen/rs
      common/par_dsdc/loglow,logup
      common/tcuts/deltas,deltac,deltags,deltagc
      common/ir/lambda,lambda2
      common/par_conti/conti,conti_tot,dconti_tot
      common/xxc/xc
      common/param/pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2,
     $     mw,mw2,gw,mz,mz2,gz,mh,mh2,
     $     mxe,mxe2,ml,ml2,mqp,mqp2,mqm,mqm2
      common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     *     q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
      common/M2flip/M2flip
      common/fident/mif
      common/par_conv/conv
      common/par_scale/scale
      common/cuts/ecut,scut,ccut,precomb,precombg,scuts,
     $     srecomb,srecombg
      common/mapvz/vzi,vzig,vziq
      common/numaps/nui
      common/apriori/alpm1,alpm2,alpm3,alpm4,alpm5,alpgm,alpqm
      common/maxweight/wmax,wgmax,wqmax
      common/sme/mat,matcmb,matb,fb,mbcmb
      common/event/weight,pbeam,pe,weightborn,pborn,nsubevent
      common/out/nout
      common/wswitches/wflag
      common/COLAMP/atotsq4,a1sq4,a2sq4
      common/COLAMPA/atotsq5,a1sq5,a2sq5
      common/colamps/atotsq,a1sq,a2sq
      common/atgc/gtgc,qatgc
      common/outi/iout
      save
c
c initializations
c
      do i=1,maxe
         weight(i)=0d0
         conti(i)=0d0
         atotsq(i)=0d0
         a1sq(i)=0d0
         a2sq(i)=0d0
         do j=1,7
            pe(j,0,i)=0d0
            pe(j,1,i)=0d0
            pe(j,2,i)=0d0
            pe(j,3,i)=0d0
         end do
      end do
      weightborn=0d0
      do i=0,3
         do j=1,7
            pborn(j,i)=0d0
         end do
      end do
      kern_b=0d0
      kern_w=0d0
      kern_s=0d0
      kern_c=0d0
      kern_r=0d0
      kernq_r=0d0
      kerni_c(1)=0d0
      kerni_c(2)=0d0
      kerni_c(3)=0d0
      kerni_b(1)=0d0
      kerni_b(2)=0d0
      kerni_b(3)=0d0
      kerngi_b(1)=0d0
      soft=0d0
      softg=0d0
      colli=0d0
      mat2=0d0
      mat2g=0d0
      icoll=0
      dpa=0
      ccuts(1)=0
      ccuts(2)=0
      ccuts(3)=0
      icuti1=1
      icuti2=1
c cm energy squared
      s=rs**2
c counters
      ntot(1)=ntot(1)+1
      if(ihist.eq.1)ntot(2)=ntot(2)+1
c random numbers for phase space generation
      do i=1,11
         x(i)=xv(i)
      end do
c variation of technical cuts
      if (dsdc.eq.1) then
c deltas value:
         deltas=10d0**((logup-loglow)*xv(12)+loglow)
      else if (dsdc.eq.2) then
c deltac value:
         deltac=10d0**((logup-loglow)*xv(12)+loglow)
      end if
      if (dsdcg.eq.1) then
c deltags value:
         deltags=10d0**((logup-loglow)*xv(12)+loglow)
      else if (dsdcg.eq.2) then
c deltagc value:
         deltagc=10d0**((logup-loglow)*xv(12)+loglow)
      end if
c cut on photon energy
      epmin=deltas*rs/2d0
      lls=dlog(2d0*epmin/lambda)
c cut on gluon energy
      epgmin=deltags*rs/2d0
      llgs=dlog(2d0*epgmin/lambda)
c logs for initial-state collinear singularity
      xc=xv(13)
      llq=dlog(scale**2/mif(1)**2)
      lleps=dlog(2d0*epmin/rs)
      beta=2d0*alpha0/pi*(dlog(scale**2/mif(1)**2)-1d0)
      ieps=dcmplx(0d0,1d-10)
c
c beam momenta:
c
      b(1,1)=0.d0
      b(2,1)=0.d0
      b(3,1)=rs/2d0
      b(4,1)=rs/2d0
      b(1,2)=0.d0
      b(2,2)=0.d0
      b(3,2)=-rs/2d0
      b(4,2)=rs/2d0
      do i=1,4
         bh(i,1)=b(i,1)
         bh(i,2)=b(i,2)
      end do

      if (sborn4.eq.0.and.sborn5.ne.0.and.
     $     (src.eq.0.or.src.eq.3)) goto 55
      if (src.eq.0.and.qqcd.eq.0.and.sborng5.ne.0) goto 68
c
c calculation of the 2->4 part
c
      npart=4

c setup of configuration 
c convention for generation of configuration:
c	1-> fermion3 (iso+: nu,u)
c       2-> fermion4 (anti-iso-: l+,anti-d)
c	3-> fermion5 (iso-: l-,d)
c       4-> fermion6 (anti-iso+: anti-nu,anti-u)
c initialization of four-momenta
      do i=1,npart
         do j=1,4
            p(j,i)=0d0
         end do
      end do

      if (src.eq.0.and.sborn4.ne.0.and.sisr.eq.1) goto 40
      if (src.eq.2.and.sisr.eq.1) goto 40
      if (src.eq.0.or.smc.eq.3) goto 15
c
c calculation of the virtual corrections in DPA
c
c self optimization of a-priori weights
c initialization
      if (iti(1).eq.1) then
         wmax(2)=0d0
         conti_opt(1)=0d0
         w_opt(1)=0d0
         istep(1)=0
         do i=1,nch(1)
            alp1(i)=alpm1(i,0)
            init1(i)=0
            walpi1(i)=0d0
         end do
         bet1(0)=0d0
         do i=1,nch(1)
            bet1(i)=0d0
            do j=1,i
               bet1(i)=bet1(i)+alp1(j)
            end do
         end do
      end if
      iti(1)=0
c optimization after 5000, ... events
      if (ntot(1).le.nopt.and.opt.eq.1) then
         if (ntot(1).eq.5000.or.ntot(1).eq.10000.or.
     $        ntot(1).eq.15000.or.ntot(1).eq.25000.or.
     $        mod(ntot(1),int(nopt/iopt)).eq.0) then
            diffi1(0)=0d0
            istep(1)=istep(1)+1
            alptot=0d0
            alpsum=0d0
            do i=1,nch(1)
               walpi1_opt(i)=dsqrt(walpi1(i)/ni1(i))
               alptot=alptot+alp1(i)*walpi1_opt(i)
               alpsum=alpsum+alp1(i)
               alpm1(i,istep(1))=alp1(i)
            end do
            do i=1,nch(1)
               if (i.eq.1) then
                  diff1=dabs(alptot-walpi1_opt(i))
               else
                  diff1=max(diff1,
     $                 dabs(alptot-walpi1_opt(i)))
               end if
            end do
            diffi1(istep(1))=diff1
c calculation of the average and the variance for each optimization:
            int1_opt(istep(1))=conti_opt(1)/ni1(1)
            dint1_opt(istep(1))=dsqrt(dabs(w_opt(1)/ni1(1)-
     $           (conti_opt(1)**2-w_opt(1))/(ni1(1)-1)/
     $           ni1(1))/ni1(1))
            if (iout.ne.0) then
               write(iout,*)' '
               write(iout,*)' DPA part (weight(2)):'
               write(iout,*)
     $              ' channel no.: a-p. weights after',istep(1)-1,
     $              ' optimizations:'
               do i=1,nch(1)
                  write(iout,900)i,': ',alpm1(i,istep(1))
               end do
c              write(iout,*)alpsum,diff1
               write(iout,*)' no. of optim., no. of events,'// 
     $              'integral estimate +/- stat. error:' 
               write(iout,1000)
     $              istep(1),',',ni1(1),',',
     $              int1_opt(istep(1)),' +/-',dint1_opt(istep(1))
            end if
            conti_opt(1)=0d0
            w_opt(1)=0d0
            alpsum=0d0
            do i=1,nch(1)
               init1(i)=0
               alp1(i)=alp1(i)*walpi1_opt(i)/alptot
               alpsum=alpsum+alp1(i)
            end do
c           if (iout.ne.0) write(iout,*)alpsum
            bet1(0)=0d0
            do i=1,nch(1)
               bet1(i)=0d0
               do j=1,i
                  bet1(i)=bet1(i)+alp1(j)
               end do
            end do
         end if
      end if
c
c generation of the configuration (event)
c random choice of channel
      call rans(rand)
      z=rand
      do i=1,nch(1)
         if (bet1(i-1).le.z.and.z.le.bet1(i)) ch=i
      end do
      do i=1,8
         mapich(i)=mapi(i,ch)
         nuich(i)=nui(i,ch)
      end do
      do i=1,5
         iich(i)=ii(i,ch)
      end do
      do i=1,3
         vzich(i)=vzi(i,ch)
      end do
c generation of four-momenta, wps: phase-space weight
      ccuts(1)=0
      ccuts(2)=0
      call phspgen_4(0,iich,mapich,vzich,nuich,s,x,wps,icut)

      if(icut.eq.1)then
         ncut2_k(1)=ncut2_k(1)+1
         if(ihist.eq.1)ncut2_k(2)=ncut2_k(2)+1
         conti(2)=0d0
         kern_w=0d0
         goto 10
      end if
c
c calculation of the invariants
c
      sinv(1,2)=2d0*dot_4(b(1,1),b(1,2))
      do j=1,npart
         sinv(1,j+2)=2d0*dot_4(b(1,1),p(1,j))
         sinv(2,j+2)=2d0*dot_4(b(1,2),p(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinv(i+2,j+2)=2d0*dot_4(p(1,i),p(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinv(j,i)=sinv(i,j)
         end do
      end do
c
c switch to Stefan's notation:
c
      do i=1,2
         ps(i,0)=b(4,i)
         ps(i,1)=b(1,i)
         ps(i,2)=b(2,i)
         ps(i,3)=b(3,i)
      end do
      do i=1,4
         ps(i+2,0)=p(4,i)
         ps(i+2,1)=p(1,i)
         ps(i+2,2)=p(2,i)
         ps(i+2,3)=p(3,i)
      end do
c
c calculation of four-momenta for nsubevent=2:
c
      do i=1,6
         pe(i,0,2)=ps(i,0)
         pe(i,1,2)=ps(i,1)
         pe(i,2,2)=ps(i,2)
         pe(i,3,2)=ps(i,3)
      end do
c
c impose cuts
c       
      call cut(pbeam,ps,npart,nocut)
      if (nocut.eq.1) icut=0
      if (nocut.eq.0) icut=1
      if(icut.eq.1)then
         ncut2_k(1)=ncut2_k(1)+1
         if(ihist.eq.1)ncut2_k(2)=ncut2_k(2)+1
         conti(2)=0d0
         kern_w=0d0
         goto 5
      end if 
c
c calculation of the local densities
c
      gtot=0d0
      do i=1,nch(1)
         do j=1,8
            mapich(j)=mapi(j,i)
            nuich(j)=nui(j,i)
         end do
         do j=1,5
            iich(j)=ii(j,i)
         end do
         do j=1,3
            vzich(j)=vzi(j,i)
         end do
         call phspgen_4(1,iich,mapich,vzich,nuich,s,x,wps,icut)
c         if (wps.gt.1d+15) write(iout,*)'wflag',i,(iich(j),j=1,5)
c     $        ,(mapich(j),j=1,8),(vzich(j),j=1,3)
         gi(i)=dabs(wps)
         gtot=gtot+alp1(i)*gi(i)
      end do
c
c switch to convention for calculating RCs
c in the case of MC processes
c
      do i=1,6
         pss(i,0)=ps(i,0)
         pss(i,1)=ps(i,1)
         pss(i,2)=ps(i,2)
         pss(i,3)=ps(i,3)
      end do
      if(cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3))then
         do i=0,3
            pss(4,i)=ps(6,i)
            pss(6,i)=ps(4,i)
         end do
      end if
c calculation of the on-shell four-momenta
      call oftoon(pss,pon,mw2,son)
c     
c switch back to my notation
c
      do i=1,2
         bon(4,i)=pon(i,0)
         bon(1,i)=pon(i,1)
         bon(2,i)=pon(i,2)
         bon(3,i)=pon(i,3)
      end do
      do i=1,4
         pson(4,i)=pon(i+2,0)
         pson(1,i)=pon(i+2,1)
         pson(2,i)=pon(i+2,2)
         pson(3,i)=pon(i+2,3)
      end do
c
c calculation of the on-shell invariants:
c
      sinvo(1,2)=2d0*dot_4(bon(1,1),bon(1,2))
      do j=1,npart
         sinvo(1,j+2)=2d0*dot_4(bon(1,1),pson(1,j))
         sinvo(2,j+2)=2d0*dot_4(bon(1,2),pson(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinvo(i+2,j+2)=2d0*dot_4(pson(1,i),pson(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinvo(j,i)=sinvo(i,j)
         end do
      end do
c
c calculation of the matrix element squared 
c to the (IR-finite) virtual corrections in DPA
c
c qsoft=3: the virtual photon YFS factor is subtracted. 
c qsoft=1 or 2: the soft, IR-singular photonic
c               logarithms are added (done in function M2(ps,pon)).
c no lambda-dependence in modified 'weak' factor ! 
c
      sqqcd=qqcd
      qqcd=0
      qatgc=0
      mat2=M2(pss,pon)
      if (qsoft.eq.3) then
         call softfac(2,1,q,lls,lambda2,yfsv)
         mat2=mat2-yfsv*mbcmb
      end if
      qqcd=sqqcd

      conti(2)=conv*mat2/(2d0*pi)**8/2d0/s/gtot
      kern_w=conti(2)
      wmax(2)=max(wmax(2),dabs(kern_w))
c       
c test of the phase-space element:
c      kern_w=kern_w/
c     $     ((pi/2d0)**3*s**2/6d0/2d0/(2d0*pi)**8/2d0/s*conv) 
c      conti(2)=kern_w
c
c  calculation of sub-contributions:
c
 5    if(ihist.eq.1)then
         conti_tot(2)=conti_tot(2)+wgt*conti(2)/dble(it)
         dconti_tot(2)=dconti_tot(2)+(wgt*conti(2))**2/dble(it)
      end if
c
c calculation of the variance for each channel and the total variance: 
c	
 10   if (ntot(1).le.nopt.and.opt.eq.1) then
         do i=1,nch(1)
            if (init1(i).eq.0) then
               ni1(i)=0
               walpi1(i)=0d0
               init1(i)=init1(i)+1
            end if
            ni1(i)=ni1(i)+1
            if (icut.eq.0) then
               walpi1(i)=walpi1(i)+gi(i)/gtot*conti(2)**2*wgt
            end if
         end do
         conti_opt(1)=conti_opt(1)+conti(2)
         w_opt(1)=w_opt(1)+conti(2)**2
      end if

 15   continue
      if (smc.eq.3.and.wflag(1).eq.0) goto 22 
      if (sborn4.eq.0.and.smc.ne.3) goto 22 
c
c smc=1: calculation of the Born cross section
c smc=3: calculation of the (Born+DPA+virt+soft photon) cross section
c
c self optimization of a-priori weights
c initialization
      if (iti(5).eq.1) then
         wmax(1)=0d0
         conti_opt(5)=0d0
         w_opt(5)=0d0
         istep(5)=0
         do i=1,nch(5)
            alp5(i)=alpm5(i,0)
            init5(i)=0
            walpi5(i)=0d0
         end do
         bet5(0)=0d0
         do i=1,nch(5)
            bet5(i)=0d0
            do j=1,i
               bet5(i)=bet5(i)+alp5(j)
            end do
         end do
      end if
      iti(5)=0
c optimization after 5000, ... events
      if (ntot(1).le.nopt.and.opt.eq.1) then
         if (ntot(1).eq.5000.or.ntot(1).eq.10000.or.
     $        ntot(1).eq.15000.or.ntot(1).eq.25000.or.
     $        mod(ntot(1),int(nopt/iopt)).eq.0) then
            diffi5(0)=0d0
            istep(5)=istep(5)+1
            alptot=0d0
            alpsum=0d0
            do i=1,nch(5)
               walpi5_opt(i)=dsqrt(walpi5(i)/ni5(i))
               alptot=alptot+alp5(i)*walpi5_opt(i)
               alpsum=alpsum+alp5(i)
               alpm5(i,istep(5))=alp5(i)
            end do
            do i=1,nch(5)
               if (i.eq.1) then
                  diff5=dabs(alptot-walpi5_opt(i))
               else
                  diff5=max(diff5,
     $                 dabs(alptot-walpi5_opt(i)))
               end if
            end do
            diffi5(istep(5))=diff5
c calculation of the average and the variance for each optimization:
            int5_opt(istep(5))=conti_opt(5)/ni5(1)
            dint5_opt(istep(5))=dsqrt(dabs(w_opt(5)/ni5(1)-
     $           (conti_opt(5)**2-w_opt(5))/(ni5(1)-1)/
     $           ni5(1))/ni5(1))
            if (iout.ne.0) then
               write(iout,*)' '
               if (smc.eq.3) then
                  write(iout,*)' Born+DPA+soft (weight(1)):'
               else
                  write(iout,*)' Born (weight(1)):'
               end if
               write(iout,*)
     $              ' channel no.: a-p. weights after',istep(5)-1,
     $              ' optimizations:'
               do i=1,nch(5)
                  write(iout,900)i,': ',alpm5(i,istep(5))
               end do
c              write(iout,*)alpsum,diff5
               write(iout,*)' no. of optim., no. of events,'// 
     $              'integral estimate +/- stat. error:' 
               write(iout,1000)
     $              istep(5),',',ni5(1),',',
     $              int5_opt(istep(5)),' +/-',dint5_opt(istep(5))
            end if
            conti_opt(5)=0d0
            w_opt(5)=0d0
            alpsum=0d0
            do i=1,nch(5)
               init5(i)=0
               alp5(i)=alp5(i)*walpi5_opt(i)/alptot
               alpsum=alpsum+alp5(i)
            end do
c            write(iout,*)alpsum
            bet5(0)=0d0
            do i=1,nch(5)
               bet5(i)=0d0
               do j=1,i
                  bet5(i)=bet5(i)+alp5(j)
               end do
            end do
         end if
      end if
c 
c generation of the configuration (event)
c random choice of channel
      call rans(rand)
      z=rand
      do i=1,nch(5)
         if (bet5(i-1).le.z.and.z.le.bet5(i)) ch=i
      end do
      do i=1,8
         mapich(i)=mapi(i,ch)
         nuich(i)=nui(i,ch)
      end do
      do i=1,5
         iich(i)=ii(i,ch)
      end do
      do i=1,3
         vzich(i)=vzi(i,ch)
      end do
c generation of the four-momenta
      if (sborn4.eq.3) dpa=1
      ccuts(1)=0
      ccuts(2)=0
c application of cuts already in the generation of the phase space:
      if (src.eq.0.and.sborn4.ne.0) then
         ccuts(1)=1
         ccuts(2)=1
      end if
      call phspgen_4(0,iich,mapich,vzich,nuich,s,x,wps,icut)

      if(icut.eq.1)then
         ncut1_k(1)=ncut1_k(1)+1
         if(ihist.eq.1)ncut1_k(2)=ncut1_k(2)+1
         conti(1)=0d0
         kern_b=0d0
         if (smc.eq.3) then
            conti(2)=0d0
            kern_w=0d0
            conti(3)=0d0
            kern_s=0d0
            conti(4)=0d0
            kerni_c(1)=0d0
            conti(10)=0d0
         end if
         goto 20
      end if
c
c calculation of the invariants
c
      sinv(1,2)=2d0*dot_4(b(1,1),b(1,2))
      do j=1,npart
         sinv(1,j+2)=2d0*dot_4(b(1,1),p(1,j))
         sinv(2,j+2)=2d0*dot_4(b(1,2),p(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinv(i+2,j+2)=2d0*dot_4(p(1,i),p(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinv(j,i)=sinv(i,j)
         end do
      end do
c
c switch to Stefan's notation
c
      do i=1,2
         ps(i,0)=b(4,i)
         ps(i,1)=b(1,i)
         ps(i,2)=b(2,i)
         ps(i,3)=b(3,i)
      end do
      do i=1,4
         ps(i+2,0)=p(4,i)
         ps(i+2,1)=p(1,i)
         ps(i+2,2)=p(2,i)
         ps(i+2,3)=p(3,i)
      end do
c
c calculation of the four-momenta for nsubevent=1:
c
      do i=1,6
         pe(i,0,1)=ps(i,0)
         pe(i,1,1)=ps(i,1)
         pe(i,2,1)=ps(i,2)
         pe(i,3,1)=ps(i,3)
         pborn(i,0)=ps(i,0)
         pborn(i,1)=ps(i,1)
         pborn(i,2)=ps(i,2)
         pborn(i,3)=ps(i,3)
      end do
c
c make cuts
c       
      call cut(pbeam,ps,npart,nocut)
      if (nocut.eq.1) icut=0
      if (nocut.eq.0) icut=1
      if(icut.eq.1)then
         ncut1_k(1)=ncut1_k(1)+1
         if(ihist.eq.1)ncut1_k(2)=ncut1_k(2)+1
         conti(1)=0d0
         kern_b=0d0
         if (smc.eq.3) then
            conti(2)=0d0
            kern_w=0d0
            conti(3)=0d0
            kern_s=0d0
            conti(4)=0d0
            kerni_c(1)=0d0
            conti(10)=0d0
         end if
         goto 18
      end if 
c
c calculation of the local densities
c
      gtot=0d0
      do i=1,nch(5)
         do j=1,8
            mapich(j)=mapi(j,i)
            nuich(j)=nui(j,i)
         end do
         do j=1,5
            iich(j)=ii(j,i)
         end do
         do j=1,3
            vzich(j)=vzi(j,i)
         end do
         call phspgen_4(1,iich,mapich,vzich,nuich,s,x,wps,icut)
c         if (wps.gt.1d+15) write(iout,*)'wflag',i,(iich(j),j=1,5)
c     $        ,(mapich(j),j=1,8),(vzich(j),j=1,3)
         gi(i)=dabs(wps)
         gtot=gtot+alp5(i)*gi(i)
      end do
c
c calculation of the Born-matrix element squared:
c  
      mat2=0d0
      if (sborn4.eq.1) then
c full off-shell Born
         qsigepem4=ssigepem4
         qqcdepem=sqcdepem
         qatgc=satgc
         call setprods(ps,dir,6)
         mat2=M2_epem_4f(ps)
         atotsq(1)=atotsq4
         a1sq(1)=a1sq4
         a2sq(1)=a2sq4
c include Coulomb singularity
         if (src.eq.0.and.scoultree.ne.0) then
c
c switch to convention for calculating RCs
c in the case of MC processes
c
            do i=1,6
               pss(i,0)=ps(i,0)
               pss(i,1)=ps(i,1)
               pss(i,2)=ps(i,2)
               pss(i,3)=ps(i,3)
            end do
            if(cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3))then
               do i=0,3
                  pss(4,i)=ps(6,i)
                  pss(6,i)=ps(4,i)
               end do
            end if
            do i=0,3
               qwp(i)=pss(3,i)+pss(4,i)
               qwm(i)=pss(5,i)+pss(6,i)
               qp(i)=qwp(i)+qwm(i)
            end do
            sp=qp(0)**2-(qp(1)**2+qp(2)**2+qp(3)**2)
            kp2off=qwp(0)**2-(qwp(1)**2+qwp(2)**2+qwp(3)**2)
            km2off=qwm(0)**2-(qwm(1)**2+qwm(2)**2+qwm(3)**2)
            bb=dsqrt((sp-kp2off-km2off)**2-4d0*kp2off*km2off)/sp
            coul=coulsing(sp,kp2off,km2off,1)
            mat2=mat2*(1d0+coul*(1d0-bb**2)**2)
            atotsq(1)=atotsq(1)*(1d0+coul*(1d0-bb**2)**2)
            a1sq(1)=a1sq(1)*(1d0+coul*(1d0-bb**2)**2)
            a2sq(1)=a2sq(1)*(1d0+coul*(1d0-bb**2)**2)
         end if
      else if (sborn4.eq.2.or.sborn4.eq.3) then
c sborn4=2:DPA Born with off-shell kinematics 
c (same Born as used in virtual corrections)
c sborn4=3:DPA Born with on-shell phase space
c switch to convention for calculating RCs
c in the case of MC processes:
         do i=1,6
            pss(i,0)=ps(i,0)
            pss(i,1)=ps(i,1)
            pss(i,2)=ps(i,2)
            pss(i,3)=ps(i,3)
         end do
         if(cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3))then
            do i=0,3
               pss(4,i)=ps(6,i)
               pss(6,i)=ps(4,i)
            end do
         end if
c calculation of the on-shell momenta
         call oftoon(pss,pon,mw2,son)
         call calcsme(pss,pon)
         mat2=mbcmb
         atotsq(1)=mbcmb
         a1sq(1)=mbcmb
         a2sq(1)=0d0
         if(cc.eq.1.and.nc.eq.1.and.sym.eq.0)then
            a1sq(1)=0d0
            a2sq(1)=mbcmb
         end if
         if (dpa.eq.1) mat2=mat2*(pi*mw*gw)**2
      end if
      kern_b=conv*mat2/(2d0*pi)**8/2d0/s/gtot
      conti(1)=kern_b
      wmax(1)=max(wmax(1),kern_b)
c       
c test of the phase space element:
c      kern_b=kern_b/
c     $     ((pi/2d0)**3*s**2/6d0/2d0/(2d0*pi)**8/2d0/s*conv) 

      if (smc.eq.3.and.src.eq.1) then
c
c switch to convention for calculating RCs
c in the case of MC processes
c
         do i=1,6
            pss(i,0)=ps(i,0)
            pss(i,1)=ps(i,1)
            pss(i,2)=ps(i,2)
            pss(i,3)=ps(i,3)
         end do
         if(cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3))then
            do i=0,3
               pss(4,i)=ps(6,i)
               pss(6,i)=ps(4,i)
            end do
         end if
c calculation of the on-shell four-momenta
         call oftoon(pss,pon,mw2,son)
c     
c switch back to my notation
c
         do i=1,2
            bon(4,i)=pon(i,0)
            bon(1,i)=pon(i,1)
            bon(2,i)=pon(i,2)
            bon(3,i)=pon(i,3)
         end do
         do i=1,4
            pson(4,i)=pon(i+2,0)
            pson(1,i)=pon(i+2,1)
            pson(2,i)=pon(i+2,2)
            pson(3,i)=pon(i+2,3)
         end do
c
c calculation of the on-shell invariants:
c
         sinvo(1,2)=2d0*dot_4(bon(1,1),bon(1,2))
         do j=1,npart
            sinvo(1,j+2)=2d0*dot_4(bon(1,1),pson(1,j))
            sinvo(2,j+2)=2d0*dot_4(bon(1,2),pson(1,j))
         end do	  
         do i=1,npart
            do j=i,npart
               sinvo(i+2,j+2)=2d0*dot_4(pson(1,i),pson(1,j))
            end do
         end do
         do i=1,npart+2
            do j=i+1,npart+2
               sinvo(j,i)=sinvo(i,j)
            end do
         end do
c
c calculation of the matrix element squared 
c to the (IR-finite) virtual corrections in DPA
c
c qsoft=3: the virtual photon YFS factor is subtracted. 
c qsoft=1 or 2: the soft, IR-singular photonic
c               logarithms are added (done in function M2(ps,pon)).
c no lambda-dependence in modified 'weak' factor ! 
c
         sqqcd=qqcd
         qqcd=0
         qatgc=0
         mat2=M2(pss,pon)
         if (qsoft.eq.3) then
            call softfac(2,1,q,lls,lambda2,yfsv)
            mat2=mat2-yfsv*mbcmb
         end if
         qqcd=sqqcd

         conti(2)=conv*mat2/(2d0*pi)**8/2d0/s/gtot
         kern_w=conti(2)
         atotsq(2)=mat2
         a1sq(2)=mat2
         a2sq(2)=0d0
         if(cc.eq.1.and.nc.eq.1.and.sym.eq.0)then
            a1sq(2)=0d0
            a2sq(2)=mat2
         end if
         wmax(2)=max(wmax(2),dabs(kern_w))
c
c calculation of the Born-matrix element squared
c photonic corrections: always the CC11 class of diagrams is used
c qqcd=1: for the virt+soft gluon part the CC03 Born is used
c qqcd=3: for the virt+soft gluon part the CC11 Born is used
c
         qsigepem4=5
         qqcdepem=0
         qatgc=0
         call setprods(ps,dir,6)
         mat2=M2_epem_4f(ps)
         kerni_b(1)=conv*mat2/(2d0*pi)**8/2d0/s/gtot
         conti(10)=kerni_b(1)
         if (qqcd.eq.1.or.qqcd.eq.3) then
            if (qqcd.eq.3) mat2g=mat2
            if (qqcd.eq.1) then
               qsigepem4=1
               mat2g=M2_epem_4f(ps)
            endif
            kerngi_b(1)=conv*mat2g/(2d0*pi)**8/2d0/s/gtot
         end if
c
c remainder of the soft+virtual singularity a la YFS (off-shell):
c sn=1: only real, sn=2: only virtual, sn=3: real+virtual
c
c photon part:
         if (qsoft.eq.3) call softfac(3,0,q,lls,lambda2,soft)
c gluon part:
         if (qqcd.eq.1.or.qqcd.eq.3) 
     $        call softgfac(3,0,q,llgs,lambda2,softg)
c
c remainder of the soft photon factor when qsoft=1 or 2 (off-shell):
c
         if (qsoft.eq.1.or.qsoft.eq.2) soft=dsoft2(pss)
c
c subtract LL O(alpha) terms (multiplied with CC11 Born, qatgc=0) 
c
         if (sisr.ne.0) soft=soft-beta*(lleps+3d0/4d0)

         kern_s=kerni_b(1)*soft+kerngi_b(1)*softg
c
c inclusion of LL first, second and third-order virtual+soft ISR
c (multiplied with 'full' Born)
         if (sisr.ne.0)
     $        kern_s=kern_s+kern_b*
     $        (beta*(lleps+3d0/4d0)+
     $        beta**2/2d0*(lleps**2+3d0/2d0*lleps+9d0/16d0-pi**2/12d0)+
     $        beta**3/6d0*(27d0/64d0-3d0*pi**2/16d0+
     $        1.2020569031595942854d0/2d0+lleps*(27d0/16d0-pi**2/4d0)+
     $        9d0/4d0*lleps**2+lleps**3))

         conti(3)=kern_s
c
c final-state collinear singularity,
c analytically integrated over energy fraction z
c
         dqedf=0d0
         dqcdf=0d0
         do i=1,4
c photon radiation
            if (q(i+2).ne.0d0) then
               lli=dlog(2d0*deltac*p(4,i)**2/mif(i+2)**2)
               dqedf=dqedf+q(i+2)**2*
     $              (-(3d0/4d0+dlog(epmin/p(4,i)))*(lli-1d0)
     $              +3d0/2d0-pi**2/3d0)
c gluon radiation
               if (q(i+2).ne.-1d0.and.(qqcd.eq.1.or.qqcd.eq.3)) then
                  llgi=dlog(2d0*deltagc*p(4,i)**2/mif(i+2)**2)
                  dqcdf=dqcdf+
     $                 (-(3d0/4d0+dlog(epgmin/p(4,i)))*(llgi-1d0)
     $                 +3d0/2d0-pi**2/3d0)
               end if
            end if
         end do

         kerni_c(1)=kerni_b(1)*alpha0/pi*dqedf+
     $        kerngi_b(1)*alphas/pi*4d0/3d0*dqcdf
         conti(4)=kerni_c(1)
         atotsq(3)=atotsq4*(soft+alpha0/pi*dqedf)
         a1sq(3)=a1sq4*(soft+alpha0/pi*dqedf)
         a2sq(3)=a2sq4*(soft+alpha0/pi*dqedf)
         if (sisr.ne.0) then
            atotsq(3)=atotsq(3)+atotsq(1)*
     $        (beta*(lleps+3d0/4d0)+
     $        beta**2/2d0*(lleps**2+3d0/2d0*lleps+9d0/16d0-pi**2/12d0))
            a1sq(3)=a1sq(3)+a1sq(1)*
     $        (beta*(lleps+3d0/4d0)+
     $        beta**2/2d0*(lleps**2+3d0/2d0*lleps+9d0/16d0-pi**2/12d0))
            a2sq(3)=a2sq(3)+a2sq(1)*
     $        (beta*(lleps+3d0/4d0)+
     $        beta**2/2d0*(lleps**2+3d0/2d0*lleps+9d0/16d0-pi**2/12d0))
         end if
         wmax(3)=max(wmax(3),dabs(conti(3)+conti(4)))
      end if
c
c  calculation of sub-contributions:
c
 18   if(ihist.eq.1)then
         conti_tot(1)=conti_tot(1)+wgt*conti(1)/dble(It)
         dconti_tot(1)=dconti_tot(1)+(wgt*conti(1))**2/dble(it)
         if (smc.eq.3) then
            conti_tot(2)=conti_tot(2)+wgt*conti(2)/dble(It)
            dconti_tot(2)=dconti_tot(2)+(wgt*conti(2))**2/dble(it)
            conti_tot(3)=conti_tot(3)+wgt*(conti(3)+conti(4))/dble(It)
            dconti_tot(3)=dconti_tot(3)+
     $           (wgt*(conti(3)+conti(4)))**2/dble(it)
            conti_tot(10)=conti_tot(10)+wgt*conti(10)/dble(It)
            dconti_tot(10)=dconti_tot(10)+(wgt*conti(10))**2/dble(it)
         end if
      end if
c
c calculation of the variance for each channel and the total variance: 
c	
 20   if (ntot(1).le.nopt.and.opt.eq.1) then
         do i=1,nch(5)
            if (init5(i).eq.0) then
               ni5(i)=0
               walpi5(i)=0d0
               init5(i)=init5(i)+1
            end if
            ni5(i)=ni5(i)+1
            if (icut.eq.0) then
               if(smc.eq.3) then
                  walpi5(i)=walpi5(i)+gi(i)/gtot*(conti(1)+conti(2)+
     $                 conti(3)+conti(4))**2*wgt
               else
                  walpi5(i)=walpi5(i)+gi(i)/gtot*conti(1)**2*wgt
               end if
            end if
         end do
         if(smc.eq.3) then
            conti_opt(5)=conti_opt(5)+conti(1)+conti(2)+
     $           conti(3)+conti(4)
            w_opt(5)=w_opt(5)+(conti(1)+conti(2)+
     $           conti(3)+conti(4))**2
         else
            conti_opt(5)=conti_opt(5)+conti(1)
            w_opt(5)=w_opt(5)+conti(1)**2
         end if
      end if
 22   continue
      if (src.eq.0) goto 40
      if (smc.eq.3) goto 35 
c
c calculation of the soft+virtual+final-state collinear 
c photon (and gluon) contribution  
c
c self optimization of a-priori weights
c initialization
      if (iti(2).eq.1) then
         wmax(3)=0d0
         conti_opt(2)=0d0
         w_opt(2)=0d0
         istep(2)=0
         do i=1,nch(2)
            alp2(i)=alpm2(i,0)
            init2(i)=0
            walpi2(i)=0d0
         end do
         bet2(0)=0d0
         do i=1,nch(2)
            bet2(i)=0d0
            do j=1,i
               bet2(i)=bet2(i)+alp2(j)
            end do
         end do
      end if
      iti(2)=0

      if (ntot(1).le.nopt.and.opt.eq.1) then
         if (ntot(1).eq.5000.or.ntot(1).eq.10000.or.
     $        ntot(1).eq.15000.or.ntot(1).eq.25000.or.
     $        mod(ntot(1),int(nopt/iopt)).eq.0) then
            diffi2(0)=0d0
            istep(2)=istep(2)+1
            alptot=0d0
            alpsum=0d0
            do i=1,nch(2)
               walpi2_opt(i)=dsqrt(walpi2(i)/ni2(i))
               alptot=alptot+alp2(i)*walpi2_opt(i)
               alpsum=alpsum+alp2(i)
               alpm2(i,istep(2))=alp2(i)
            end do
            do i=1,nch(2)
               if (i.eq.1) then
                  diff2=dabs(alptot-walpi2_opt(i))
               else
                  diff2=max(diff2,
     $                 dabs(alptot-walpi2_opt(i)))
               end if
            end do
            diffi2(istep(2))=diff2
c calculation of the average and the variance for each optimization:
            int2_opt(istep(2))=conti_opt(2)/ni2(1)
            dint2_opt(istep(2))=dsqrt(dabs(w_opt(2)/ni2(1)-
     $           (conti_opt(2)**2-w_opt(2))/(ni2(1)-1)/
     $           ni2(1))/ni2(1))
            if (iout.ne.0) then
               write(iout,*)' '
               write(iout,*)' v+s+final-state coll. (weight(3)):'
               write(iout,*)
     $              ' channel no.: a-p. weights after',istep(2)-1,
     $              ' optimizations:'
               do i=1,nch(2)
                  write(iout,900)i,': ',alpm2(i,istep(2))
               end do
c              write(iout,*)alpsum,diff2
               write(iout,*)' no. of optim., no. of events,'// 
     $              'integral estimate +/- stat. error:' 
               write(iout,1000)
     $              istep(2),',',ni2(1),',',
     $              int2_opt(istep(2)),' +/-',dint2_opt(istep(2))
            end if
            conti_opt(2)=0d0
            w_opt(2)=0d0
            alpsum=0d0
            do i=1,nch(2)
               init2(i)=0
               alp2(i)=alp2(i)*walpi2_opt(i)/alptot
               alpsum=alpsum+alp2(i)
            end do
c            write(iout,*)alpsum
            bet2(0)=0d0
            do i=1,nch(2)
               bet2(i)=0d0
               do j=1,i
                  bet2(i)=bet2(i)+alp2(j)
               end do
            end do
         end if
      end if
c 
c generation of the configuration (event)
c random choice of channel:
c
      call rans(rand)
      z=rand
      do i=1,nch(2)
         if (bet2(i-1).le.z.and.z.le.bet2(i)) ch=i
      end do
      do i=1,8
         mapich(i)=mapi(i,ch)
         nuich(i)=nui(i,ch)
      end do
      do i=1,5
         iich(i)=ii(i,ch)
      end do
      do i=1,3
         vzich(i)=vzi(i,ch)
      end do
c generation of the four-momenta
      dpa=0
      ccuts(1)=0
      ccuts(2)=0
      call phspgen_4(0,iich,mapich,vzich,nuich,s,x,wps,icut)

      if(icut.eq.1)then
         ncut3_k(1)=ncut3_k(1)+1
         if(ihist.eq.1)ncut3_k(2)=ncut3_k(2)+1
         do i=3,4
            conti(i)=0d0
         end do
         conti(10)=0d0
         kerni_b(1)=0d0
         kerni_c(1)=0d0
         kern_s=0d0
         goto 28
      end if
c
c calculation of the invariants
c
      sinv(1,2)=2d0*dot_4(b(1,1),b(1,2))
      do j=1,npart
         sinv(1,j+2)=2d0*dot_4(b(1,1),p(1,j))
         sinv(2,j+2)=2d0*dot_4(b(1,2),p(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinv(i+2,j+2)=2d0*dot_4(p(1,i),p(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinv(j,i)=sinv(i,j)
         end do
      end do
c
c switch to Stefan's notation:
c
      do i=1,2
         ps(i,0)=b(4,i)
         ps(i,1)=b(1,i)
         ps(i,2)=b(2,i)
         ps(i,3)=b(3,i)
      end do
      do i=1,4
         ps(i+2,0)=p(4,i)
         ps(i+2,1)=p(1,i)
         ps(i+2,2)=p(2,i)
         ps(i+2,3)=p(3,i)
      end do
c
c calculation of the four-momenta for nsubevent=3:
c
      do i=1,6
         pe(i,0,3)=ps(i,0)
         pe(i,1,3)=ps(i,1)
         pe(i,2,3)=ps(i,2)
         pe(i,3,3)=ps(i,3)
      end do
c
c make cuts
c       
      call cut(pbeam,ps,npart,nocut)
      if (nocut.eq.1) icut=0
      if (nocut.eq.0) icut=1
      if(icut.eq.1)then
         ncut3_k(1)=ncut3_k(1)+1
         if(ihist.eq.1)ncut3_k(2)=ncut3_k(2)+1
         do i=3,4
            conti(i)=0d0
         end do
         conti(10)=0d0
         kerni_b(1)=0d0
         kerni_c(1)=0d0
         kern_s=0d0
         goto 25
      end if 
c
c calculation of the local densities
c
      gtot=0d0
      do i=1,nch(2)
         do j=1,8
            mapich(j)=mapi(j,i)
            nuich(j)=nui(j,i)
         end do
         do j=1,5
            iich(j)=ii(j,i)
         end do
         do j=1,3
            vzich(j)=vzi(j,i)
         end do
         call phspgen_4(1,iich,mapich,vzich,nuich,s,x,wps,icut)
c         if (wps.gt.1d+15) write(iout,*)'wflag',i,(iich(j),j=1,5)
c     $        ,(mapich(j),j=1,8),(vzich(j),j=1,3)
         gi(i)=dabs(wps)
         gtot=gtot+alp2(i)*gi(i)
      end do
c
c calculation of the Born-matrix element squared
c photonic corrections: always the CC11 class of diagrams is used
c qqcd=1: for the virt+soft gluon part the CC03 Born is used
c qqcd=3: for the virt+soft gluon part the CC11 Born is used
c
      qsigepem4=5
      qqcdepem=0
      qatgc=0
      call setprods(ps,dir,6)
      mat2=M2_epem_4f(ps)
      kerni_b(1)=conv*mat2/(2d0*pi)**8/2d0/s/gtot
      conti(10)=kerni_b(1)
      if (qqcd.eq.1.or.qqcd.eq.3) then
         if (qqcd.eq.3) mat2g=mat2
         if (qqcd.eq.1) then
            qsigepem4=1
            call setprods(ps,dir,6)
            mat2g=M2_epem_4f(ps)
         endif
         kerngi_b(1)=conv*mat2g/(2d0*pi)**8/2d0/s/gtot
      end if
c
c remainder of the soft+virtual singularity a la YFS (off-shell):
c sn=1: only real, sn=2: only virtual, sn=3: real+virtual
c
c photon part:
      if (qsoft.eq.3) call softfac(3,0,q,lls,lambda2,soft)
c gluon part:
      if (qqcd.eq.1.or.qqcd.eq.3) 
     $     call softgfac(3,0,q,llgs,lambda2,softg)
c
c remainder of the soft photon factor when qsoft=1 or 2 (off-shell):
c
      if (qsoft.eq.1.or.qsoft.eq.2) then
         do i=1,6
            pss(i,0)=ps(i,0)
            pss(i,1)=ps(i,1)
            pss(i,2)=ps(i,2)
            pss(i,3)=ps(i,3)
         end do
         if(cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3))then
            do i=0,3
               pss(4,i)=ps(6,i)
               pss(6,i)=ps(4,i)
            end do
         end if
         soft=dsoft2(pss)
      end if
c
c subtraction of 1-loop term when 
c exponentiated ISR is taken into account
c
      if (sisr.ne.0) soft=soft-alpha0/pi*(llq-1d0)*(2d0*lleps+3d0/2d0)

      kern_s=kerni_b(1)*soft+kerngi_b(1)*softg
      conti(3)=kern_s
c
c final-state collinear singularity,
c analytically integrated over energy fraction z
c
      dqedf=0d0
      dqcdf=0d0
      do i=1,4
c photon radiation
         if (q(i+2).ne.0d0) then
            lli=dlog(2d0*deltac*p(4,i)**2/mif(i+2)**2)
            dqedf=dqedf+q(i+2)**2*
     $           (-(3d0/4d0+dlog(epmin/p(4,i)))*(lli-1d0)
     $           +3d0/2d0-pi**2/3d0)
c gluon radiation
            if (q(i+2).ne.-1d0.and.(qqcd.eq.1.or.qqcd.eq.3)) then
               llgi=dlog(2d0*deltagc*p(4,i)**2/mif(i+2)**2)
               dqcdf=dqcdf+
     $              (-(3d0/4d0+dlog(epgmin/p(4,i)))*(llgi-1d0)
     $              +3d0/2d0-pi**2/3d0)
            end if
         end if
      end do

      kerni_c(1)=kerni_b(1)*alpha0/pi*dqedf+
     $     kerngi_b(1)*alphas/pi*4d0/3d0*dqcdf
      conti(4)=kerni_c(1)
      wmax(3)=max(wmax(3),dabs(conti(3)+conti(4)))
c
c  calculation of sub-contributions:
c
 25   if(ihist.eq.1)then
         conti_tot(10)=conti_tot(10)+wgt*conti(10)/dble(It)
         dconti_tot(10)=dconti_tot(10)+(wgt*conti(10))**2/dble(it)
         conti_tot(3)=conti_tot(3)+wgt*(conti(3)+conti(4))/dble(It)
         dconti_tot(3)=dconti_tot(3)+
     $        (wgt*(conti(3)+conti(4)))**2/dble(it)
      end if
c
c calculation of the variance for each channel and the total variance: 
c	
 28   if (ntot(1).le.nopt.and.opt.eq.1) then
         do i=1,nch(2)
            if (init2(i).eq.0) then
               ni2(i)=0
               walpi2(i)=0d0
               init2(i)=init2(i)+1
            end if
            ni2(i)=ni2(i)+1
            if (icut.eq.0) then
               walpi2(i)=walpi2(i)+gi(i)/gtot*
     $              (conti(3)+conti(4))**2*wgt
            end if
         end do
         conti_opt(2)=conti_opt(2)+conti(3)+conti(4)
         w_opt(2)=w_opt(2)+(conti(3)+conti(4))**2
      end if
 35   continue
      if (smc.eq.3.and.wflag(4).eq.0.and.wflag(5).eq.0) goto 40  
c
c calculation of the collinear initial-state photon contribution
c
c self optimization of a-priori weights
c initialization
      if (iti(3).eq.1) then
         wmax(4)=0d0
         wmax(5)=0d0
         conti_opt(3)=0d0
         w_opt(3)=0d0
         istep(3)=0
         do i=1,nch(3)
            alp3(i)=alpm3(i,0)
            init3(i)=0
            walpi3(i)=0d0
         end do
         bet3(0)=0d0
         do i=1,nch(3)
            bet3(i)=0d0
            do j=1,i
               bet3(i)=bet3(i)+alp3(j)
            end do
         end do
      end if
      iti(3)=0
c optimization after 5000, ... events
      if (ntot(1).le.nopt.and.opt.eq.1) then
         if (ntot(1).eq.5000.or.ntot(1).eq.10000.or.
     $        ntot(1).eq.15000.or.ntot(1).eq.25000.or.
     $        mod(ntot(1),int(nopt/iopt)).eq.0) then
            diffi3(0)=0d0
            istep(3)=istep(3)+1
            alptot=0d0
            alpsum=0d0
            do i=1,nch(3)
               walpi3_opt(i)=dsqrt(walpi3(i)/ni3(i))
               alptot=alptot+alp3(i)*walpi3_opt(i)
               alpsum=alpsum+alp3(i)
               alpm3(i,istep(3))=alp3(i)
            end do
            do i=1,nch(3)
               if (i.eq.1) then
                  diff3=dabs(alptot-walpi3_opt(i))
               else
                  diff3=max(diff3,
     $                 dabs(alptot-walpi3_opt(i)))
               end if
            end do
            diffi3(istep(3))=diff3
c calculation of the average and the variance for each optimization:
            int3_opt(istep(3))=conti_opt(3)/ni3(1)
            dint3_opt(istep(3))=dsqrt(dabs(w_opt(3)/ni3(1)-
     $           (conti_opt(3)**2-w_opt(3))/(ni3(1)-1)/
     $           ni3(1))/ni3(1))
            if (iout.ne.0) then
               write(iout,*)' '
               write(iout,*)
     $              ' O(alpha) initial-state coll. (weight(4,5)):'
               write(iout,*)
     $              ' channel no.: a-p. weights after',istep(3)-1,
     $              ' optimizations:'
               do i=1,nch(3)
                  write(iout,900)i,': ',alpm3(i,istep(3))
               end do
c              write(iout,*)alpsum,diff3
               write(iout,*)' no. of optim., no. of events,'// 
     $              'integral estimate +/- stat. error:' 
               write(iout,1000)
     $              istep(3),',',ni3(1),',',
     $              int3_opt(istep(3)),' +/-',dint3_opt(istep(3))
            end if
            conti_opt(3)=0d0
            w_opt(3)=0d0
            alpsum=0d0
            do i=1,nch(3)
               init3(i)=0
               alp3(i)=alp3(i)*walpi3_opt(i)/alptot
               alpsum=alpsum+alp3(i)
            end do
c            write(iout,*)alpsum
            bet3(0)=0d0
            do i=1,nch(3)
               bet3(i)=0d0
               do j=1,i
                  bet3(i)=bet3(i)+alp3(j)
               end do
            end do
         end if
      end if
      if (smc.eq.3.and.wflag(4).eq.0) goto 30 
c
c radiation from particle 1 (positron)
c generation of the configuration (event)
c random choice of channel:
      call rans(rand)
      z=rand
      do i=1,nch(3)
         if (bet3(i-1).le.z.and.z.le.bet3(i)) ch=i
      end do
      do i=1,8
         mapich(i)=mapi(i,ch)
         nuich(i)=nui(i,ch)
      end do
      do i=1,5
         iich(i)=ii(i,ch)
      end do
      do i=1,3
         vzich(i)=vzi(i,ch)
      end do
c generation of the four-momenta      
      icoll=1
      dpa=0
      ecut(7)=epmin
      ccuts(1)=0
      ccuts(2)=0
      call phspgen_4(0,iich,mapich,vzich,nuich,s,x,wps,icuti1)

      if(icuti1.eq.1)then
         ncut4_k(1)=ncut4_k(1)+1
         if(Ihist.eq.1)ncut4_k(2)=ncut4_k(2)+1
         conti(5)=0d0
         kerni_c(2)=0d0
         goto 30
      end if
      sh=2d0*dot_4(b(1,1),b(1,2))
      zc=sh/s
c
c boost back to LAB frame (along positive z-axis), radiation from e+
c
      gq0=(sh+s)/2d0/dsqrt(sh)/rs
      gq=dabs(sh-s)/2d0/dsqrt(sh)/rs
      do i=1,2
         call boost_z(gq0,gq,b(4,i),b(3,i))
      end do
      do i=1,4
         call boost_z(gq0,gq,p(4,i),p(3,i))
      end do
c
c calculation of the invariants
c
      sinv(1,2)=2d0*dot_4(b(1,1),b(1,2))
      do j=1,npart
         sinv(1,j+2)=2d0*dot_4(b(1,1),p(1,j))
         sinv(2,j+2)=2d0*dot_4(b(1,2),p(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinv(i+2,j+2)=2d0*dot_4(p(1,i),p(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinv(j,i)=sinv(i,j)
         end do
      end do
c
c switch to Stefan's notation:
c
      do i=1,2
         ps(i,0)=b(4,i)
         ps(i,1)=b(1,i)
         ps(i,2)=b(2,i)
         ps(i,3)=b(3,i)
      end do
      do i=1,4
         ps(i+2,0)=p(4,i)
         ps(i+2,1)=p(1,i)
         ps(i+2,2)=p(2,i)
         ps(i+2,3)=p(3,i)
      end do
c
c calculation of the momenta for nsubevent=4:
c
      do i=1,6
         pe(i,0,4)=ps(i,0)
         pe(i,1,4)=ps(i,1)
         pe(i,2,4)=ps(i,2)
         pe(i,3,4)=ps(i,3)
      end do
c
c make cuts:
c       
      call cut(pbeam,ps,npart,nocut)
      if (nocut.eq.1) icuti1=0
      if (nocut.eq.0) icuti1=1
      if(icuti1.eq.1)then
         ncut4_k(1)=ncut4_k(1)+1
         if(Ihist.eq.1)ncut4_k(2)=ncut4_k(2)+1
         conti(5)=0d0
         kerni_c(2)=0d0
         goto 29
      end if 
c
c calculation of the local densities:
c
      gtot=0d0
      do i=1,nch(3)
         do j=1,8
            mapich(j)=mapi(j,i)
            nuich(j)=nui(j,i)
         end do
         do j=1,5
            iich(j)=ii(j,i)
         end do
         do j=1,3
            vzich(j)=vzi(j,i)
         end do
         call phspgen_4(1,iich,mapich,vzich,nuich,s,x,wps,icuti1)
c         if (wps.gt.1d+15) write(iout,*)'wflag',i,(iich(j),j=1,5)
c     $        ,(mapich(j),j=1,8),(vzich(j),j=1,3)
         gi(i)=dabs(wps)
         gtot=gtot+alp3(i)*gi(i)
      end do
c
c calculation of the Born-matrix element squared
c always CC11 class of diagrams is used ! 
c
      qsigepem4=5
      qqcdepem=0
      qatgc=0
      call setprods(ps,dir,6)
      mat2=M2_epem_4f(ps)
      kerni_b(2)=conv*mat2/(2d0*pi)**8/2d0/sh/gtot/s
c       
c test of the phase space element:
c      kerni_b(2)=kerni_b(2)/
c     $     ((pi/2d0)**3*sh**2/6d0/2d0/(2d0*pi)**8/2d0/sh*conv)
c
c initial-state collinear photon factor
      colli=q(1)**2*alpha0/pi*
     $     (mat2*(1d0+zc**2)/(1d0-zc)*
     $     (dlog(s/mif(1)**2*deltac/2d0)-1d0)+M2flip(1)*(1d0-zc))/2d0

c subtract 1-loop term when exponentiated ISR is taken into account

      if (sisr.ne.0.and.smc.ne.3) colli=colli-q(1)**2*alpha0/pi*mat2*
     $     (llq-1d0)*(1d0+zc**2)/(1d0-zc)/2d0
      if (smc.eq.3.and.sisr.ne.0) 
     $     colli=colli-mat2*beta/4d0*(1d0+zc**2)/(1d0-zc)
c
c inclusion of LL first, second and third-order collinear ISR:
c (with 'full' Born)
c
      if (smc.eq.3.and.sisr.ne.0) then
         qsigepem4=ssigepem4
         qqcdepem=sqcdepem
         qatgc=satgc
         mat2=M2_epem_4f(ps)
         colli=colli+mat2*(beta/4d0*(1d0+zc**2)/(1d0-zc)+
     $        beta**2/8d0*((1d0+zc**2)/(1d0-zc)*(dlog(1d0-zc)+
     $        3d0/2d0-dlog(zc)/2d0+lleps)+
     $        (1d0+zc)/2d0*(dlog(zc)/2d0-1d0)+zc)+
     $        beta**3/32d0*((1d0+zc**2)/(1d0-zc)*(dlog(1d0-zc)**2-
     $        dlog(zc)*dlog(1d0-zc)+dlog(zc)**2/6d0+
     $        (1d0+zc/2d0+lleps)*(2d0*dlog(1d0-zc)-dlog(zc))+
     $        2d0+zc/4d0-pi**2/3d0+3d0*lleps+lleps**2)-3d0/2d0+
     $        (zc-1d0)*lleps+(1d0+zc)*(pi**2/12d0+(zc+3d0)/4d0+
     $        zc*dlog(1-zc)-dlog(zc)**2/8d0+(1d0-zc)*dlog(zc)/2d0-
     $        dreal(spence(zc+ieps))/2d0+lleps*dlog(zc)/2d0)))
      end if

      kerni_c(2)=conv*colli/(2d0*pi)**8/2d0/sh/gtot/s
      conti(5)=kerni_c(2)
      atotsq(4)=atotsq4
      a1sq(4)=a1sq4
      a2sq(4)=a2sq4
      wmax(4)=max(wmax(4),dabs(kerni_c(2)))
c
c  calculation of sub-contributions:
c
 29   if(ihist.eq.1)then
         conti_tot(4)=conti_tot(4)+wgt*conti(5)/dble(It)
         dconti_tot(4)=dconti_tot(4)+(wgt*conti(5))**2/dble(it)
      end if

 30   continue
      if (smc.eq.3.and.wflag(5).eq.0) goto 32
c
c radiation from particle 2 (electron)
c generation of the configuration (event)
c random choice of channel
      call rans(rand)
      z=rand
      do i=1,nch(3)
         if (bet3(i-1).le.z.and.z.le.bet3(i)) ch=i
      end do
      do i=1,8
         mapich(i)=mapi(i,ch)
         nuich(i)=nui(i,ch)
      end do
      do i=1,5
         iich(i)=ii(i,ch)
      end do
      do i=1,3
         vzich(i)=vzi(i,ch)
      end do
c generation of the four-momenta
      icoll=1
      dpa=0
      ecut(7)=epmin
      ccuts(1)=0
      ccuts(2)=0
      call phspgen_4(0,iich,mapich,vzich,nuich,s,x,wps,icuti2)

      if(icuti2.eq.1)then
         ncut5_k(1)=ncut5_k(1)+1
         if(Ihist.eq.1)ncut5_k(2)=ncut5_k(2)+1
         conti(6)=0d0
         kerni_c(3)=0d0
         goto 32
      end if
      sh=2d0*dot_4(b(1,1),b(1,2))
      zc=sh/s
c
c boost back to LAB frame (along negative z-axis), radiation from e-
c
      gq0=(sh+s)/2d0/dsqrt(sh)/rs
      gq=-dabs(sh-s)/2d0/dsqrt(sh)/rs
      do i=1,2
         call boost_z(gq0,gq,b(4,i),b(3,i))
      end do
      do i=1,4
         call boost_z(gq0,gq,p(4,i),p(3,i))
      end do
c
c calculation of the invariants:
c
      sinv(1,2)=2d0*dot_4(b(1,1),b(1,2))
      do j=1,npart
         sinv(1,j+2)=2d0*dot_4(b(1,1),p(1,j))
         sinv(2,j+2)=2d0*dot_4(b(1,2),p(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinv(i+2,j+2)=2d0*dot_4(p(1,i),p(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinv(j,i)=sinv(i,j)
         end do
      end do
c
c switch to Stefan's notation:
c
      do i=1,2
         ps(i,0)=b(4,i)
         ps(i,1)=b(1,i)
         ps(i,2)=b(2,i)
         ps(i,3)=b(3,i)
      end do
      do i=1,4
         ps(i+2,0)=p(4,i)
         ps(i+2,1)=p(1,i)
         ps(i+2,2)=p(2,i)
         ps(i+2,3)=p(3,i)
      end do
c
c calculation of four-momenta for nsubevent=5:
c
      do i=1,6
         pe(i,0,5)=ps(i,0)
         pe(i,1,5)=ps(i,1)
         pe(i,2,5)=ps(i,2)
         pe(i,3,5)=ps(i,3)
      end do
c
c make cuts:
c       
      call cut(pbeam,ps,npart,nocut)
      if (nocut.eq.1) icuti2=0
      if (nocut.eq.0) icuti2=1
      if(icuti2.eq.1)then
         ncut5_k(1)=ncut5_k(1)+1
         if(Ihist.eq.1)ncut5_k(2)=ncut5_k(2)+1
         conti(6)=0d0
         kerni_c(3)=0d0
         goto 31
      end if 
c
c calculation of the local densities:
c
      gtot=0d0
      do i=1,nch(3)
         do j=1,8
            mapich(j)=mapi(j,i)
            nuich(j)=nui(j,i)
         end do
         do j=1,5
            iich(j)=ii(j,i)
         end do
         do j=1,3
            vzich(j)=vzi(j,i)
         end do
         call phspgen_4(1,iich,mapich,vzich,nuich,s,x,wps,icuti2)
c         if (wps.gt.1d+15) write(iout,*)'wflag',i,(iich(j),j=1,5)
c     $        ,(mapich(j),j=1,8),(vzich(j),j=1,3)
         gi(i)=dabs(wps)
         gtot=gtot+alp3(i)*gi(i)
      end do
c
c calculation of the Born-matrix element squared:
c always CC11 class of diagrams is used !
c
      qsigepem4=5
      qqcdepem=0
      qatgc=0
      call setprods(ps,dir,6)
      mat2=M2_epem_4f(ps)
      kerni_b(2)=conv*mat2/(2d0*pi)**8/2d0/sh/gtot/s
c       
c test of the phase space element:
c      kerni_b(2)=kerni_b(2)/
c     $     ((pi/2d0)**3*sh**2/6d0/2d0/(2d0*pi)**8/2d0/sh*conv)
c
c initial-state collinear photon factor
      colli=q(2)**2*alpha0/pi*
     $     (mat2*(1d0+zc**2)/(1d0-zc)*
     $     (dlog(s/mif(2)**2*deltac/2d0)-1d0)+M2flip(2)*(1d0-zc))/2d0

c subtract 1-loop term when exponentiated ISR is taken into account

      if (sisr.ne.0.and.smc.ne.3) colli=colli-q(2)**2*alpha0/pi*mat2*
     $     (llq-1d0)*(1d0+zc**2)/(1d0-zc)/2d0
      if (smc.eq.3.and.sisr.ne.0) 
     $     colli=colli-mat2*beta/4d0*(1d0+zc**2)/(1d0-zc)
c
c inclusion of LL first, second and third-order collinear ISR:
c (with 'full' Born)
c
      if (smc.eq.3.and.sisr.ne.0) then
         qsigepem4=ssigepem4
         qqcdepem=sqcdepem
         qatgc=satgc
         mat2=M2_epem_4f(ps)
         colli=colli+mat2*(beta/4d0*(1d0+zc**2)/(1d0-zc)+
     $        beta**2/8d0*((1d0+zc**2)/(1d0-zc)*(dlog(1d0-zc)+
     $        3d0/2d0-dlog(zc)/2d0+lleps)+
     $        (1d0+zc)/2d0*(dlog(zc)/2d0-1d0)+zc)+
     $        beta**3/32d0*((1d0+zc**2)/(1d0-zc)*(dlog(1d0-zc)**2-
     $        dlog(zc)*dlog(1d0-zc)+dlog(zc)**2/6d0+
     $        (1d0+zc/2d0+lleps)*(2d0*dlog(1d0-zc)-dlog(zc))+
     $        2d0+zc/4d0-pi**2/3d0+3d0*lleps+lleps**2)-3d0/2d0+
     $        (zc-1d0)*lleps+(1d0+zc)*(pi**2/12d0+(zc+3d0)/4d0+
     $        zc*dlog(1-zc)-dlog(zc)**2/8d0+(1d0-zc)*dlog(zc)/2d0-
     $        dreal(spence(zc+ieps))/2d0+lleps*dlog(zc)/2d0)))
      end if

      kerni_c(3)=conv*colli/(2d0*pi)**8/2d0/sh/gtot/s
      conti(6)=kerni_c(3)
      atotsq(5)=atotsq4
      a1sq(5)=a1sq4
      a2sq(5)=a2sq4
      wmax(5)=max(wmax(5),dabs(kerni_c(3)))
c
c  calculation of sub-contributions:
c
 31   if(ihist.eq.1)then
         conti_tot(5)=conti_tot(5)+wgt*conti(6)/dble(It)
         dconti_tot(5)=dconti_tot(5)+(wgt*conti(6))**2/dble(it)
      end if
c
c calculation of the variance for each channel and the total variance: 
c
 32   continue
      icut=icuti1*icuti2
      if (ntot(1).le.nopt.and.opt.eq.1) then
         do i=1,nch(3)
            if (init3(i).eq.0) then
               ni3(i)=0
               walpi3(i)=0d0
               init3(i)=init3(i)+1
            end if
            ni3(i)=ni3(i)+1
            if (icut.eq.0) then
               walpi3(i)=walpi3(i)+gi(i)/gtot*
     $              (conti(5)+conti(6))**2*wgt
            end if
         end do
         conti_opt(3)=conti_opt(3)+conti(5)+conti(6)
         w_opt(3)=w_opt(3)+(conti(5)+conti(6))**2
      end if

 40   continue
      if (sisr.eq.0) goto 50
      if (smc.eq.3.and.wflag(6).eq.0) goto 50
c     
c sisr=1: calculation of the higher-order ISR by convoluting
c         the Born-cross section with structure functions.
c src=2 : calculation of the IBA CC03 cross section.
c
c self optimization of a-priori weights:
c initialization
      if (iti(4).eq.1) then
         wmax(6)=0d0
         conti_opt(4)=0d0
         w_opt(4)=0d0
         istep(4)=0
         do i=1,nch(4)
            alp4(i)=alpm4(i,0)
            init4(i)=0
            walpi4(i)=0d0
         end do
         bet4(0)=0d0
         do i=1,nch(4)
            bet4(i)=0d0
            do j=1,i
               bet4(i)=bet4(i)+alp4(j)
            end do
         end do
      end if
      iti(4)=0
c optimization after 5000, ... events
      if (ntot(1).le.nopt.and.opt.eq.1) then
         if (ntot(1).eq.5000.or.ntot(1).eq.10000.or.
     $        ntot(1).eq.15000.or.ntot(1).eq.25000.or.
     $        mod(ntot(1),int(nopt/iopt)).eq.0) then
            diffi4(0)=0d0
            istep(4)=istep(4)+1
            alptot=0d0
            alpsum=0d0
            do i=1,nch(4)
               walpi4_opt(i)=dsqrt(walpi4(i)/ni4(i))
               alptot=alptot+alp4(i)*walpi4_opt(i)
               alpsum=alpsum+alp4(i)
               alpm4(i,istep(4))=alp4(i)
            end do
            do i=1,nch(4)
               if (i.eq.1) then
                  diff4=dabs(alptot-walpi4_opt(i))
               else
                  diff4=max(diff4,
     $                 dabs(alptot-walpi4_opt(i)))
               end if
            end do
            diffi4(istep(4))=diff4
c calculation of the average and the variance for each optimization:
            int4_opt(istep(4))=conti_opt(4)/ni4(1)
            dint4_opt(istep(4))=dsqrt(dabs(w_opt(4)/ni4(1)-
     $           (conti_opt(4)**2-w_opt(4))/(ni4(1)-1)/
     $           ni4(1))/ni4(1))
            if (iout.ne.0) then
               write(iout,*)' '
               if (src.ne.2) then
                  write(iout,*)
     $           ' Born convoluted with struct. functions (weight(6)):'
               else
                  write(iout,*)' IBA (weight(6)):'
               end if
               write(iout,*)
     $              ' channel no.: a-p. weights after',istep(4)-1,
     $              ' optimizations:'
               do i=1,nch(4)
                  write(iout,900)i,': ',alpm4(i,istep(4))
               end do
c              write(iout,*)alpsum,diff4
               write(iout,*)' no. of optim., no. of events,'// 
     $              'integral estimate +/- stat. error:' 
               write(iout,1000)
     $              istep(4),',',ni4(1),',',
     $              int4_opt(istep(4)),' +/-',dint4_opt(istep(4))
            end if
            conti_opt(4)=0d0
            w_opt(4)=0d0
            alpsum=0d0
            do i=1,nch(4)
               init4(i)=0
               alp4(i)=alp4(i)*walpi4_opt(i)/alptot
               alpsum=alpsum+alp4(i)
            end do
c            write(iout,*)alpsum
            bet4(0)=0d0
            do i=1,nch(4)
               bet4(i)=0d0
               do j=1,i
                  bet4(i)=bet4(i)+alp4(j)
               end do
            end do
         end if
      end if
c
c generation of the configuration (event)
c random choice of channel:
      call rans(rand)
      z=rand
      do i=1,nch(4)
         if (bet4(i-1).le.z.and.z.le.bet4(i)) ch=i
      end do
      do i=1,8
         mapich(i)=mapi(i,ch)
         nuich(i)=nui(i,ch)
      end do
      do i=1,5
         iich(i)=ii(i,ch)
      end do
      do i=1,3
         vzich(i)=vzi(i,ch)
      end do

      icoll=0
      dpa=0
      if (smc.eq.3) then
         oxp=dexp((1d0-xv(14))*lleps)
         oxm=dexp((1d0-xv(15))*lleps)
         if (oxp.lt.1d-20) oxp=1d-20
         if (oxm.lt.1d-20) oxm=1d-20
         xp=1d0-oxp
         xm=1d0-oxm
         dxp=-lleps
         dxm=-lleps
      else
         beti=alpha0/pi*(llq-1d0)
         oxp=xv(14)**(1d0/beti)
         oxm=xv(15)**(1d0/beti)
         if (oxp.lt.1d-20) oxp=1d-20
         if (oxm.lt.1d-20) oxm=1d-20
         xp=1d0-oxp
         xm=1d0-oxm
         dxp=1d0/beti
         dxm=1d0/beti
      end if
      sh=xp*xm*s
      gq0=(xp+xm)*rs/2.d0/dsqrt(sh)
      gq=(xp-xm)*rs/2.d0/dsqrt(sh)
c
c beam momenta:
c
      b(1,1)=0.d0
      b(2,1)=0.d0
      b(3,1)=dsqrt(sh)/2d0
      b(4,1)=dsqrt(sh)/2d0
      b(1,2)=0.d0
      b(2,2)=0.d0
      b(3,2)=-dsqrt(sh)/2d0
      b(4,2)=dsqrt(sh)/2d0
      do i=1,4
         bh(i,1)=b(i,1)
         bh(i,2)=b(i,2)
      end do
      ccuts(1)=0
      ccuts(2)=0
c cuts are taken into account in the phase space generation
      if (src.eq.0) then
         ccuts(1)=1
         ccuts(2)=1
      end if
      do i=1,2
         call boost_z(gq0,gq,bh(4,i),bh(3,i))
      end do
      call phspgen_4(0,iich,mapich,vzich,nuich,sh,x,wps,icut)

      if(icut.eq.1)then
         ncut6_k(1)=ncut6_k(1)+1
         if(Ihist.eq.1)ncut6_k(2)=ncut6_k(2)+1
         conti(7)=0d0
         kerni_b(3)=0d0
         goto 42
      end if
c
c boost to laboratory frame
c
      do i=1,4
         b(i,1)=bh(i,1)
         b(i,2)=bh(i,2)
      end do
      do i=1,4
         call boost_z(gq0,gq,p(4,i),p(3,i))
      end do
c
c calculation of the invariants:
c
      sinv(1,2)=2d0*dot_4(b(1,1),b(1,2))
      do j=1,npart
         sinv(1,j+2)=2d0*dot_4(b(1,1),p(1,j))
         sinv(2,j+2)=2d0*dot_4(b(1,2),p(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinv(i+2,j+2)=2d0*dot_4(p(1,i),p(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinv(j,i)=sinv(i,j)
         end do
      end do
c
c switch to Stefan's notation:
c
      do i=1,2
         ps(i,0)=b(4,i)
         ps(i,1)=b(1,i)
         ps(i,2)=b(2,i)
         ps(i,3)=b(3,i)
      end do
      do i=1,4
         ps(i+2,0)=p(4,i)
         ps(i+2,1)=p(1,i)
         ps(i+2,2)=p(2,i)
         ps(i+2,3)=p(3,i)
      end do
c
c calculation of the momenta for nsubevent=6:
c
      do i=1,6
         pe(i,0,6)=ps(i,0)
         pe(i,1,6)=ps(i,1)
         pe(i,2,6)=ps(i,2)
         pe(i,3,6)=ps(i,3)
      end do
c
c make cuts:
c       
      call cut(pbeam,ps,npart,nocut)
      if (nocut.eq.1) icut=0
      if (nocut.eq.0) icut=1
      if(icut.eq.1)then
         ncut6_k(1)=ncut6_k(1)+1
         if(Ihist.eq.1)ncut6_k(2)=ncut6_k(2)+1
         conti(7)=0d0
         kerni_b(3)=0d0
         goto 41
      end if 
c
c calculation of the local densities:
c
      gtot=0d0
      do i=1,nch(4)
         do j=1,8
            mapich(j)=mapi(j,i)
            nuich(j)=nui(j,i)
         end do
         do j=1,5
            iich(j)=ii(j,i)
         end do
         do j=1,3
            vzich(j)=vzi(j,i)
         end do
         call phspgen_4(1,iich,mapich,vzich,nuich,sh,x,wps,icut)
c         if (wps.gt.1d+15) write(iout,*)'wflag',i,(iich(j),j=1,5)
c     $        ,(mapich(j),j=1,8),(vzich(j),j=1,3)
         gi(i)=dabs(wps)
         gtot=gtot+alp4(i)*gi(i)
      end do
c
c calculation of the Born-matrix element squared
c src=1: the same class of diagrams as in Born is used 
c src=2 (IBA): only CC03 !
c 
      if (src.eq.2) then
c
c switch to convention for calculating RCs
c in the case of MC processes
c
         do i=1,6
            pss(i,0)=ps(i,0)
            pss(i,1)=ps(i,1)
            pss(i,2)=ps(i,2)
            pss(i,3)=ps(i,3)
         end do
         if(cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3))then
            do i=0,3
               pss(4,i)=ps(6,i)
               pss(6,i)=ps(4,i)
            end do
         end if
         mat2=M2_Born_offsh(pss,1,1)
         atotsq(6)=mat2
         a1sq(6)=mat2
         a2sq(6)=0d0
         if(cc.eq.1.and.nc.eq.1.and.sym.eq.0)then
            a1sq(6)=0d0
            a2sq(6)=mat2
         end if
      else
         qatgc=satgc
         qsigepem4=ssigepem4
         qqcdepem=sqcdepem
         call setprods(ps,dir,6)
         mat2=M2_epem_4f(ps)
         atotsq(6)=atotsq4
         a1sq(6)=a1sq4
         a2sq(6)=a2sq4
c include Coulomb singularity
         if (scoultree.ne.0) then
c
c switch to convention for calculating RCs
c in the case of MC processes
c
            do i=1,6
               pss(i,0)=ps(i,0)
               pss(i,1)=ps(i,1)
               pss(i,2)=ps(i,2)
               pss(i,3)=ps(i,3)
            end do
            if(cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3))then
               do i=0,3
                  pss(4,i)=ps(6,i)
                  pss(6,i)=ps(4,i)
               end do
            end if
            do i=0,3
               qwp(i)=pss(3,i)+pss(4,i)
               qwm(i)=pss(5,i)+pss(6,i)
               qp(i)=qwp(i)+qwm(i)
            end do
            sp=qp(0)**2-(qp(1)**2+qp(2)**2+qp(3)**2)
            kp2off=qwp(0)**2-(qwp(1)**2+qwp(2)**2+qwp(3)**2)
            km2off=qwm(0)**2-(qwm(1)**2+qwm(2)**2+qwm(3)**2)
            bb=dsqrt((sp-kp2off-km2off)**2-4d0*kp2off*km2off)/sp
            coul=coulsing(sp,kp2off,km2off,1)
            mat2=mat2*(1d0+coul*(1d0-bb**2)**2)
            atotsq(6)=atotsq(6)*(1d0+coul*(1d0-bb**2)**2)
            a1sq(6)=a1sq(6)*(1d0+coul*(1d0-bb**2)**2)
            a2sq(6)=a2sq(6)*(1d0+coul*(1d0-bb**2)**2)
         end if
      end if
      kerni_b(2)=conv*mat2/(2d0*pi)**8/2d0/sh/gtot
c       
c test of the phase space element:
c      kerni_b(2)=kerni_b(2)/
c     $     ((pi/2d0)**3*sh**2/6d0/2d0/(2d0*pi)**8/2d0/sh*conv)
c
c multiplication with the structure functions (=function struci):
      if (smc.eq.3) then
c rest of beta**2 and beta**3 terms:
         glleep=(1d0+xp**2)*beta/4d0
         glleem=(1d0+xm**2)*beta/4d0
         glleep2=beta**2/8d0*((1d0+xp**2)*(dlog(1d0-xp)-dlog(xp)/2d0+
     $        3d0/4d0)+(1d0-xp**2)*dlog(xp)/4d0-(1d0-xp)**2/2d0)
         glleem2=beta**2/8d0*((1d0+xm**2)*(dlog(1d0-xm)-dlog(xm)/2d0+
     $        3d0/4d0)+(1d0-xm**2)*dlog(xm)/4d0-(1d0-xm)**2/2d0)
      else
         glleep=struci(xp,oxp,llq,beti,alpha0)
         glleem=struci(xm,oxm,llq,beti,alpha0)
         glleep2=0d0
         glleem2=0d0
      end if
      kerni_b(3)=kerni_b(2)*(glleep*glleem+glleep*glleem2+
     $     glleem*glleep2)*dxp*dxm
      conti(7)=kerni_b(3)
      wmax(6)=max(wmax(6),dabs(kerni_b(3)))
c
c calculation of sub-contributions:
c
 41   if(ihist.eq.1)then
         if (src.eq.1.and.smc.ne.3) then
            conti_tot(6)=conti_tot(6)+wgt*(conti(7)-conti(1))/dble(It)
            dconti_tot(6)=dconti_tot(6)+
     $           (wgt*(conti(7)-conti(1)))**2/dble(it)
         else 
            conti_tot(6)=conti_tot(6)+wgt*conti(7)/dble(It)
            dconti_tot(6)=dconti_tot(6)+(wgt*conti(7))**2/dble(it)
         end if
      end if
c
c calculation of the variance for each channel and the total variance: 
c
 42   continue
      if (ntot(1).le.nopt.and.opt.eq.1) then
         do i=1,nch(4)
            if (init4(i).eq.0) then
               ni4(i)=0
               walpi4(i)=0d0
               init4(i)=init4(i)+1
            end if
            ni4(i)=ni4(i)+1
            if (icut.eq.0) then
               walpi4(i)=walpi4(i)+gi(i)/gtot*conti(7)**2*wgt
            end if
         end do
         conti_opt(4)=conti_opt(4)+conti(7)
         w_opt(4)=w_opt(4)+conti(7)**2
      end if

 50   continue
      if (sborn5.eq.0.and.sborng5.eq.0) goto 100
      if (sborn5.eq.0) goto 68
      if (smc.eq.3.and.wflag(7).eq.0) goto 68

 55   continue
c
c src=3: calculation of the IBA to ee->4f+photon
c src=1: calculation of the real corrections
c src=0: calculation of tree-level ee->4f+photon  
c full matrix element for the
c tree-level processes ee->4f+photon is used
c
      npart=5 
c
c self-optimization of a-priori weights:
c
      if (itig.eq.1) then
         wgmax=0d0
         contig_opt=0d0
         wg_opt=0d0
         istepg=0
         do i=1,nchg
            alpg(i)=alpgm(i,0)
            walpig(i)=0d0
            initg(i)=0
         end do
         betg(0)=0d0
         do i=1,nchg
            betg(i)=0d0
            do j=1,i
               betg(i)=betg(i)+alpg(j)
            end do
         end do
      end if
      itig=0

      if (ntot(1).le.noptg.and.opt.eq.1) then
         if (ntot(1).eq.500000.or.ntot(1).eq.1500000.or.
     $        ntot(1).eq.3000000.or.
     $        mod(ntot(1),int(noptg/ioptg)).eq.0) then
            diffig(0)=0d0
            istepg=istepg+1
            alptot=0d0
            alpsum=0d0
            do i=1,nchg
               walpig_opt(i)=dsqrt(walpig(i)/nig(i))
               alptot=alptot+alpg(i)*walpig_opt(i)
               alpsum=alpsum+alpg(i)
               alpgm(i,istepg)=alpg(i)
            end do
            do i=1,nchg
               if (i.eq.1) then
                  diffg=dabs(alptot-walpig_opt(i))
               else
                  diffg=max(diffg,
     $                 dabs(alptot-walpig_opt(i)))
               end if
            end do
            diffig(istepg)=diffg
c calculation of the average and the variance for each optimization:
            intg_opt(istepg)=contig_opt/nig(1)
            dintg_opt(istepg)=dsqrt(dabs(wg_opt/nig(1)-
     $           (contig_opt**2-wg_opt)/(nig(1)-1)/nig(1))/nig(1))
            if (iout.ne.0) then
               write(iout,*)' '
               write(iout,*)' 2->5 QED (weight(7)):'
               write(iout,*)
     $              ' channel no.: a-p. weights after',istepg-1,
     $              ' optimizations:'
               do i=1,nchg
                  write(iout,900)i,': ',alpgm(i,istepg)
               end do
c            write(iout,*)alpsum,diffg
               write(iout,*)' no. of optim., no. of events,'// 
     $              'integral estimate +/- stat. error:' 
               write(iout,1000)
     $              istepg,',',nig(1),',',
     $              intg_opt(istepg),' +/-',dintg_opt(istepg)
            end if
            contig_opt=0d0
            wg_opt=0d0
            alpsum=0d0
            do i=1,nchg
               initg(i)=0
               alpg(i)=alpg(i)*walpig_opt(i)/alptot
            end do
            betg(0)=0d0
            do i=1,nchg
               betg(i)=0d0
               do j=1,i
                  betg(i)=betg(i)+alpg(j)
               end do
            end do
         end if
      end if
c
c setup of configuration
c convention for generation of phase space:
c	1-> fermion3 (iso+: nu,u)
c       2-> fermion4 (anti-iso-: l+,anti-d)
c	3-> fermion5 (iso-: l-,d)
c       4-> fermion6 (anti-iso+: anti-nu,anti-u)
c       5-> photon 
c initialization of four momenta:
      do i=1,npart
         do j=1,4
            p(j,i)=0d0
         end do
      end do
      do i=1,4
         b(i,1)=0d0
         b(i,2)=0d0
         bh(i,1)=0d0
         bh(i,2)=0d0
      end do
c
c generate the configuration (event):
c random choice of channel:
      call rans(rand)
      z=rand
      do i=1,nchg
         if (betg(i-1).le.z.and.z.le.betg(i)) chg=i
      end do
      do i=1,8
         mapigch(i)=mapig(i,chg)
         nuich(i)=nui(i,chg)
      end do
      do i=1,5
         iigch(i)=iig(i,chg)
      end do
      do i=1,3
         vzigch(i)=vzig(i,chg)
      end do

      sh=s
      if (sisr.eq.1.and.(src.eq.0.or.src.eq.3)) then
         beti=alpha0/pi*(llq-1d0)
         oxp=xv(14)**(1d0/beti)
         oxm=xv(15)**(1d0/beti)
         if (oxp.lt.1d-20) oxp=1d-20
         if (oxm.lt.1d-20) oxm=1d-20
         xp=1d0-oxp
         xm=1d0-oxm
         dxp=1d0/beti
         dxm=1d0/beti
         sh=xp*xm*s
         gq0=(xp+xm)*rs/2.d0/dsqrt(sh)
         gq=(xp-xm)*rs/2.d0/dsqrt(sh)
      end if
c
c beam momenta:
c
      b(1,1)=0.d0
      b(2,1)=0.d0
      b(3,1)=dsqrt(sh)/2d0
      b(4,1)=dsqrt(sh)/2d0
      b(1,2)=0.d0
      b(2,2)=0.d0
      b(3,2)=-dsqrt(sh)/2d0
      b(4,2)=dsqrt(sh)/2d0
      do i=1,4
         bh(i,1)=b(i,1)
         bh(i,2)=b(i,2)
      end do

      if (src.eq.0.or.src.eq.3) then
c cuts are taken into account in the phase space generation
         ccuts(1)=1
         ccuts(2)=1
         ccuts(3)=1
         if (sisr.eq.1) then
            ccuts(3)=0
            do i=1,2
               call boost_z(gq0,gq,bh(4,i),bh(3,i))
            end do
         end if
      else 
c full kinematical range (no cuts in phase space generation)
         ccuts(1)=0
         ccuts(2)=0
         ccuts(3)=0
      end if
      call phspgen_5(0,iigch,mapigch,vzigch,nuich,sh,x,wps,icut)
      
      if (icut.eq.1) then
         ncut_r(1)=ncut_r(1)+1
         if(Ihist.eq.1)ncut_r(2)=ncut_r(2)+1
         kern_r=0d0
         conti(8)=0d0
         goto 65 
      end if 
c
c boost to laboratory frame
c
      if (sisr.eq.1.and.(src.eq.0.or.src.eq.3)) then
         do i=1,4
            b(i,1)=bh(i,1)
            b(i,2)=bh(i,2)
         end do
         do i=1,5
            call boost_z(gq0,gq,p(4,i),p(3,i))
         end do
      end if
c
c calculate the invariants:
c       
      sinv(1,2)=2d0*dot_4(b(1,1),b(1,2))
      do j=1,npart
         sinv(1,j+2)=2d0*dot_4(b(1,1),p(1,j))
         sinv(2,j+2)=2d0*dot_4(b(1,2),p(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinv(i+2,j+2)=2d0*dot_4(p(1,i),p(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinv(j,i)=sinv(i,j)
         end do
      end do
c
c switch to Stefan's notation 
c (and save 4-momenta before recombination):
c
      do i=1,2
         ps(i,0)=b(4,i)
         ps(i,1)=b(1,i)
         ps(i,2)=b(2,i)
         ps(i,3)=b(3,i)
      end do
      do i=1,5
         ps(i+2,0)=p(4,i)
         ps(i+2,1)=p(1,i)
         ps(i+2,2)=p(2,i)
         ps(i+2,3)=p(3,i)
      end do
c
c calculate four-momenta for nsubevent=7 before recombination:
c
      do i=1,7
         pe(i,0,7)=ps(i,0)
         pe(i,1,7)=ps(i,1)
         pe(i,2,7)=ps(i,2)
         pe(i,3,7)=ps(i,3)
      end do

      if (src.eq.1) then
c
c cuts to avoid soft singularities:
c
         ephoton=ps(7,0)
         if (ephoton.lt.epmin) then
            icut=1
            conti(8)=0d0
            kern_r=0d0
            ncut_r(1)=ncut_r(1)+1
            if(ihist.eq.1)ncut_r(2)=ncut_r(2)+1
            goto 60
         end if
c
c cuts to avoid collinear singularities:
c
         smin=deltac*rs*ephoton
         if(dabs(sinv(1,7)).lt.smin.or.
     $        dabs(sinv(2,7)).lt.smin)then
            icut=1
            conti(8)=0d0
            kern_r=0d0
            ncut_r(1)=ncut_r(1)+1
            if(ihist.eq.1)ncut_r(2)=ncut_r(2)+1
            goto 60
         end if
         do i=1,4
            if (q(i+2).ne.0d0) then
               smin=deltac*2d0*ephoton*ps(i+2,0)
               if(dabs(sinv(i+2,7)).lt.smin) then
                  icut=1
                  conti(8)=0d0
                  kern_r=0d0
                  ncut_r(1)=ncut_r(1)+1
                  if(ihist.eq.1)ncut_r(2)=ncut_r(2)+1
                  goto 60 
               end if
            end if
         end do
      end if
c
c make recombination and separation cuts:
c
      call recombination(pbeam,ps,pout,nocut)
      if (nocut.eq.0) icut=1
      if (nocut.eq.1) icut=0
c
c calculate four-momenta for nsubevent=7 after recombination:
c
      do i=1,7
         pe(i,0,7)=pout(i,0)
         pe(i,1,7)=pout(i,1)
         pe(i,2,7)=pout(i,2)
         pe(i,3,7)=pout(i,3)
      end do
      do i=1,2
         b(4,i)=pout(i,0)
         b(1,i)=pout(i,1)
         b(2,i)=pout(i,2)
         b(3,i)=pout(i,3)
      end do
      do i=1,5
         p(4,i)=pout(i+2,0)
         p(1,i)=pout(i+2,1)
         p(2,i)=pout(i+2,2)
         p(3,i)=pout(i+2,3)
      end do

      if(icut.eq.1)then
         ncut_r(1)=ncut_r(1)+1
         if(Ihist.eq.1)ncut_r(2)=ncut_r(2)+1
         kern_r=0d0
         conti(8)=0d0
         goto 60
      end if 
c
c calculate the local densities:
c
      gtotg=0d0
      do i=1,nchg
         do j=1,8
            mapigch(j)=mapig(j,i)
            nuich(j)=nui(j,i)
         end do
         do j=1,5
            iigch(j)=iig(j,i)
         end do
         do j=1,3
            vzigch(j)=vzig(j,i)
         end do
         call phspgen_5(1,iigch,mapigch,vzigch,nuich,
     $        sh,x,wps,icut)
c         if (wps.gt.1d+15) write(iout,*)'wflag',i,(iigch(j),j=1,5)
c     $        ,(mapigch(j),j=1,8),(vzigch(j),j=1,3)
         gig(i)=dabs(wps)
         gtotg=gtotg+alpg(i)*gig(i)
      end do
c
c calculation of the matrix element squared:
c
      qqcdepem=sqcdepem
      if (src.eq.1) qqcdepem=0
      qsigepem5=ssigepem5
      if (src.eq.1) qsigepem5=5
      call setprods(ps,dir,7)
      mat2=M2_epem_4fA(ps)
      kern_r=conv*mat2/(2d0*pi)**11/2d0/sh/gtotg
      if ((src.eq.0.or.src.eq.3).and.scoultree.ne.0) then
c
c switch to convention for calculating RCs
c in the case of MC processes
c
         do i=1,6
            pss(i,0)=ps(i,0)
            pss(i,1)=ps(i,1)
            pss(i,2)=ps(i,2)
            pss(i,3)=ps(i,3)
         end do
         if(cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3))then
            do i=0,3
               pss(4,i)=ps(6,i)
               pss(6,i)=ps(4,i)
            end do
         end if
         do i=0,3
            qwp(i)=pss(3,i)+pss(4,i)
            qwm(i)=pss(5,i)+pss(6,i)
            qp(i)=qwp(i)+qwm(i)
         end do
         sp=qp(0)**2-(qp(1)**2+qp(2)**2+qp(3)**2)
         kp2off=qwp(0)**2-(qwp(1)**2+qwp(2)**2+qwp(3)**2)
         km2off=qwm(0)**2-(qwm(1)**2+qwm(2)**2+qwm(3)**2)
         coul=0d0
         if (scoultree.eq.1) then
            bb=dsqrt((sp-kp2off-km2off)**2-4d0*kp2off*km2off)/sp
            coul=coulsing(sp,kp2off,km2off,1)
         else if (scoultree.eq.2) then
            do i=0,3
               qwpk(i)=qwp(i)+ps(7,i)
               qwmk(i)=qwm(i)+ps(7,i)
               qpk(i)=qp(i)+ps(7,i)
            end do
            spk=qpk(0)**2-(qpk(1)**2+qpk(2)**2+qpk(3)**2)
            kp2koff=qwpk(0)**2-(qwpk(1)**2+qwpk(2)**2+qwpk(3)**2)
            km2koff=qwmk(0)**2-(qwmk(1)**2+qwmk(2)**2+qwmk(3)**2)
            if (dabs(kp2off-mw**2).lt.dabs(kp2koff-mw**2).and.
     $          dabs(km2off-mw**2).lt.dabs(km2koff-mw**2)) then
               bb=dsqrt((sp-kp2off-km2off)**2-4d0*kp2off*km2off)/sp
               coul=coulsing(sp,kp2off,km2off,1)
            else if ((dabs(kp2off-mw**2).gt.dabs(kp2koff-mw**2).and.
     $                dabs(km2off-mw**2).lt.dabs(km2koff-mw**2)).or.
     $               (dabs(kp2off-mw**2).gt.dabs(kp2koff-mw**2).and.
     $                dabs(km2off-mw**2).gt.dabs(km2koff-mw**2).and.
     $                dabs(kp2koff-mw**2).lt.dabs(km2koff-mw**2))) then
               bb=dsqrt((spk-kp2koff-km2off)**2-4d0*kp2koff*km2off)/spk
               coul=coulsing(spk,kp2koff,km2off,1)
            else if ((dabs(kp2off-mw**2).lt.dabs(kp2koff-mw**2).and.
     $                dabs(km2off-mw**2).gt.dabs(km2koff-mw**2)).or.
     $               (dabs(kp2off-mw**2).gt.dabs(kp2koff-mw**2).and.
     $                dabs(km2off-mw**2).gt.dabs(km2koff-mw**2).and.
     $                dabs(kp2koff-mw**2).gt.dabs(km2koff-mw**2))) then
               bb=dsqrt((spk-kp2off-km2koff)**2-4d0*kp2off*km2koff)/spk
               coul=coulsing(spk,kp2off,km2koff,1)
            end if
         end if
         kern_r=kern_r*(1d0+coul*(1d0-bb**2)**2)
      end if
      if (sisr.eq.1.and.(src.eq.0.or.src.eq.3)) then
         glleep=struci(xp,oxp,llq,beti,alpha0)
         glleem=struci(xm,oxm,llq,beti,alpha0)
         kern_r=kern_r*glleep*glleem*dxp*dxm
      end if
      conti(8)=kern_r
      atotsq(7)=atotsq5
      a1sq(7)=a1sq5
      a2sq(7)=a2sq5
      wgmax=max(wgmax,kern_r)
c     
c test of the phase space element:
c	kern_r=kern_r/((pi/2d0)**4*s**3/6d0/(2d0*pi)**11/2d0/s*
c	1    conv/24d0)
c
c calculation of subcontributions 
c
 60   if(ihist.eq.1)then
         conti_tot(7)=conti_tot(7)+wgt*conti(8)/dble(It)
         dconti_tot(7)=dconti_tot(7)+(wgt*conti(8))**2/dble(it)
      end if
c
c calculation of the variance for each channel:
c
 65   if (ntot(1).le.noptg.and.opt.eq.1) then
         do i=1,nchg
            if (initg(i).eq.0) then
               nig(i)=0
               walpig(i)=0d0
               initg(i)=initg(i)+1
            end if
            nig(i)=nig(i)+1
            if (icut.eq.0)
     $           walpig(i)=walpig(i)+gig(i)/gtotg*conti(8)**2*wgt
         end do
         contig_opt=contig_opt+conti(8)
         wg_opt=wg_opt+conti(8)**2
      end if

 68   continue 
      if (sborng5.eq.0) goto 100
      if (smc.eq.3.and.wflag(8).eq.0) goto 100
c
c qqcd=1,3: calculation of the real gluon corrections 
c qqcd=0: caculation of the tree-level processes ee->4f+gluon
c full matrix element for the
c tree-level processes ee->4f+gluon is used
c
      npart=5 
c
c self-optimization of a-priori weights:
c
      if (itiq.eq.1) then
         wqmax=0d0
         contiq_opt=0d0
         wq_opt=0d0
         istepq=0
         do i=1,nchq
            alpq(i)=alpqm(i,0)
            walpiq(i)=0d0
            initq(i)=0
         end do
         betq(0)=0d0
         do i=1,nchq
            betq(i)=0d0
            do j=1,i
               betq(i)=betq(i)+alpq(j)
            end do
         end do
      end if
      itiq=0

c      if (ntot(1).le.nopg.and.opt.eq.1) then
c         if (ntot(1).eq.500000.or.ntot(1).eq.1500000.or.
c     $        ntot(1).eq.3000000.or.
c     $        mod(ntot(1),int(noptg/ioptg)).eq.0) then
      if (ntot(1).le.nopt.and.opt.eq.1) then
         if (ntot(1).eq.5000.or.ntot(1).eq.10000.or.
     $        ntot(1).eq.15000.or.ntot(1).eq.25000.or.
     $        mod(ntot(1),int(nopt/iopt)).eq.0) then
            diffiq(0)=0d0
            istepq=istepq+1
            alptot=0d0
            alpsum=0d0
            do i=1,nchq
               walpiq_opt(i)=dsqrt(walpiq(i)/niq(i))
               alptot=alptot+alpq(i)*walpiq_opt(i)
               alpsum=alpsum+alpq(i)
               alpqm(i,istepq)=alpq(i)
            end do
            do i=1,nchq
               if (i.eq.1) then
                  diffq=dabs(alptot-walpiq_opt(i))
               else
                  diffq=max(diffq,
     $                 dabs(alptot-walpiq_opt(i)))
               end if
            end do
            diffiq(istepq)=diffq
c calculation of the average and the variance for each optimization:
            intq_opt(istepq)=contiq_opt/niq(1)
            dintq_opt(istepq)=dsqrt(dabs(wq_opt/niq(1)-
     $           (contiq_opt**2-wq_opt)/(niq(1)-1)/niq(1))/niq(1))
            if (iout.ne.0) then
               write(iout,*)' '
               write(iout,*)' 2->5 QCD (weight(8)):'
               write(iout,*)
     $              ' channel no.: a-p. weights after',istepq-1,
     $              ' optimizations:'
               do i=1,nchq
                  write(iout,900)i,': ',alpqm(i,istepq)
               end do
c            write(iout,*)alpsum,diffq
               write(iout,*)' no. of optim., no. of events,'// 
     $              'integral estimate +/- stat. error:' 
               write(iout,1000)
     $              istepq,',',niq(1),',',
     $              intq_opt(istepq),' +/-',dintq_opt(istepq)
            end if
            contiq_opt=0d0
            wq_opt=0d0
            alpsum=0d0
            do i=1,nchq
               initq(i)=0
               alpq(i)=alpq(i)*walpiq_opt(i)/alptot
            end do
            betq(0)=0d0
            do i=1,nchq
               betq(i)=0d0
               do j=1,i
                  betq(i)=betq(i)+alpq(j)
               end do
            end do
         end if
      end if
c
c setup of configuration
c
c convention for generation of phase space:
c
c	1-> fermion3 (iso+: nu,u)
c       2-> fermion4 (anti-iso-: l+,anti-d)
c	3-> fermion5 (iso-: l-,d)
c       4-> fermion6 (anti-iso+: anti-nu,anti-u)
c       5-> gluon
c initialization of four momenta:
      do i=1,npart
         do j=1,4
            p(j,i)=0d0
         end do
      end do
c
c generate the configuration (event):
c random choice of channel:
      call rans(rand)
      z=rand
      do i=1,nchq
         if (betq(i-1).le.z.and.z.le.betq(i)) chg=i
      end do
      do i=1,8
         mapiqch(i)=mapiq(i,chg)
         nuich(i)=nui(i,chg)
      end do
      do i=1,5
         iiqch(i)=iiq(i,chg)
      end do
      do i=1,3
         vziqch(i)=vziq(i,chg)
      end do

      if (qqcd.eq.0) then
c cuts are taken into account in the phase space generation
         ccuts(1)=1
         ccuts(2)=1
         ccuts(3)=1
      else 
c full kinematical range (no cuts in phase space generation)
         ccuts(1)=0
         ccuts(2)=0
         ccuts(3)=0
      end if
      call phspgen_5(0,iiqch,mapiqch,vziqch,nuich,s,x,wps,icut)
      
      if (icut.eq.1) then
         ncutq_r(1)=ncutq_r(1)+1
         if(Ihist.eq.1)ncutq_r(2)=ncutq_r(2)+1
         kernq_r=0d0
         conti(9)=0d0
         goto 75 
      end if 
c
c calculate the invariants:
c       
      sinv(1,2)=2d0*dot_4(b(1,1),b(1,2))
      do j=1,npart
         sinv(1,j+2)=2d0*dot_4(b(1,1),p(1,j))
         sinv(2,j+2)=2d0*dot_4(b(1,2),p(1,j))
      end do	  
      do i=1,npart
         do j=i,npart
            sinv(i+2,j+2)=2d0*dot_4(p(1,i),p(1,j))
         end do
      end do
      do i=1,npart+2
         do j=i+1,npart+2
            sinv(j,i)=sinv(i,j)
         end do
      end do
c
c switch to Stefan's notation 
c (and save 4-momenta before recombination):
c
      do i=1,2
         ps(i,0)=b(4,i)
         ps(i,1)=b(1,i)
         ps(i,2)=b(2,i)
         ps(i,3)=b(3,i)
      end do
      do i=1,5
         ps(i+2,0)=p(4,i)
         ps(i+2,1)=p(1,i)
         ps(i+2,2)=p(2,i)
         ps(i+2,3)=p(3,i)
      end do
c
c calculate momenta for nsubevent=8 before recombination:
c
      do i=1,7
         pe(i,0,8)=ps(i,0)
         pe(i,1,8)=ps(i,1)
         pe(i,2,8)=ps(i,2)
         pe(i,3,8)=ps(i,3)
      end do
c
c cuts to avoid soft singularities:
c
      if (src.eq.1.and.qqcd.ne.0) then
         egluon=ps(7,0)
         if (egluon.lt.epgmin) then
            icut=1
            conti(9)=0d0
            kernq_r=0d0
            ncutq_r(1)=ncutq_r(1)+1
            if(ihist.eq.1)ncutq_r(2)=ncutq_r(2)+1
            goto 70
         end if
c
c cuts to avoid collinear singularities:
c
         do i=1,4
            if (q(i+2).ne.0d0.and.q(i+2).ne.-1d0) then
               smin=deltagc*2d0*egluon*ps(i+2,0)
               if(dabs(sinv(i+2,7)).lt.smin) then
                  icut=1
                  conti(9)=0d0
                  kernq_r=0d0
                  ncutq_r(1)=ncutq_r(1)+1
                  if(ihist.eq.1)ncutq_r(2)=ncutq_r(2)+1
                  goto 70 
               end if
            end if
         end do
      end if
c
c make recombination and separation cuts:
c
      call grecombination(pbeam,ps,pout,nocut)
      if (nocut.eq.0) icut=1
      if (nocut.eq.1) icut=0
c
c calculate momenta for nsubevent=8 after recombination:
c
      do i=1,7
         pe(i,0,8)=pout(i,0)
         pe(i,1,8)=pout(i,1)
         pe(i,2,8)=pout(i,2)
         pe(i,3,8)=pout(i,3)
      end do
c go back to my notation:
      do i=1,2
         b(4,i)=pout(i,0)
         b(1,i)=pout(i,1)
         b(2,i)=pout(i,2)
         b(3,i)=pout(i,3)
      end do
      do i=1,5
         p(4,i)=pout(i+2,0)
         p(1,i)=pout(i+2,1)
         p(2,i)=pout(i+2,2)
         p(3,i)=pout(i+2,3)
      end do

      if(icut.eq.1)then
         ncutq_r(1)=ncutq_r(1)+1
         if(Ihist.eq.1)ncutq_r(2)=ncutq_r(2)+1
         kernq_r=0d0
         conti(9)=0d0
         goto 70
      end if 
c
c calculate the local densities:
c
      gtotg=0d0
      do i=1,nchq
         do j=1,8
            mapiqch(j)=mapiq(j,i)
            nuich(j)=nui(j,i)
         end do
         do j=1,5
            iiqch(j)=iiq(j,i)
         end do
         do j=1,3
            vziqch(j)=vziq(j,i)
         end do
         call phspgen_5(1,iiqch,mapiqch,vziqch,nuich,
     $        s,x,wps,icut)
c         if (wps.gt.1d+15) write(iout,*)'wflag',i,(iiqch(j),j=1,5)
c     $        ,(mapiqch(j),j=1,8),(vziqch(j),j=1,3)
         gig(i)=dabs(wps)
         gtotg=gtotg+alpq(i)*gig(i)
      end do
c
c calculation of the matrix element squared
c
      call setprods(ps,dir,7)
      qsigepem5=ssigepemg5
      qqcdepem=0
      mat2=M2_epem_4fG(ps)
      kernq_r=conv*mat2/(2d0*pi)**11/2d0/s/gtotg
      conti(9)=kernq_r
      wqmax=max(wqmax,kernq_r)
c     
c test of the phase space element:
c	kernq_r=kernq_r/((pi/2d0)**4*s**3/6d0/(2d0*pi)**11/2d0/s*
c	1    conv/24d0)
c
c calculation of subcontributions
c
 70   if(ihist.eq.1)then
         conti_tot(8)=conti_tot(8)+wgt*conti(9)/dble(It)
         dconti_tot(8)=dconti_tot(8)+(wgt*conti(9))**2/dble(it)
      end if
c
c calculation of the variance for each channel:
c
 75   if (ntot(1).le.nopt.and.opt.eq.1) then
         do i=1,nchq
            if (initq(i).eq.0) then
               niq(i)=0
               walpiq(i)=0d0
               initq(i)=initq(i)+1
            end if
            niq(i)=niq(i)+1
            if (icut.eq.0)
     $           walpiq(i)=walpiq(i)+gig(i)/gtotg*conti(9)**2*wgt
         end do
         contiq_opt=contiq_opt+conti(9)
         wq_opt=wq_opt+conti(9)**2
      end if

 100  continue

      weightborn=kern_b
      if (smc.eq.1.and.sisr.ne.0) kern_b=0d0
      if (src.eq.0.and.sisr.ne.0.and.sborn4.ne.0) kern_b=0d0
      if (smc.eq.3) then
         weight(1)=kern_b+kern_w+kern_s+kerni_c(1)
         weight(2)=0d0
         weight(3)=0d0
         atotsq(1)=atotsq(1)+atotsq(2)+atotsq(3)
         a1sq(1)=a1sq(1)+a1sq(2)+a1sq(3)
         a2sq(1)=a2sq(1)+a2sq(2)+a2sq(3)
      else
         weight(1)=kern_b
         weight(2)=kern_w
         weight(3)=kern_s+kerni_c(1)
      end if
      weight(4)=kerni_c(2)
      weight(5)=kerni_c(3)
      weight(6)=kerni_b(3)
      weight(7)=kern_r
      weight(8)=kernq_r
c
c sum the contributions:
c
      kern_c=kerni_c(1)+kerni_c(2)+kerni_c(3)
      if(ihist.ne.1)then 
         kern=dabs(kern_b)+dabs(kern_r)+dabs(kern_w)+dabs(kern_c)+
     $        dabs(kern_s)+dabs(kerni_b(3))+dabs(kernq_r)
      else
         kern=kern_b+kern_r+kern_w+kern_s+kern_c+kerni_b(3)+kernq_r
      end if
      if(kern.eq.0d0)ncut(1)=ncut(1)+1
      if(kern.eq.0d0.and.ihist.eq.1)ncut(2)=ncut(2)+1
 900  format(i3,10x,(a),1f9.5)
 1000 format(1x,i2,12x,(a),i10,4x,(a),1f12.5,5x,(a),1f12.5)
      return
      end
c*********************************************************************
c definition of the scalar product of four vectors:
c*********************************************************************
      real*8 function dot_4(p1,p2)
      implicit none
      real*8 p1(4),p2(4)
      dot_4=-p1(1)*p2(1)-p1(2)*p2(2)-p1(3)*p2(3)+p1(4)*p2(4)
      return
      end
c*********************************************************************
      subroutine softfac(sn,onoff,xq,xl,ll2,soft)
c*********************************************************************
      implicit none
      integer i,j,k,sn,onoff
      integer qborn,qreal,qqcd,qbos,qferm,qsoft,qnf,qfast
      integer type,nc,cc,sym,perm
      integer nmax
      parameter(nmax=10)
      real*8 soft,xl,ll2,soft1,soft2
      real*8 xq(6),mif(6),ps(4,6),xsinv(6,6),xqs(6),mifs(6)
      real*8 p(4,nmax),sinv(nmax,nmax)
      real*8 b(4,2),bh(4,2)
      real*8 bon(4,2),pson(4,nmax),sinvo(nmax,nmax)
      real*8 pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2,
     $     mw,mw2,gw,mz,mz2,gz,mh,mh2,
     $     mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
      complex*16 ieps,spence

      common/fident/mif
      common/par_config/p,sinv
      common/par_beam/b,bh
      common/paron_config/bon,pson,sinvo
      common/param/pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2,
     $     mw,mw2,gw,mz,mz2,gz,mh,mh2,
     $     mxe,mxe2,ml,ml2,mqp,mqp2,mqm,mqm2
      common/rcoptions/qborn,qreal,qqcd,qbos,qferm,qsoft,qnf,qfast
      common/processtype/type,nc,cc,sym,perm
        
      soft=0d0
      soft1=0d0
      soft2=0d0
      ieps=dcmplx(0d0,1d-10)
      if (onoff.eq.0) then
         do i=1,4
            ps(i,1)=b(i,1)
            ps(i,2)=b(i,2)
            ps(i,3)=p(i,1)
            ps(i,4)=p(i,2)
            ps(i,5)=p(i,3)
            ps(i,6)=p(i,4)
         end do
         do i=1,6
            do j=i+1,6
               xsinv(i,j)=sinv(i,j)
               xsinv(j,i)=sinv(j,i)
            end do
         end do
      else if (onoff.eq.1) then
         do i=1,4
            ps(i,1)=bon(i,1)
            ps(i,2)=bon(i,2)
            ps(i,3)=pson(i,1)
            ps(i,4)=pson(i,2)
            ps(i,5)=pson(i,3)
            ps(i,6)=pson(i,4)
         end do
         do i=1,6
            do j=i+1,6
               xsinv(i,j)=sinvo(i,j)
               xsinv(j,i)=sinvo(j,i)
            end do
         end do
      end if
      if (sn.eq.1.or.sn.eq.3) then
c real IR singular photon contribution:
         do i=1,6
            do j=i+1,6
               if (xq(i)*xq(j).ne.0d0)
     $              soft1=soft1-(-1d0)**(i+j)*xq(i)*xq(j)*
     $              (xl*(-2d0+
     $              dlog(xsinv(i,j)**2/mif(i)**2/mif(j)**2))+
     $              dlog(4d0*ps(4,i)*ps(4,j)/mif(i)/mif(j))-
     $              dlog(4d0*ps(4,i)**2/mif(i)**2)**2/4d0-
     $              dlog(4d0*ps(4,j)**2/mif(j)**2)**2/4d0-
     $              pi**2/3d0-dreal(spence(1d0-
     $              4d0*ps(4,j)*ps(4,i)/dabs(xsinv(i,j))+ieps)))
            end do
         end do
      end if
      if (sn.eq.2.or.sn.eq.3) then
         do i=1,6
            xqs(i)=xq(i)
            mifs(i)=mif(i)
         end do
         if (onoff.eq.1.and.cc.eq.1.and.nc.eq.1.and.
     $        (sym.eq.0.or.sym.eq.3)) then
            xqs(4)=xq(6)
            xqs(6)=xq(4)
            mifs(4)=mif(6)
            mifs(6)=mif(4)
         end if
c virtual IR singular photon contribution (YFS+additional log(m)!):
         do i=1,6
            do j=i+1,6
               k=1
               if (i.eq.1.and.j.ne.2) k=0 
               if (i.eq.2) k=0 
               if (xqs(i)*xqs(j).ne.0d0)
     $              soft2=soft2-(-1d0)**(i+j)*xqs(i)*xqs(j)*
     $              (dlog(ll2/dabs(xsinv(i,j)))*(-2d0+
     $              dlog(xsinv(i,j)**2/mifs(i)**2/mifs(j)**2))+
     $              dlog(mifs(i)/mifs(j))**2+
     $              dlog(dabs(xsinv(i,j))/mifs(i)/mifs(j))**2+
     $              dlog(dabs(xsinv(i,j))/mifs(i)/mifs(j))+
     $              pi**2/3d0+k*pi**2-2d0)/2d0
            end do
         end do
      end if
      soft=alpha0/pi*(soft1+soft2)
      return
      end
c*********************************************************************
      subroutine softgfac(sn,onoff,xq,xl,ll2,softg)
c*********************************************************************
      implicit none
      integer i,j,sn,onoff
      integer qborn,qreal,qqcd,qbos,qferm,qsoft,qnf,qfast
      integer type,nc,cc,sym,perm
      integer nmax
      parameter(nmax=10)
      real*8 softg,xl,ll2,softg1,softg2
      real*8 xq(6),mif(6),ps(4,6),xsinv(6,6)
      real*8 p(4,nmax),sinv(nmax,nmax)
      real*8 b(4,2),bh(4,2)
      real*8 bon(4,2),pson(4,nmax),sinvo(nmax,nmax)
      real*8 pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2,
     $     mw,mw2,gw,mz,mz2,gz,mh,mh2,
     $     mxe,mxe2,ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
      complex*16 ieps,spence

      common/fident/mif
      common/par_config/p,sinv
      common/par_beam/b,bh
      common/paron_config/bon,pson,sinvo
      common/param/pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2,
     $     mw,mw2,gw,mz,mz2,gz,mh,mh2,
     $     mxe,mxe2,ml,ml2,mqp,mqp2,mqm,mqm2
      common/rcoptions/qborn,qreal,qqcd,qbos,qferm,qsoft,qnf,qfast
      common/processtype/type,nc,cc,sym,perm
        
      softg=0d0
      softg1=0d0
      softg2=0d0
      ieps=dcmplx(0d0,1d-10)
      if (onoff.eq.0) then
         do i=1,4
            ps(i,1)=b(i,1)
            ps(i,2)=b(i,2)
            ps(i,3)=p(i,1)
            ps(i,4)=p(i,2)
            ps(i,5)=p(i,3)
            ps(i,6)=p(i,4)
         end do
         do i=1,6
            do j=i+1,6
               xsinv(i,j)=sinv(i,j)
               xsinv(j,i)=sinv(j,i)
            end do
         end do
      else if (onoff.eq.1) then
         do i=1,4
            ps(i,1)=bon(i,1)
            ps(i,2)=bon(i,2)
            ps(i,3)=pson(i,1)
            ps(i,4)=pson(i,2)
            ps(i,5)=pson(i,3)
            ps(i,6)=pson(i,4)
         end do
         do i=1,6
            do j=i+1,6
               xsinv(i,j)=sinvo(i,j)
               xsinv(j,i)=sinvo(j,i)
            end do
         end do
      end if
      if (sn.eq.1.or.sn.eq.3) then
c real IR singular gluon contribution:
         do i=3,5,2
            j=i+1
            if (cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3)) then
               if (i.eq.3) j=6
               if (i.eq.5) j=4
            end if
            if ((xq(i).ne.0d0.and.xq(i).ne.-1d0).and.
     $           (xq(j).ne.0d0.and.xq(j).ne.-1d0))
     $           softg1=softg1+
     $           (xl*(-2d0+
     $           dlog(xsinv(i,j)**2/mif(i)**2/mif(j)**2))+
     $           dlog(4d0*ps(4,i)*ps(4,j)/mif(i)/mif(j))-
     $           dlog(4d0*ps(4,i)**2/mif(i)**2)**2/4d0-
     $           dlog(4d0*ps(4,j)**2/mif(j)**2)**2/4d0-
     $           pi**2/3d0-dreal(spence(1d0-
     $           4d0*ps(4,j)*ps(4,i)/dabs(xsinv(i,j))+ieps)))
         end do
      end if
      if (sn.eq.2.or.sn.eq.3) then
c virtual IR singular gluon contribution:
         do i=3,5,2
            j=i+1
            if (cc.eq.1.and.nc.eq.1.and.(sym.eq.0.or.sym.eq.3)) then
               if (i.eq.3) j=6
               if (i.eq.5) j=4
            end if
            if ((xq(i).ne.0d0.and.xq(i).ne.-1d0).and.
     $           (xq(j).ne.0d0.and.xq(j).ne.-1d0))
     $           softg2=softg2+     
     $           (dlog(ll2/dabs(xsinv(i,j)))*(-2d0+
     $           dlog(xsinv(i,j)**2/mif(i)**2/mif(j)**2))+
     $           dlog(mif(i)/mif(j))**2+
     $           dlog(dabs(xsinv(i,j))/mif(i)/mif(j))**2+
     $           dlog(dabs(xsinv(i,j))/mif(i)/mif(j))+
     $           4d0*pi**2/3d0-4d0)/2d0
         end do
      end if
      softg=alphas/pi*4d0/3d0*(softg1+softg2)
      return
      end
c**********************************************************************
      double precision function struci(xx,dxx,l,bet,xalp)
      implicit none
      real*8 xx,l,bet,xalp,pi
      real*8 ge,gam,gamf,lxx,dxx
      complex*16 spence,ieps
      ieps=dcmplx(0d0,1d-20)
      pi=4d0*datan(1d0)
      ge=0.5772115664901532d0
      gam=gamf(1d0+bet)
      if (dabs(dxx).lt.1d-15) then
         lxx=-1d0-dxx/2.d0-dxx**2/3.d0-dxx**3/4.d0
c         lxx=-1d0
      else
         lxx=dlog(xx)/(dxx)
      end if
c      struci=dexp(bet*(-ge+3d0/4d0))/gam*bet
c     $     +(-bet/2d0*(1d0+xx)
c     $     -bet**2/8d0*((1d0+3d0*xx*xx)*lxx
c     $     +4d0*(1d0+xx)*dlog(dxx)+5d0+xx))*(dxx)**(1d0-bet)
      struci=dexp(bet*(-ge+3d0/4d0))/gam*bet
     $     +(-bet/2d0*(1d0+xx)
     $     -bet**2/8d0*((1d0+3d0*xx*xx)*lxx
     $     +4d0*(1d0+xx)*dlog(dxx)+5d0+xx)
     $     -bet**3/48d0*((1d0+xx)*(6d0*dreal(spence(xx+ieps))
     $     +12d0*dlog(dxx)**2-3d0*pi**2)
     $     +3d0/2d0*(1d0+8d0*xx+3d0*xx**2)*lxx+6d0*(xx+5d0)*dlog(dxx)
     $     +12d0*(1d0+xx**2)*dlog(dxx)*lxx
     $     -(1d0+7d0*xx**2)/2d0*lxx*dlog(xx)
     $     +(15d0*xx+39d0)/4d0))*(dxx)**(1d0-bet)
c test: YFS exponentiation:
c      struci=dexp(-bet*ge)/gam*bet
c     $     *dexp(xalp/pi*(l/2d0-1d0+pi**2/3d0))
c     $     *(1d0+bet/2d0+(xalp/pi*l)**2/2d0
c     $     -(1d0-xx**2)/2d0+xalp/pi*l*(-(1d0+3d0*xx**2)/4d0*dlog(xx)
c     $     -1d0+xx))
      end
c**********************************************************************
c gamma function
c copied form subtraction.f (M.Roth)
c**********************************************************************
      real*8 function gamf(x)
      implicit none
c local variable
      integer max
      parameter(max=10)
      real*8 x,omx,a(max),prod,pi
      integer i1
      pi=4d0*datan(1d0)
c a(1)=gammae
      data a/0.5772156649015328606d0,0d0,
     *       0.4006856343865314285d0,0d0,
     *       0.2073855510286739853d0,0d0,
     *       0.1440498967688461181d0,0d0,
     *       0.1113342658695646905d0,0d0/ 
c good convergence for small values of 1-x
      omx=x-1d0
      gamf=dexp(0.5d0*dlog(omx*pi/dsin(pi*omx)))
      do i1=1,max,2
        prod=dexp(-a(i1)*omx**i1)
        gamf=gamf*prod
        if(dabs(prod-1d0).lt.1d-10)return
      enddo
      write(*,'(a)')' gamma: converges badly'
      stop
      end
c*********************************************************************
      complex*16 function spence(xx)
c  the dilogarithm for general complex argument.
c  not allowed: real(xx) gt 1 with imag(xx)=0.
      implicit real*8(a-z)
      integer n
      complex*16 xx,x,z,d,p,cdlog
      dimension a(19)
      pi=4d0*datan(1d0)
      x=xx
      xr=dreal(x)
      xi=dimag(x)
      if(xr.ne.1.) goto 111
      if(xi.eq.0.) goto 20
 111  continue
c projection into the convergence radius
      vor=1.d0
      p=dcmplx(0.d0,0.d0)
      r=dreal(x)
      if (r .le. 0.5d0) goto 1
      p=pi*pi/6.d0- cdlog(x)*cdlog(1.d0-x)
      vor=-1.d0
      x=1.d0-x
 1    continue
      b=cdabs(x)
      if (b .lt. 1.d0) goto 2
      p=p - (pi*pi/6.d0+ cdlog(-x)*cdlog(-x)/2.d0)*vor
      vor=vor*(-1.d0)
      x=1.d0/x
 2    continue
c calculation of the spence function
      a(1)=1.d0
      a(2)=-0.5d0
      a(3)=1.d0/6.d0
      a(5)=-1.d0/30.d0
      a(7)=1.d0/42.d0
      a(9)=-1.d0/30.d0
      a(11)=5.d0/66.d0
      a(13)=-691.d0/2730.d0
      a(15)=7.d0/6.d0
      a(17)=-3617.d0/510.d0
      a(19)=43867.d0/798.d0
      do 5 n=2,9,1
         a(2*n)=0.d0
 5    continue
      z=(-1.d0)*cdlog(1.d0-x)
      d=dcmplx(a(19),0.d0)
      do 10 n=1,18,1
         d=d*z/(20.d0-n) + a(19-n)
 10   continue
      d=d*z
      spence=d*vor + p
      goto 30
 20   continue
      spence=pi*pi/6.d0
 30   continue
      return
      end
***************************************************************
      subroutine phspgen_4(idens,ii,mapi,vzi,nu,xs,x,wps,icut)
***************************************************************
c massless phase space generator!
c
c idens=0:
c input:
c npart: number of particles, npart=4
c x(3*npart-4): random numbers.
c
c output:
c p(4,npart): momenta of the particles (4 is the energy).
c
c idens=1:
c input:
c momenta and specification of channel
c
c output:
c wps: local weight of the phase space
c
c icut: when ccuts(2)=1, cuts are taken into account already in
c       the integration limits for t-channel decays.
c       When then tmax<tmin the event is rejected (icut=1).
c       When ccuts(1)=1, cuts are taken into account in
c       the integration limits of the s-invariants. When
c       s<scut, the event is rejected (icut=1).
c 
c	Doreen Wackeroth 07/28/00 (new version)
********************************************************
      implicit none
      integer i,ii(5),mapi(8),icut,ccuts(3),icoll,dpa,idens
      integer quark(6),qprop,iso(6),gen(6),dir(7),pol(7),color
      integer aflag
      integer nmax
      integer srecomb,srecombg,scuts
      integer iout
      parameter(nmax=10)
      real*8 x(8),xc
      real*8 alam,alam1,wps,wpsi(6)
      real*8 s1,rs1,s2,rs2,xs,s,rs,ss
      real*8 s1min,s2min,smax,smin
      real*8 ph1,ct1,st1
      real*8 ph2,ct2,st2
      real*8 ph,ct,st
      real*8 st1s,ct1s,st2s,ct2s
      real*8 k10,k1b,k20,k2b,g10,g20,pi10,pi20,pi30,pi40,g1,g2
      real*8 pa10,pa20
      real*8 nu(8),tp,tm,xt,t,t1,t2,vzi(3)
      real*8 q(6),mv(3),mv2(3),gv(3),qcdfac,qcdfac2
      real*8 pi,mww,mzz,gww,gzz
      real*8 checkx,checky,checkz,checke
      real*8 p(4,nmax),sinv(nmax,nmax)
      real*8 b(4,2),bh(4,2)
      real*8 ecut(7),scut(7,7),ccut(7,7),precomb(4),precombg(2)
      complex*16 cvf(-1:1,3,6),cvw(2)
      character*6 fname(6),dfname(6)
c
c common blocks 
c
      common/par_in/mww,mzz,gww,gzz
      common/config_cuts/ccuts
      common/cuts/ecut,scut,ccut,precomb,precombg,scuts,
     $     srecomb,srecombg
      common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     $     q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
      common/inicoll/icoll
      common/dpa_para/dpa
      common/xxc/xc
      common/par_config/p,sinv
      common/par_beam/b,bh
      common/negalam/aflag
      common/outi/iout
c
c initialization:
c
      s1min=0d0
      s2min=0d0
      smin=0d0
      smax=0d0
      wps=1d0
      do i=1,6
         wpsi(i)=1d0
      end do
      pi=4d0*datan(1d0)
      
      s=xs
      rs=dsqrt(s)
c
c a-priori the event is fine:
c
      if (idens.eq.0) icut=0
c
c additional mapping for initial state collinear factor:
c
      if (icoll.eq.1) then
         smax=s
c         smin=2d0*ecut(7)*rs-ecut(7)**2
         smin=2d0*ecut(7)*rs
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or. 
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning41:',smin,smax
               return
            end if
            call smap(mapi(7),xc,smin,smax,nu(7),ss)
         end if
         if (idens.eq.1) then
            ss=s-sinv(1,2)
            call sdens(mapi(7),smin,smax,ss,nu(7),wpsi(6))
         end if
         if (ss.lt.smin.and.iout.ne.0) write(iout,*)'sflag7'
         s=s-ss
         rs=dsqrt(s)
         if (dpa.eq.1.and.idens.eq.0.and.rs.le.2d0*mww) then
            icut=1
            return
         end if
      end if

      if (mapi(6).eq.1) then
c     
c DPA approximation:
c
         if (dpa.eq.1) then
            s1=mww*mww
            s2=s1
            rs1=dsqrt(s1)
            rs2=dsqrt(s2)
            goto 5
         end if
c cuts:
         if (ccuts(1).eq.1) then
            s1min=scut(ii(1)+2,ii(2)+2)
            if (s1min.eq.0d0)
     $           s1min=2d0*ecut(ii(1)+2)
     $           *ecut(ii(2)+2)*(1d0-ccut(ii(1)+2,ii(2)+2))
            s2min=scut(ii(3)+2,ii(4)+2)
            if (s2min.eq.0d0)
     $           s2min=2d0*ecut(ii(3)+2)
     $           *ecut(ii(4)+2)*(1d0-ccut(ii(3)+2,ii(4)+2))
         end if
	   
         smin=s1min
         smax=s-2d0*rs*dsqrt(s2min)+s2min
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning42:',smin,smax
               return
            end if
            call smap(mapi(1),x(1),smin,smax,nu(1),s1)
         end if
         if (idens.eq.1) then
            s1=sinv(ii(1)+2,ii(2)+2)
            call sdens(mapi(1),smin,smax,s1,nu(1),wpsi(1))
         end if
         rs1=dsqrt(s1)
         if (s1.lt.smin.and.iout.ne.0) write(iout,*)'sflag1'
         
         smin=s2min
         smax=s+s1-2d0*rs1*rs
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning43:',smin,smax
               return
            end if
            call smap(mapi(2),x(2),smin,smax,nu(2),s2)
         end if
         if (idens.eq.1) then
            s2=sinv(ii(3)+2,ii(4)+2)
            call sdens(mapi(2),smin,smax,s2,nu(2),wpsi(2))
         end if
         rs2=dsqrt(s2)
         if (s2.lt.smin.and.iout.ne.0) write(iout,*)'sflag2'

 5       continue
           
c decay: a+b->k1+k2: mapi(3)=0, s-channel, mapi(3)>=1: t-channel
         k10=(s+s1-s2)/2d0/rs
         alam1=alam(rs,rs1,rs2)
         if (aflag.eq.1) then
            if (idens.eq.0) then
               if (iout.ne.0) write(iout,*)'alam negative'
               icut=1
               return
            end if
         end if
         k1b=alam1/2d0/rs
         k20=(s+s2-s1)/2d0/rs
         k2b=k1b
         g10=k10/rs1
         g1=k1b/rs1
         g20=k20/rs2
         g2=k2b/rs2
c s-channel:
         if (mapi(3).eq.0) then
            if (mapi(4).gt.0.and.iout.ne.0)
     $           write(iout,*)'warning: mapi(4) must be 0 !'
            if (idens.eq.0) then
               ct=2d0*x(3)-1d0
               st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            end if
            if (idens.eq.1)
     $           wpsi(3)=alam1/8d0/s*4d0*pi
            goto 10
         end if
c t-channel:
         tm=-(s1-s+s2+alam1)/2d0
         tp=-(s1-s+s2-alam1)/2d0
         if (tm.le.-1d-5.or.tp.le.-1d-5.and.iout.ne.0) 
     $        write(iout,*)'41,1',tm,tp
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning41:',tm,tp
               return
            end if
            call tmap(mapi(3),x(3),tm,tp,nu(3),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'41,2',xt
            t=-xt
            ct=(2d0*t-s1+s-s2)/alam1
            st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            goto 10
         end if
         if (idens.eq.1) then
            xt=-(s1-sinv(1,ii(1)+2)-sinv(1,ii(2)+2))
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'d41,2',xt
            t=-xt
            call tdens(mapi(3),tm,tp,xt,nu(3),wpsi(3))
            wpsi(3)=wpsi(3)/4d0/s*2d0*pi
         end if
 10      continue

c decay: k1->pi1+pi2: mapi(4)=0, s-channel, mapi(4)>=1: t-channel
         pi10=rs1/2d0
         pi20=pi10
c s-channel:
         if (mapi(4).eq.0) then
            if (idens.eq.0) then
               ct1=2d0*x(4)-1d0
               st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            end if
            if (idens.eq.1) wpsi(4)=1d0/8d0*4d0*pi
            goto 20
         end if
         if (mapi(3).eq.0.and.iout.ne.0)
     $        write(iout,*)'warning: mapi(3) must be 1,2 !'
c t-channel: (t1=(pa-p1)**2 in the rest frame k1=pa+q=0)
         pa10=(s1-t)/2d0/rs1
         tm=0d0
         tp=s1-t
c cuts:
         if (ccuts(2).eq.1) then
            tm=2d0*bh(4,1)*ecut(ii(1)+2)*(1d0-ccut(1,ii(1)+2))
         end if
         if (tp.le.-1d-5.and.iout.ne.0) write(iout,*)'41,3',tp
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning42:',tm,tp
               return
            end if
            call tmap(mapi(4),x(4),tm,tp,nu(4),xt)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'41,4',xt
            t1=-xt
            ct1=(2d0*t1+s1-t)/(s1-t)
            st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            goto 20
         end if
         if (idens.eq.1) then
            xt=sinv(1,ii(1)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d41,4',xt
            call tdens(mapi(4),tm,tp,xt,nu(4),wpsi(4))
            wpsi(4)=wpsi(4)/4d0/(s1-t)*2d0*pi
         end if
 20      continue

c decay: k2->pi3+pi4: mapi(5)=0, only s-channel !
         if (mapi(5).gt.0.and.iout.ne.0)
     $        write(iout,*)'warning: mapi(5) must be 0 !'
         pi30=rs2/2d0
         pi40=pi30
c s-channel:
         if (idens.eq.0) then
            ct2=2d0*x(5)-1d0
            st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))
            goto 30
         end if
         if (idens.eq.1) then
            wpsi(5)=1d0/8d0*4d0*pi 
            do i=1,6
               wps=wps/wpsi(i)
            end do
            goto 200
         end if
 30      continue

         ph1=2d0*pi*x(6)
         ph2=2d0*pi*x(7)
         ph=2d0*pi*x(8)

         p(1,ii(1))=pi10*st1*dcos(ph1)
         p(2,ii(1))=pi10*st1*dsin(ph1)
         p(3,ii(1))=pi10*ct1
         p(4,ii(1))=pi10
         p(1,ii(2))=-pi20*st1*dcos(ph1)
         p(2,ii(2))=-pi20*st1*dsin(ph1)
         p(3,ii(2))=-pi20*ct1
         p(4,ii(2))=pi20
         if (mapi(4).gt.0) then
            st1s=-rs/2d0*st/pa10
            ct1s=rs/2d0*(g10*ct-g1)/pa10
            call rotation_1(1d0,st1s,ct1s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st1s,ct1s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g10,g1,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(1d0,st,ct,dsin(ph),dcos(ph),
     $        p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g10,g1,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(1d0,st,ct,dsin(ph),dcos(ph),
     $        p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))

         p(1,ii(3))=pi30*st2*dcos(ph2)
         p(2,ii(3))=pi30*st2*dsin(ph2)
         p(3,ii(3))=pi30*ct2
         p(4,ii(3))=pi30
         p(1,ii(4))=-pi40*st2*dcos(ph2)
         p(2,ii(4))=-pi40*st2*dsin(ph2)
         p(3,ii(4))=-pi40*ct2
         p(4,ii(4))=pi40
         call boost_z(g20,g2,p(4,ii(3)),p(3,ii(3)))
         call rotation_2(-1d0,st,ct,dsin(ph),dcos(ph),
     $        p(1,ii(3)),p(2,ii(3)),p(3,ii(3)))
         call boost_z(g20,g2,p(4,ii(4)),p(3,ii(4)))
         call rotation_2(-1d0,st,ct,dsin(ph),dcos(ph),
     $        p(1,ii(4)),p(2,ii(4)),p(3,ii(4)))
         goto 100
      end if
	
      if (mapi(6).eq.2) then  
c cuts:
         if (ccuts(1).eq.1) then
            s1min=scut(ii(1)+2,ii(2)+2)
            if (s1min.eq.0d0)
     $           s1min=2d0*ecut(ii(1)+2)
     $           *ecut(ii(2)+2)*(1d0-ccut(ii(1)+2,ii(2)+2))
         end if
         
         smin=s1min
         smax=s
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning44:',smin,smax
               return
            end if
            call smap(mapi(1),x(1),smin,smax,nu(1),s1)
         end if
         if (idens.eq.1) then 
            s1=sinv(ii(1)+2,ii(2)+2)
            call sdens(mapi(1),smin,smax,s1,nu(1),wpsi(1))
         end if
         rs1=dsqrt(s1)

         smin=s1
         smax=s
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or. 
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning45:',smin,smax
               return
            end if
            call smap(mapi(2),x(2),smin,smax,nu(2),s2)
         end if
         if (idens.eq.1) then
            s2=s-sinv(1,ii(4)+2)-sinv(2,ii(4)+2)
            call sdens(mapi(2),smin,smax,s2,nu(2),wpsi(2))
         end if
         rs2=dsqrt(s2)

c decay: a+b->k2+pi4: mapi(3)=0, s-channel, mapi(3)>=1: t-channel
         k20=(s+s2)/2d0/rs
         k2b=dabs(s-s2)/2d0/rs
         g20=k20/rs2
         g2=k2b/rs2
         pi40=k2b
c s-channel:
         if (mapi(3).eq.0) then
            if (mapi(4).gt.0.or.mapi(5).gt.0.and.iout.ne.0)
     $           write(iout,*)'warning: mapi(4,5) must be 0 !'
            if (idens.eq.0) then
               ct=2d0*x(3)-1d0
               st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            end if
            if (idens.eq.1) wpsi(3)=dabs(s-s2)/8d0/s*4d0*pi
            goto 40
         end if
c t-channel:
         tm=0d0
         tp=s-s2
c cuts:
         if (ccuts(2).eq.1) then
            tm=2d0*bh(4,1)*ecut(ii(4)+2)*(1d0-ccut(1,ii(4)+2))
         end if
         if (tp.le.-1d-5.and.iout.ne.0) write(iout,*)'42,1',tp
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning43:',tm,tp
               return
            end if
            call tmap(mapi(3),x(3),tm,tp,nu(3),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'42,2',vzi(1),xt
            t=-xt
            ct=(2d0*t-s2+s)/(s-s2)
            st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            goto 40
         end if
         if (idens.eq.1) then
            if (vzi(1).gt.0d0) xt=sinv(2,ii(4)+2)
            if (vzi(1).lt.0d0) xt=sinv(1,ii(4)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d42,2',vzi(1),xt
            t=-xt
            call tdens(mapi(3),tm,tp,xt,nu(3),wpsi(3))
            wpsi(3)=wpsi(3)/4d0/s*2d0*pi
         end if
 40      continue

c decay: k2->k1+pi3: mapi(4)=0, s-channel, mapi(4)>=1: t-channel
c always vzi(1)=+1:
         k10=(s2+s1)/2d0/rs2
         k1b=dabs(s2-s1)/2d0/rs2
         g10=k10/rs1
         g1=k1b/rs1
         pi30=k1b
c s-channel:
         if (mapi(4).eq.0) then
            if (mapi(5).gt.0.and.iout.ne.0) 
     $           write(iout,*)'warning: mapi(5) must be 0!'
            if (idens.eq.0) then
               ct1=2d0*x(4)-1d0
               st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            end if
            if (idens.eq.1) wpsi(4)=dabs(s2-s1)/s2/8d0*4d0*pi
            goto 50
         end if
c t-channel:
         if (iout.ne.0) then
         if (vzi(1).lt.0d0) 
     $        write(iout,*)'warning: vzi(1) must be +1!'
         if (mapi(3).eq.0.or.mapi(2).gt.0) 
     $        write(iout,*)'warning: mapi(3,2) must be 1(or 2) and 0!'
         end if
         pa10=(s2-t)/2d0/rs2
         if (vzi(2).gt.0d0) then
            tm=-(t*s1/s2)
            tp=-(s1-s2+t)
            if (tm.le.-1d-5.or.tp.le.-1d-5.and.iout.ne.0) 
     $           write(iout,*)'42,3',vzi(2),tm,tp
         end if
         if (vzi(2).lt.0d0) then
            tm=0d0
            tp=(s2-t)*(s2-s1)/s2
c cuts:
            if (ccuts(2).eq.1) then
               tm=2d0*bh(4,1)*ecut(ii(3)+2)*(1d0-ccut(1,ii(3)+2))
            end if
            if (tp.le.-1d-5.and.iout.ne.0) 
     $           write(iout,*)'42,3',vzi(2),tp
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning44:',tm,tp
               return
            end if
            call tmap(mapi(4),x(4),tm,tp,nu(4),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'42,4',vzi(2),xt
            t1=-xt
            if (vzi(2).gt.0d0) ct1=(t1-s1+(s2-t)/rs2*k10)/
     $           k1b/(s2-t)*rs2
            if (vzi(2).lt.0d0) ct1=(t1+(s2-t)/rs2*pi30)/
     $           pi30/(s2-t)*rs2
            st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            goto 50
         end if
         if (idens.eq.1) then
            if (vzi(2).lt.0d0) xt=sinv(1,ii(3)+2)
            if (vzi(2).gt.0d0) 
     $           xt=-(s1-sinv(1,ii(1)+2)-sinv(1,ii(2)+2))
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'d42,4',vzi(2),xt
            t1=-xt
            call tdens(mapi(4),tm,tp,xt,nu(4),wpsi(4))
            wpsi(4)=wpsi(4)/4d0/(s2-t)*2d0*pi
         end if
 50      continue

c decay: k1->pi1+pi2: mapi(5)=0: s-channel, mapi(5)>=0: t-channel
c always vzi(1)=+1, vzi(2)=+1:
         pi10=rs1/2d0
         pi20=pi10
c s-channel:
         if (mapi(5).eq.0) then
            if (idens.eq.0) then
               ct2=2d0*x(5)-1d0
               st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))
            end if
            if (idens.eq.1) wpsi(5)=1d0/8d0*4d0*pi
            goto 60
         end if
c t-channel:
         if(iout.ne.0)then
         if (vzi(1).lt.0d0.or.vzi(2).lt.0d0) 
     $        write(iout,*)'warning: vzi(1,2) must be +1,+1!'
         if (mapi(3).eq.0.or.mapi(4).eq.0.or.mapi(2).gt.0.or.
     $        mapi(1).gt.0.and.iout.ne.0) write(iout,*)
     $        'warning: mapi(3,4,2,1) must be 1(or 2),1(or 2),0,0!'
         end if
         pa20=(s1-t1)/2d0/rs1
         tm=0d0
         tp=s1-t1
c cuts:
         if (ccuts(2).eq.1) then
            tm=2d0*bh(4,1)*ecut(ii(1)+2)*(1d0-ccut(1,ii(1)+2))
         end if
         if (tp.le.-1d-5.and.iout.ne.0) write(iout,*)'42,5',tp
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning45:',tm,tp
               return
            end if
            call tmap(mapi(5),x(5),tm,tp,nu(5),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'42,6',xt
            t2=-xt
            ct2=(2d0*t2+s1-t1)/(s1-t1)
            st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))
            goto 60
         end if
         if (idens.eq.1) then
            xt=sinv(1,ii(1)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d42,6',xt
            call tdens(mapi(5),tm,tp,xt,nu(5),wpsi(5))
            wpsi(5)=wpsi(5)/4d0/(s1-t1)*2d0*pi
         end if
 60      continue

         if (idens.eq.1) then
            do i=1,6
               wps=wps/wpsi(i)
            end do
            goto 200
         end if

         ph1=2d0*pi*x(6)
         ph2=2d0*pi*x(7)
         ph=2d0*pi*x(8)

         p(1,ii(4))=-vzi(1)*pi40*st*dcos(ph)
         p(2,ii(4))=-vzi(1)*pi40*st*dsin(ph)
         p(3,ii(4))=-vzi(1)*pi40*ct
         p(4,ii(4))=pi40
         
         p(1,ii(3))=-vzi(2)*pi30*st1*dcos(ph1)
         p(2,ii(3))=-vzi(2)*pi30*st1*dsin(ph1)
         p(3,ii(3))=-vzi(2)*pi30*ct1
         p(4,ii(3))=pi30
         if (mapi(4).gt.0) then
            st1s=-rs/2d0*st/pa10
            ct1s=rs/2d0*(g20*ct-g2)/pa10
            call rotation_1(1d0,st1s,ct1s,p(1,ii(3)),p(3,ii(3)))
         end if
         call boost_z(g20,g2,p(4,ii(3)),p(3,ii(3)))
         call rotation_2(vzi(1),st,ct,dsin(ph),dcos(ph),
     $        p(1,ii(3)),p(2,ii(3)),p(3,ii(3)))

         p(1,ii(1))=pi10*st2*dcos(ph2)
         p(2,ii(1))=pi10*st2*dsin(ph2)
         p(3,ii(1))=pi10*ct2
         p(4,ii(1))=pi10
         p(1,ii(2))=-pi20*st2*dcos(ph2)
         p(2,ii(2))=-pi20*st2*dsin(ph2)
         p(3,ii(2))=-pi20*ct2
         p(4,ii(2))=pi20
         if (mapi(5).gt.0) then
            st2s=-pa10*st1/pa20
            ct2s=pa10*(g10*ct1-g1)/pa20
            call rotation_1(1d0,st2s,ct2s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st2s,ct2s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g10,g1,p(4,ii(1)),p(3,ii(1)))
         call boost_z(g10,g1,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(vzi(2),st1,ct1,dsin(ph1),dcos(ph1),
     $        p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call rotation_2(vzi(2),st1,ct1,dsin(ph1),dcos(ph1),
     $        p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))
         if (mapi(4).gt.0) then
            call rotation_1(1d0,st1s,ct1s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st1s,ct1s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g20,g2,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(vzi(1),st,ct,dsin(ph),dcos(ph),
     $        p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g20,g2,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(vzi(1),st,ct,dsin(ph),dcos(ph),
     $        p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))
      end if
 100  continue
c
c beam momenta:
c
      b(1,1)=0.d0
      b(2,1)=0.d0
      b(3,1)=rs/2d0
      b(4,1)=rs/2d0
      b(1,2)=0.d0
      b(2,2)=0.d0
      b(3,2)=-rs/2d0
      b(4,2)=rs/2d0
c
c check of four-momentum conservation:	
c
      if (iout.ne.0) then
      checkx=b(1,1)+b(1,2)-(p(1,ii(4))+p(1,ii(3))
     $     +p(1,ii(1))+p(1,ii(2)))
      if (dabs(checkx).gt.1d-10) 
     $     write(iout,*)'warning: x-comp. is not conserved',
     $     checkx
      checky=b(2,1)+b(2,2)-(p(2,ii(4))+p(2,ii(3))
     $     +p(2,ii(1))+p(2,ii(2)))
      if (dabs(checky).gt.1d-10) 
     $     write(iout,*)'warning: y-comp. is not conserved',
     $     checky
      checkz=b(3,1)+b(3,2)-(p(3,ii(4))+p(3,ii(3))
     $     +p(3,ii(1))+p(3,ii(2)))
      if (dabs(checkz).gt.1d-10) 
     $     write(iout,*)'warning: z-comp. is not conserved',
     $     checkz
      checke=b(4,1)+b(4,2)-(p(4,ii(4))+p(4,ii(3))
     $     +p(4,ii(1))+p(4,ii(2)))
      if (dabs(checke).gt.1d-10) 
     $     write(iout,*)'warning: energy is not conserved',
     $     checke,b(4,1)+b(4,2)
      end if
 200  continue
      return
      end
********************************************************
      subroutine smap(map,xx,smin,smax,xnu,xs)
********************************************************
      implicit none
      integer map
      real*8 y1,y2,ybw,mv,gamv,xx,smin,smax,xs,xnu,xne,a,ydiff
      real*8 pi,mww,mzz,gww,gzz
      common/par_in/mww,mzz,gww,gzz
	
      a=1d-5
      xne=1d0-xnu
      if (map.eq.0) then
         xs=smax*xx+(1d0-xx)*smin
         goto 10
      end if
      if (map.eq.1) then
         if (dabs(xne).gt.1d-10) then
c           if (smin.gt.1d-5.and.smax.gt.1d-5) a=0d0
            xs=((a+smax)**xne*xx
     $           +(1d0-xx)*(a+smin)**xne)**(1d0/xne)-a
         else
c	      if (smin.gt.1d-5.and.smax.gt.1d-5) a=0d0
            xs=dexp(dlog(a+smax)*xx+(1d0-xx)*dlog(a+smin))-a
         end if
         goto 10
      end if
      if (map.eq.2) then
         mv=mww
         gamv=gww
      end if
      if (map.eq.3) then
         mv=mzz
         gamv=gzz
      end if
      y1=(smin-mv**2)/mv/gamv
      y2=(smax-mv**2)/mv/gamv
      ydiff=datan((smax-smin)/mv/gamv/(1d0+y1*y2))
      pi=4d0*datan(1d0)
      if (y2.gt.0d0.and.y1*y2.lt.-1d0) ydiff=ydiff+pi
      if (y2.lt.0d0.and.y1*y2.lt.-1d0) ydiff=ydiff-pi
      ybw=datan(y1)+xx*ydiff
      xs=dtan(ybw)*mv*gamv+mv**2
 10   continue
      xs=dabs(xs)
      return
      end
********************************************************
      subroutine tmap(map,xx,tmin,tmax,xnu,xt)
********************************************************
      implicit none
      real*8 xx,tmin,tmax,xt,xnu,xne,a
      integer map
      
      tmin=dabs(tmin)
      tmax=dabs(tmax)
      a=1d-5
      xne=1d0-xnu
      if (map.eq.1) xt=tmax*xx+(1d0-xx)*tmin
      if (map.eq.2) then
         if (dabs(xne).gt.1d-10) then
c     if (tmin.gt.1d-5.and.tmax.gt.1d-5) a=0d0
            xt=((a+tmax)**xne*xx
     $           +(1d0-xx)*(a+tmin)**xne)**(1d0/xne)-a
         else
c	      if (tmin.gt.1d-5.and.tmax.gt.1d-5) a=0d0
            xt=dexp(dlog(a+tmax)*xx+(1d0-xx)*dlog(a+tmin))-a
         end if
      end if
      return
      end
********************************************************
      real*8 function alam(xm,xm1,xm2)
********************************************************
      implicit none
      real*8 xm,xm1,xm2
      real*8 s,s1,s2
      real*8 aux
      integer aflag,iout
      common/negalam/aflag
      common/outi/iout
      s=xm**2
      s1=xm1**2
      s2=xm2**2
      aux=s**2+s1**2+s2**2-2d0*s*s1-2d0*s*s2-2d0*s1*s2
      aflag=0
      if(aux.lt.0.d0) then
         if(iout.ne.0)write(iout,*)'warning:aux in alam negative'
     $        ,aux,xm,xm1,xm2
         aflag=1
      end if
      alam=dsqrt(dabs(aux))
      return
      end	
********************************************************
      subroutine boost_z(ecm,pcm,p4,p3)
********************************************************
c this subroutine performs a boost along the z direction
********************************************************
      implicit none
      real*8 ecm,pcm,p4,p3
      real*8 gamma,bgamma,E,Pp
      gamma=ecm
      bgamma=pcm
      E=p4
      Pp=p3
      p4=gamma*E+bgamma*Pp
      p3=gamma*Pp+bgamma*E 
      return
      end
********************************************************
      subroutine rotation_1(vz,st,ct,p1,p3)
********************************************************
c this subroutine performs a rotation
********************************************************
      implicit none
      real*8 st,ct,p1,p3
      real*8 p1s,p3s,vz
      p1s=p1
      p3s=p3
      p1=vz*(ct*p1s+st*p3s)
      p3=vz*(-st*p1s+ct*p3s)
      return
      end
********************************************************
      subroutine rotation_2(vz,st,ct,sp,cp,p1,p2,p3)
********************************************************
c this subroutine performs a rotation
********************************************************
      implicit none
      real*8 st,ct,sp,cp,p1,p2,p3
      real*8 p1s,p2s,p3s,vz
      p1s=p1
      p2s=p2
      p3s=p3
      p1=vz*(cp*(ct*p1s+st*p3s)-sp*p2s)
      p2=vz*(sp*(ct*p1s+st*p3s)+cp*p2s)
      p3=vz*(-st*p1s+ct*p3s)
      return
      end
*****************************************************************
      subroutine sdens(map,smin,smax,xs,xnu,xwps)
*****************************************************************
      implicit none
      integer map,iout
      real*8 y1,y2,mv,gamv,smin,smax,xs,xwps,xnu,xne,a,ydiff
      real*8 pi,mww,mzz,gww,gzz
      common/par_in/mww,mzz,gww,gzz
      common/outi/iout
      a=1d-5
      xne=1d0-xnu
      if (xs.lt.smin.or.xs.gt.smax.and.iout.ne.0) 
     $     write(iout,*)'warning,sdens',xs,smin,smax
      if (map.eq.0) then
         xwps=smax-smin
         goto 10
      end if
      if(map.eq.1) then
         if (dabs(xne).gt.1d-10) then
c	      if (smin.gt.1d-5.and.smax.gt.1d-5) a=0d0
            xwps=(a+xs)**xnu*((a+smax)**xne-(a+smin)**xne)/xne
         else
c	      if (smin.gt.1d-5.and.smax.gt.1d-5) a=0d0
            xwps=(a+xs)*dlog((a+smax)/(a+smin))
         end if
         goto 10
      end if
      if (map.eq.2) then
         mv=mww
         gamv=gww
      end if
      if (map.eq.3) then
         mv=mzz
         gamv=gzz
      end if
      y1=(smin-mv**2)/mv/gamv
      y2=(smax-mv**2)/mv/gamv
      ydiff=datan((smax-smin)/mv/gamv/(1d0+y1*y2))
      pi=4d0*datan(1d0)
      if (y2.gt.0d0.and.y1*y2.lt.-1d0) ydiff=ydiff+pi
      if (y2.lt.0d0.and.y1*y2.lt.-1d0) ydiff=ydiff-pi
      xwps=ydiff*((xs-mv**2)**2+mv**2*gamv**2)/mv/gamv
 10   continue
      return
      end
******************************************************************
      subroutine tdens(map,tmin,tmax,xt,xnu,xwps)
******************************************************************
      implicit none
      integer map,iout
      real*8 tmin,tmax,xt,xwps,xnu,xne,a
      common/outi/iout
      a=1d-5
      xne=1d0-xnu
      tmin=dabs(tmin)
      tmax=dabs(tmax)
      xt=dabs(xt)
      if (xt.lt.tmin.or.xt.gt.tmax.and.iout.ne.0) 
     $     write(iout,*)'warning,tdens',xt,tmin,tmax
      if(map.eq.1) xwps=tmax-tmin
      if(map.eq.2) then
         if (dabs(xne).gt.1d-10) then
c	      if (tmin.gt.1d-5.and.tmax.gt.1d-5) a=0d0
            xwps=(a+xt)**xnu*((a+tmax)**xne-(a+tmin)**xne)/xne
         else
c	      if (tmin.gt.1d-5.and.tmax.gt.1d-5) a=0d0
            xwps=(a+xt)*dlog((a+tmax)/(a+tmin))
         end if
      end if
      return
      end
*****************************************************************
      subroutine phspgen_5(idens,ii,mapi,vzi,nu,xs,x,wps,icut)
*****************************************************************
c massless phase space generator !
c
c idens=0:
c input:
c x(3*npart-4): random numbers.
c ii(5),mapi(8),vzi(3),nu(3): specification of final state and
c                             mapping 
c xs: CM energy
c
c output:
c p(4,npart): momenta of the particles (4 is the energy).
c
c idens=1:
c input: 
c four-momenta and specification of final state and mapping
c
c output:
c wps: local weight of the phase space
c
c icut: when ccuts(2)=1, cuts are taken into account already in
c       the integration limits for t-channel decays.
c       When then tmax<tmin the event is rejected (icut=1).
c       When ccuts(1)=1, cuts are taken into account in
c       the integration limits of the s-invariants. When
c       s<scut, the event is rejected (icut=1).
c       When ccuts(3)=1, cuts on E_fb and cos theta(fb) are taken into
c       in the phase space generation where possible.
c 
c	Doreen Wackeroth 07/28/00 (new version)
******************************************************************
      implicit none
      integer i,ii(5),mapi(8),icut,ccuts(3),idens
      integer quark(6),qprop,iso(6),gen(6),dir(7),pol(7),color
      integer aflag
      integer nmax
      integer srecomb,srecombg,scuts
      integer iout
      parameter(nmax=10)
      real*8 x(11)
      real*8 alam,alam1,wps,wpsi(8)
      real*8 s2,rs2,s1,rs1,s,xs,rs,s3,rs3
      real*8 s1min,s2min,s3min,smin,smax
      real*8 ph2,ct2,st2
      real*8 ph1,ct1,st1
      real*8 ph,ct,st
      real*8 st1s,ct1s,st2s,ct2s,st3s,ct3s
      real*8 ph3,ct3,st3
      real*8 pa10,pa20,pa30
      real*8 g10,g20,g1,g2,g30,g3
      real*8 pi10,pi20,pi30,pi40,pi50,k10,k1b,k20,k2b,k30,k3b
      real*8 nu(8),tp,tm,xt,t,t1,t2,t3,vzi(3)
      real*8 q(6),mv(3),mv2(3),gv(3),qcdfac,qcdfac2
      real*8 ecut5
      real*8 checkx,checky,checkz,checke
      real*8 pi
      real*8 p(4,nmax),sinv(nmax,nmax)
      real*8 b(4,2),bh(4,2)
      real*8 ecut(7),scut(7,7),ccut(7,7),precomb(4),precombg(2)
      complex*16 cvf(-1:1,3,6),cvw(2)
      character*6 fname(6),dfname(6)

      common/config_cuts/ccuts
      common/cuts/ecut,scut,ccut,precomb,precombg,scuts,
     $     srecomb,srecombg
      common/processpar/cvf,cvw,mv,mv2,gv,qcdfac,qcdfac2,
     $     q,qprop,quark,iso,gen,dir,pol,color,fname,dfname
      common/par_config/p,sinv
      common/par_beam/b,bh
      common/negalam/aflag
      common/outi/iout

c initialization:
      wps=1d0
      smin=0d0
      smax=0d0
      s1min=0d0
      s2min=0d0
      s3min=0d0
      ecut5=0d0
      do i=1,8
         wpsi(i)=1d0
      end do

      pi=4d0*datan(1d0)
      s=xs
      rs=dsqrt(s)

c a-priori the event is fine:
      if (idens.eq.0) icut=0
	
      if (mapi(6).eq.1) then
c no vzi(3) dependence !
c implementation of experimental cuts:
         if (ccuts(1).eq.1) then
            s1min=scut(ii(1)+2,ii(2)+2)
            if (s1min.eq.0d0)
     $           s1min=2d0*ecut(ii(1)+2)
     $           *ecut(ii(2)+2)*(1d0-ccut(ii(1)+2,ii(2)+2))
            s3min=scut(ii(4)+2,ii(5)+2)
            if (s3min.eq.0d0)
     $           s3min=2d0*ecut(ii(4)+2)
     $           *ecut(ii(5)+2)*(1d0-ccut(ii(4)+2,ii(5)+2))
         end if
         
         smin=s1min
         smax=s+s3min-2d0*rs*dsqrt(s3min)
         if (idens.eq.0)  then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning51:',smin,smax
               return
            end if
            call smap(mapi(1),x(1),smin,smax,nu(1),s1)
         end if
         if (idens.eq.1) then
            s1=sinv(ii(1)+2,ii(2)+2)
            call sdens(mapi(1),smin,smax,s1,nu(1),wpsi(1))
         end if
         rs1=dsqrt(s1)
         
         smin=s1
         smax=s+s3min-2d0*rs*dsqrt(s3min)
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning52:',smin,smax
               return
            end if
            call smap(mapi(2),x(2),smin,smax,nu(2),s2)
         end if
         if (idens.eq.1) then
            s2=s1+sinv(ii(1)+2,ii(3)+2)+sinv(ii(2)+2,ii(3)+2)
            call sdens(mapi(2),smin,smax,s2,nu(2),wpsi(2))
         end if
         rs2=dsqrt(s2)
         
         smin=s3min
         smax=s+s2-2d0*rs*rs2
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning53:',smin,smax
               return
            end if
            call smap(mapi(7),x(3),smin,smax,nu(7),s3)
         end if
         if (idens.eq.1) then
            s3=sinv(ii(4)+2,ii(5)+2)
            call sdens(mapi(7),smin,smax,s3,nu(7),wpsi(7))
         end if
         rs3=dsqrt(s3)

c decay: a+b->k2+k3: mapi(8)=0, s-channel, mapi(8)>=1: t-channel
         k20=(s+s2-s3)/2d0/rs
         alam1=alam(rs,rs2,rs3)
         if (aflag.eq.1) then
            if (idens.eq.0) then
               if(iout.ne.0)write(iout,*)'alam negative'
               icut=1
               return
            end if
         end if
         k2b=alam1/2d0/rs
         k30=(s+s3-s2)/2d0/rs
         k3b=k2b
         g20=k20/rs2
         g2=k2b/rs2
         g30=k30/rs3
         g3=k3b/rs3
c s-channel:
         if (mapi(8).eq.0) then
            if (mapi(3).gt.0.or.mapi(4).gt.0.or.mapi(5).gt.0
     $           .and.iout.ne.0)
     $           write(iout,*)'warning: mapi(3,4,5) must be 0 !'
            if (idens.eq.0) then
               ct=2d0*x(4)-1d0
               st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            end if
            if (idens.eq.1) wpsi(8)=alam1/8d0/s*4d0*pi
            goto 10
         end if
c t-channel:
         tm=-(s3+s2-s+alam1)/2d0
         tp=-(s3+s2-s-alam1)/2d0
         if (tm.le.0d0.or.tp.le.0d0.and.iout.ne.0) 
     $        write(iout,*)'51,1',tm,tp
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tm).ge.dabs(tp))) then
               icut=1
c               write(iout,*)'twarning51:',tm,tp
               return
            end if
            call tmap(mapi(8),x(4),tm,tp,nu(8),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'51,2',xt
            t=-xt
            ct=(2d0*t-s3-s2+s)/alam1
            st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            goto 10
         end if
         if (idens.eq.1) then
            if (vzi(1).gt.0d0)
     $           xt=-(s3-sinv(2,ii(4)+2)-sinv(2,ii(5)+2))
            if (vzi(1).lt.0d0)
     $           xt=-(s3-sinv(1,ii(4)+2)-sinv(1,ii(5)+2))
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d51,2',xt
            t=-xt
            call tdens(mapi(8),tm,tp,xt,nu(8),wpsi(8))
            wpsi(8)=wpsi(8)/4d0/s*2d0*pi
         end if
 10      continue

c decay: k2->k1+pi3: mapi(4)=0, s-channel, mapi(4)>=1: t-channel
         k10=(s2+s1)/2d0/rs2
         k1b=dabs(s2-s1)/2d0/rs2
         g10=k10/rs1
         g1=k1b/rs1
         pi30=k1b
c s-channel:
         if (mapi(4).eq.0) then
            if (mapi(5).gt.0.and.iout.ne.0) 
     $           write(iout,*)'warning: mapi(5) must be 0!'
            if (idens.eq.0) then
               ct1=2d0*x(5)-1d0
               st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            end if
            if (idens.eq.1) wpsi(4)=dabs(s2-s1)/8d0/s2*4d0*pi
            goto 20
         end if
c t-channel (only for vzi(1)=+1):
         if (iout.ne.0) then
         if (vzi(1).lt.0d0) 
     $        write(iout,*)'warning: vzi(1) must be +1!'
         if (mapi(8).eq.0.or.mapi(3).gt.0.or.mapi(2).gt.0) 
     $        write(iout,*)'warning: mapi(8,3,2) must be 1(or 2),0,0!'
         end if
         pa10=(s2-t)/2d0/rs2
         if (vzi(2).gt.0d0) then
            tm=-s1/s2*t
            tp=-(s1-s2+t)
            if (tp.le.0d0.or.tm.le.0d0.and.iout.ne.0) 
     $           write(iout,*)'51,3',tm,tp
         end if
         if (vzi(2).lt.0d0) then
            if (mapi(5).gt.0.and.iout.ne.0) 
     $           write(iout,*)'warning: mapi(5) must be 0!'
            tm=0d0
            tp=(s2-t)*(s2-s1)/s2
            if (tp.le.0d0.and.iout.ne.0) write(iout,*)'51,3',tp
c implementation of experimental cuts:
            if (ccuts(2).eq.1) then
               tm=2d0*bh(4,1)*ecut(ii(3)+2)*(1d0-ccut(1,ii(3)+2))
            end if
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning52:',tm,tp
               return
            end if
            call tmap(mapi(4),x(5),tm,tp,nu(4),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'51,4',xt
            t1=-xt
            if (vzi(2).gt.0d0) ct1=(2d0*s2*(t1-s1)+(s2-t)*(s2+s1))/
     $           dabs(s2-s1)/(s2-t)
            if (vzi(2).lt.0d0) ct1=(2d0*s2*t1+(s2-t)*(s2-s1))/
     $           dabs(s2-s1)/(s2-t)
            st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            goto 20
         end if
         if (idens.eq.1) then
            if (vzi(2).gt.0d0) 
     $           xt=-(s1-sinv(1,ii(1)+2)-sinv(1,ii(2)+2))
            if (vzi(2).lt.0d0) xt=sinv(1,ii(3)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d51,4',xt
            t1=-xt
            call tdens(mapi(4),tm,tp,xt,nu(4),wpsi(4))
            wpsi(4)=wpsi(4)/4d0/(s2-t)*2d0*pi
         end if
 20      continue

c decay: k1->pi1+pi2: mapi(5)=0: s-channel, mapi(5)>=0: t-channel
         pi10=rs1/2d0
         pi20=pi10
c s-channel:	   
         if (mapi(5).eq.0) then
            if (idens.eq.0) then
               ct2=2d0*x(6)-1d0
               st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))
            end if
            if (idens.eq.1) wpsi(5)=4d0*pi/8d0
            goto 30
         end if
c t-channel: only for vzi(1)=+1, vzi(2)=+1 !
         if (iout.ne.0) then
         if (vzi(1).lt.0d0.or.vzi(2).lt.0d0) 
     $        write(iout,*)'warning: vzi(1,2) must be +1!'
         if (mapi(8).eq.0.or.mapi(4).eq.0.or.
     $        mapi(3).gt.0.or.mapi(2).gt.0.or.mapi(1).gt.0) 
     $        write(iout,*)
     $        'warning:mapi(8,4,3,2,1) must be 1(or2),1(or2),0,0,0!'
         end if
         pa20=(s1-t1)/2d0/rs1
         tm=0d0
         tp=s1-t1
         if (tp.le.0d0.and.iout.ne.0) write(iout,*)'51,5',tp
c implementation of experimental cuts: 
         if (ccuts(2).eq.1) then
            tm=2d0*bh(4,1)*ecut(ii(1)+2)*(1d0-ccut(1,ii(1)+2))
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning53:',tm,tp
               return
            end if
            call tmap(mapi(5),x(6),tm,tp,nu(5),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'51,6',xt
            t2=-xt
            ct2=(2d0*t2+s1-t1)/(s1-t1)
            st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))
            goto 30
         end if
         if (idens.eq.1) then
            xt=sinv(1,ii(1)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d51,6',xt
            t2=-xt
            call tdens(mapi(5),tm,tp,xt,nu(5),wpsi(5))
            wpsi(5)=wpsi(5)/4d0/(s1-t1)*2d0*pi
         end if
 30      continue

c decay: k3->pi4+pi5: mapi(3)=0: s-channel, mapi(3)>=0: t-channel
         pi40=rs3/2d0
         pi50=pi40
c s-channel:
         if (mapi(3).eq.0) then
            if (idens.eq.0) then
               ct3=2d0*x(7)-1d0
               st3=dsqrt(dabs((1d0-ct3)*(1d0+ct3)))
            end if
            if (idens.eq.1) wpsi(3)=4d0*pi/8d0
            goto 40
         end if
c t-channel (only for vzi(1)=-1 !):
         if (iout.ne.0) then
         if (vzi(1).gt.0d0) write(iout,*)'warning: vzi(1) must be -1!'
         if (mapi(8).eq.0.or.mapi(7).gt.0) 
     $        write(iout,*)'warning: mapi(8,7) must be 1(or 2) and 0!'
         end if
         pa30=(s3-t)/2d0/rs3
         tm=0d0
         tp=s3-t
         if (tp.le.0d0.and.iout.ne.0) write(iout,*)'51,7',tp
c implementation of experimental cuts:
         if (ccuts(2).eq.1) then
            tm=2d0*bh(4,1)*ecut(ii(4)+2)*(1d0-ccut(1,ii(4)+2))
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning54:',tm,tp
               return
            end if
            call tmap(mapi(3),x(7),tm,tp,nu(3),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'51,8',xt
            t3=-xt
            ct3=(2d0*t3+s3-t)/(s3-t)
            st3=dsqrt(dabs((1d0-ct3)*(1d0+ct3)))
            goto 40
         end if
         if (idens.eq.1) then
            xt=sinv(1,ii(4)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d51,8',xt
            t3=-xt
            call tdens(mapi(3),tm,tp,xt,nu(3),wpsi(3))
            wpsi(3)=wpsi(3)/4d0/(s3-t)*2d0*pi
         end if
 40      continue

         if (idens.eq.1) then
            do i=1,8
               wps=wps/wpsi(i)
            end do
            goto 200
         end if

         ph1=2d0*pi*x(8)
         ph2=2d0*pi*x(9)
         ph3=2d0*pi*x(10)
         ph=2d0*pi*x(11)

         p(1,ii(3))=-vzi(2)*pi30*st1*dcos(ph1)
         p(2,ii(3))=-vzi(2)*pi30*st1*dsin(ph1)
         p(3,ii(3))=-vzi(2)*pi30*ct1
         p(4,ii(3))=pi30
         if (mapi(4).gt.0) then
            st1s=-rs/2d0*st/pa10
            ct1s=rs/2d0*(g20*ct-g2)/pa10
            call rotation_1(1d0,st1s,ct1s,p(1,ii(3)),p(3,ii(3)))
         end if
         call boost_z(g20,g2,p(4,ii(3)),p(3,ii(3)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(3)),p(2,ii(3)),p(3,ii(3)))

         p(1,ii(1))=pi10*st2*dcos(ph2)
         p(2,ii(1))=pi10*st2*dsin(ph2)
         p(3,ii(1))=pi10*ct2
         p(4,ii(1))=pi10
         p(1,ii(2))=-pi20*st2*dcos(ph2)
         p(2,ii(2))=-pi20*st2*dsin(ph2)
         p(3,ii(2))=-pi20*ct2
         p(4,ii(2))=pi20
         if (mapi(5).gt.0) then
            st2s=-pa10*st1/pa20
            ct2s=pa10*(g10*ct1-g1)/pa20
            call rotation_1(1d0,st2s,ct2s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st2s,ct2s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g10,g1,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(vzi(2),st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g10,g1,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(vzi(2),st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))
         if (mapi(4).gt.0) then
            call rotation_1(1d0,st1s,ct1s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st1s,ct1s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g20,g2,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g20,g2,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))

         p(1,ii(4))=pi40*st3*dcos(ph3)
         p(2,ii(4))=pi40*st3*dsin(ph3)
         p(3,ii(4))=pi40*ct3
         p(4,ii(4))=pi40
         p(1,ii(5))=-pi50*st3*dcos(ph3)
         p(2,ii(5))=-pi50*st3*dsin(ph3)
         p(3,ii(5))=-pi50*ct3
         p(4,ii(5))=pi50
         if (mapi(3).gt.0) then
            st3s=-rs/2d0*st/pa30
            ct3s=rs/2d0*(g30*ct-g3)/pa30
            call rotation_1(1d0,st3s,ct3s,p(1,ii(4)),p(3,ii(4)))
            call rotation_1(1d0,st3s,ct3s,p(1,ii(5)),p(3,ii(5)))
         end if
         call boost_z(g30,g3,p(4,ii(4)),p(3,ii(4)))
         call rotation_2(-vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(4)),p(2,ii(4)),p(3,ii(4)))
         call boost_z(g30,g3,p(4,ii(5)),p(3,ii(5)))
         call rotation_2(-vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(5)),p(2,ii(5)),p(3,ii(5)))
         goto 100
      end if

      if (mapi(6).eq.2) then
c always mapi(4)=0 and no vzi(2),vzi(3) dependence!
c implementation of experimental cuts:
         if (ccuts(1).eq.1) then
            s1min=scut(ii(1)+2,ii(2)+2)
            if (s1min.eq.0d0)
     $           s1min=2d0*ecut(ii(1)+2)
     $           *ecut(ii(2)+2)*(1d0-ccut(ii(1)+2,ii(2)+2))
            s2min=scut(ii(3)+2,ii(4)+2)
            if (s2min.eq.0d0)
     $           s2min=2d0*ecut(ii(3)+2)
     $           *ecut(ii(4)+2)*(1d0-ccut(ii(3)+2,ii(4)+2))
         end if

         smin=s1min
         smax=s-2d0*ecut5*rs+s2min-2d0*dsqrt(s2min)*
     $        dsqrt(s-2d0*ecut5*rs)
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning54:',smin,smax
               return
            end if
            call smap(mapi(1),x(1),smin,smax,nu(1),s1)
         end if
         if (idens.eq.1) then
            s1=sinv(ii(1)+2,ii(2)+2)
            call sdens(mapi(1),smin,smax,s1,nu(1),wpsi(1))
         end if
         rs1=dsqrt(s1)
         
         smin=s2min
         smax=s-2d0*ecut5*rs+s1-2d0*rs1*dsqrt(s-2d0*ecut5*rs)
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning55:',smin,smax
               return
            end if
            call smap(mapi(2),x(2),smin,smax,nu(2),s2)
         end if
         if (idens.eq.1) then
            s2=sinv(ii(3)+2,ii(4)+2)
            call sdens(mapi(2),smin,smax,s2,nu(2),wpsi(2))
         end if
         rs2=dsqrt(s2)

         smin=s1+s2+2d0*rs1*rs2
         smax=s-2d0*ecut5*rs
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning56:',smin,smax
               return
            end if
            call smap(mapi(7),x(3),smin,smax,nu(7),s3)
         end if
         if (idens.eq.1) then
            s3=s-sinv(1,ii(5)+2)-sinv(2,ii(5)+2)
            call sdens(mapi(7),smin,smax,s3,nu(7),wpsi(7))
         end if
         rs3=dsqrt(s3)

c decay: a+b->k3+pi5: s-channel mapi(8)=0, t-channel mapi(8)>=1
         k30=(s+s3)/2d0/rs
         k3b=dabs(s-s3)/2d0/rs
         pi50=k3b
         g30=k30/rs3
         g3=k3b/rs3
         if (idens.eq.0.and.ccuts(3).eq.1) then
            if (pi50.lt.ecut(ii(5)+2)) then
               icut=1
               return
            end if
         end if
c s-channel:
         if (mapi(8).eq.0) then
            if (mapi(3).gt.0.or.mapi(5).gt.0.and.iout.ne.0)
     $           write(iout,*)'warning: mapi(3,5) must be 0,0 !'
            if (idens.eq.0) then
               ct=2d0*x(4)-1d0
               st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            end if
            if (idens.eq.1) wpsi(8)=dabs(s-s3)/8d0/s*4d0*pi
            goto 50
         end if
c t-channel:
         tm=0d0
         tp=s-s3
         if (tp.le.0d0.and.iout.ne.0) 
     $        write(iout,*)'52,1',idens,ecut5,tp
c implementation of an angle cut:
         if (ccuts(2).eq.1) then
            if (vzi(1).gt.0d0) 
     $           tm=2d0*bh(4,2)*ecut(ii(5)+2)*(1d0-ccut(2,ii(5)+2))
            if (vzi(1).lt.0d0) 
     $           tm=2d0*bh(4,1)*ecut(ii(5)+2)*(1d0-ccut(1,ii(5)+2))
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning55:',tm,tp
               return
            end if
            call tmap(mapi(8),x(4),tm,tp,nu(8),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'52,2',xt
            t=-xt
            ct=(2d0*t+s-s3)/(s-s3)
            st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            goto 50
         end if
         if (idens.eq.1) then
            if (vzi(1).gt.0d0) xt=sinv(2,ii(5)+2)
            if (vzi(1).lt.0d0) xt=sinv(1,ii(5)+2)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'d52,2',vzi(1),xt
            t=-xt
            call tdens(mapi(8),tm,tp,xt,nu(8),wpsi(8))
            wpsi(8)=wpsi(8)/4d0/s*2d0*pi
         end if
 50      continue
         if (idens.eq.0.and.ccuts(3).eq.1) then
            if (ct.gt.ccut(1,ii(5)+2)) then
               icut=1
               return
            end if
         end if
	   
c decay: k3->k1+k2: mapi(3)=0, s-channel, mapi(3)>=1: t-channel
         k20=(s3+s2-s1)/2d0/rs3
         alam1=alam(rs3,rs1,rs2)
         if (aflag.eq.1) then
            if (idens.eq.0) then
               if (iout.ne.0) write(iout,*)'alam negative'
               icut=1
               return
            end if
         end if
         k2b=alam1/2d0/rs3
         k10=(s3+s1-s2)/2d0/rs3
         k1b=k2b
         g20=k20/rs2
         g2=k2b/rs2
         g10=k10/rs1
         g1=k1b/rs1
c s-channel:
         if (mapi(3).eq.0) then
            if (mapi(5).gt.0.and.iout.ne.0) 
     $           write(iout,*)'warning: mapi(5) must be 0!'
            if (idens.eq.0) then
               ct1=2d0*x(5)-1d0
               st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            end if
            if (idens.eq.1) wpsi(3)=alam1/8d0/s3*4d0*pi
            goto 60
         end if
c t-channel (only for vzi(1)=+1):
         if (iout.ne.0) then
         if (vzi(1).lt.0d0) write(iout,*)'warning: vzi(1) must be +1!'
         if (mapi(8).eq.0.or.mapi(7).gt.0) 
     $        write(iout,*)'warning: mapi(8,7) must be 1(or 2) and 0!'
         end if
         pa10=(s3-t)/2d0/rs3
         tm=-(2d0*s3*s1-(s3-t)*(s3+s1-s2-alam1))/2d0/s3
         tp=-(2d0*s3*s1-(s3-t)*(s3+s1-s2+alam1))/2d0/s3
         if (tm.le.0d0.or.tp.le.0d0.and.iout.ne.0) 
     $        write(iout,*)'52,3',tm,tp
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning56:',tm,tp
               return
            end if
            call tmap(mapi(3),x(5),tm,tp,nu(3),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'52,4',xt
            t1=-xt
            ct1=(2d0*s3*(t1-s1)+(s3-t)*(s3+s1-s2))/(s3-t)/alam1
            st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            goto 60
         end if
         if (idens.eq.1) then
            xt=-(s1-sinv(1,ii(1)+2)-sinv(1,ii(2)+2))
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'d52,4',xt
            t1=-xt
            call tdens(mapi(3),tm,tp,xt,nu(3),wpsi(3))
            wpsi(3)=wpsi(3)/4d0/(s3-t)*2d0*pi
         end if
 60      continue

c decay: k1->pi1+pi2: mapi(5)=0: s-channel, mapi(5)>=1: t-channel
         pi10=rs1/2d0
         pi20=pi10
c s-channel:
         if (mapi(5).eq.0) then
            if (idens.eq.0) then
               ct2=2d0*x(6)-1d0
               st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))
            end if
            if (idens.eq.1) wpsi(5)=4d0*pi/8d0
            goto 65
         end if
c t-channel: (only for vzi(1)=+1)
         if (iout.ne.0) then
         if (vzi(1).lt.0d0) write(iout,*)'warning: vzi(1) must be +1!'
         if (mapi(3).eq.0.or.mapi(8).eq.0.or.mapi(7).gt.0.or.
     $        mapi(1).gt.0.and.iout.ne.0) write(iout,*)
     $        'warning: mapi(3,8,7,1) must be 1(or 2),1(or 2),0,0!'
         end if
         pa20=(s1-t1)/2d0/rs1
         tm=0d0
         tp=s1-t1
         if (tp.le.0d0.and.iout.ne.0) write(iout,*)'52,5',tp
c implementation of experimental cuts:
         if (ccuts(2).eq.1) then
            tm=2d0*bh(4,1)*ecut(ii(1)+2)*(1d0-ccut(1,ii(1)+2))
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning57:',tm,tp
               return
            end if
            call tmap(mapi(5),x(6),tm,tp,nu(5),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'52,6',xt
            t2=-xt
            ct2=(2d0*t2+s1-t1)/(s1-t1)
            st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))
            goto 65
         end if
         if (idens.eq.1) then
            xt=sinv(1,ii(1)+2)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'d52,6',xt
            t2=-xt
            call tdens(mapi(5),tm,tp,xt,nu(5),wpsi(5))
            wpsi(5)=wpsi(5)/4d0/(s1-t1)*2d0*pi
         end if
 65      continue

c decay: k2->pi3+pi4 only mapi(4)=0 (s-channel) !
         if (mapi(4).gt.0.and.iout.ne.0) 
     $        write(iout,*)'warning: mapi(4) must be 0 !'
         pi30=rs2/2d0
         pi40=pi30
c s-channel:
         if (idens.eq.0) then
            ct3=2d0*x(7)-1d0
            st3=dsqrt(dabs((1d0-ct3)*(1d0+ct3)))
         end if
         if (idens.eq.1) then
            wpsi(4)=4d0*pi/8d0
            do i=1,8
               wps=wps/wpsi(i)
            end do
            goto 200
         end if

         ph1=2d0*pi*x(8)
         ph2=2d0*pi*x(9)
         ph3=2d0*pi*x(10)
         ph=2d0*pi*x(11)

         p(1,ii(5))=-vzi(1)*pi50*st*dcos(ph)
         p(2,ii(5))=-vzi(1)*pi50*st*dsin(ph)
         p(3,ii(5))=-vzi(1)*pi50*ct
         p(4,ii(5))=pi50

         p(1,ii(1))=pi10*st2*dcos(ph2)
         p(2,ii(1))=pi10*st2*dsin(ph2)
         p(3,ii(1))=pi10*ct2
         p(4,ii(1))=pi10
         p(1,ii(2))=-pi20*st2*dcos(ph2)
         p(2,ii(2))=-pi20*st2*dsin(ph2)
         p(3,ii(2))=-pi20*ct2
         p(4,ii(2))=pi20
         if (mapi(5).gt.0) then
            st2s=-pa10*st1/pa20
            ct2s=pa10*(g10*ct1-g1)/pa20
            call rotation_1(1d0,st2s,ct2s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st2s,ct2s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g10,g1,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(1d0,st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g10,g1,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(1d0,st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))
         if (mapi(3).gt.0) then
            st1s=-rs/2d0*st/pa10
            ct1s=rs/2d0*(g30*ct-g3)/pa10
            call rotation_1(1d0,st1s,ct1s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st1s,ct1s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g30,g3,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g30,g3,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))

         p(1,ii(3))=pi30*st3*dcos(ph3)
         p(2,ii(3))=pi30*st3*dsin(ph3)
         p(3,ii(3))=pi30*ct3
         p(4,ii(3))=pi30
         p(1,ii(4))=-pi40*st3*dcos(ph3)
         p(2,ii(4))=-pi40*st3*dsin(ph3)
         p(3,ii(4))=-pi40*ct3
         p(4,ii(4))=pi40
         call boost_z(g20,g2,p(4,ii(3)),p(3,ii(3)))
         call rotation_2(-1d0,st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(3)),p(2,ii(3)),p(3,ii(3)))
         call boost_z(g20,g2,p(4,ii(4)),p(3,ii(4)))
         call rotation_2(-1d0,st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(4)),p(2,ii(4)),p(3,ii(4)))
         if (mapi(3).gt.0) then
            call rotation_1(1d0,st1s,ct1s,p(1,ii(3)),p(3,ii(3)))
            call rotation_1(1d0,st1s,ct1s,p(1,ii(4)),p(3,ii(4)))
         end if
         call boost_z(g30,g3,p(4,ii(3)),p(3,ii(3)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(3)),p(2,ii(3)),p(3,ii(3)))
         call boost_z(g30,g3,p(4,ii(4)),p(3,ii(4)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(4)),p(2,ii(4)),p(3,ii(4)))
         goto 100
      end if

      if (mapi(6).eq.3) then
c implementation of experimental cuts:
         if (ccuts(1).eq.1) then
            s1min=scut(ii(1)+2,ii(2)+2)
            if (s1min.eq.0d0)
     $           s1min=2d0*ecut(ii(1)+2)
     $           *ecut(ii(2)+2)*(1d0-ccut(ii(1)+2,ii(2)+2))
         end if

         smin=s1min
         smax=s-2d0*ecut5*rs
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning57:',smin,smax
               return
            end if
            call smap(mapi(1),x(1),smin,smax,nu(1),s1)
         end if
         if (idens.eq.1) then
            s1=sinv(ii(1)+2,ii(2)+2)
            call sdens(mapi(1),smin,smax,s1,nu(1),wpsi(1))
         end if
         rs1=dsqrt(s1)

         smin=s1
         smax=s-2d0*ecut5*rs
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning58:',smin,smax
               return
            end if
            call smap(mapi(2),x(2),smin,smax,nu(2),s2)
         end if
         if (idens.eq.1) then
            s2=s1+sinv(ii(1)+2,ii(3)+2)+sinv(ii(2)+2,ii(3)+2)
            call sdens(mapi(2),smin,smax,s2,nu(2),wpsi(2))
         end if
         rs2=dsqrt(s2)

         smin=s2
         smax=s-2d0*ecut5*rs
         if (idens.eq.0) then
            if ((smin.lt.1d-10.and.smax.lt.1d-10).or.
     $           (dabs(smin).ge.dabs(smax))) then
               icut=1
c               write(iout,*)'swarning59:',smin,smax
               return
            end if
            call smap(mapi(7),x(3),smin,smax,nu(7),s3)
         end if
         if (idens.eq.1) then
            s3=s-sinv(1,ii(5)+2)-sinv(2,ii(5)+2)
            call sdens(mapi(7),smin,smax,s3,nu(7),wpsi(7))
         end if
         rs3=dsqrt(s3)

c decay: a+b->k3+pi5: mapi(8)=0, s-channel, mapi(8)>=1: t-channel
         k30=(s+s3)/2d0/rs
         k3b=dabs(s-s3)/2d0/rs
         pi50=k3b
         g30=k30/rs3
         g3=k3b/rs3
         if (idens.eq.0.and.ccuts(3).eq.1) then
            if (pi50.lt.ecut(ii(5)+2)) then
               icut=1
               return
            end if
         end if
c s-channel:
         if (mapi(8).eq.0) then
            if (mapi(3).gt.0.or.mapi(4).gt.0.or.mapi(5).gt.0
     $           .and.iout.ne.0)
     $           write(iout,*)'warning: mapi(3,4,5) must be 0,0,0 !'
            if (idens.eq.0) then
               ct=2d0*x(4)-1d0
               st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            end if
            if (idens.eq.1) wpsi(8)=dabs(s-s3)/8d0/s*4d0*pi
            goto 70
         end if
c t-channel:
         tm=0d0
         tp=s-s3
         if (tp.le.0d0.and.iout.ne.0) write(iout,*)'53,1',tp
c implementation of an angle cut:
         if (ccuts(2).eq.1) then
            if (vzi(1).gt.0d0)
     $           tm=2d0*bh(4,2)*ecut(ii(5)+2)*(1d0-ccut(2,ii(5)+2))
            if (vzi(1).lt.0d0)
     $           tm=2d0*bh(4,1)*ecut(ii(5)+2)*(1d0-ccut(1,ii(5)+2))
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning59:',tm,tp
               return
            end if
            call tmap(mapi(8),x(4),tm,tp,nu(8),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'53,2',xt
            t=-xt
            ct=(2d0*t+s-s3)/(s-s3)
            st=dsqrt(dabs((1d0-ct)*(1d0+ct)))
            goto 70
         end if
         if (idens.eq.1) then
            if (vzi(1).gt.0d0) xt=sinv(2,ii(5)+2)
            if (vzi(1).lt.0d0) xt=sinv(1,ii(5)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d53,2',xt
            t=-xt
            call tdens(mapi(8),tm,tp,xt,nu(8),wpsi(8))
            wpsi(8)=wpsi(8)/4d0/s*2d0*pi
         end if
 70      continue
         if (idens.eq.0.and.ccuts(3).eq.1) then
            if (ct.gt.ccut(1,ii(5)+2)) then
               icut=1
               return
            end if
         end if

c decay: k3->k2+pi4: mapi(3)=0, s-channel, mapi(3)>=1: t-channel
         k20=(s3+s2)/2d0/rs3
         k2b=dabs(s3-s2)/2d0/rs3
         g20=k20/rs2
         g2=k2b/rs2
         pi40=k2b
c s-channel:
         if (mapi(3).eq.0) then
            if (mapi(5).gt.0.or.mapi(4).gt.0.and.iout.ne.0) 
     $           write(iout,*)'warning: mapi(5,4) must be 0,0!'
            if (idens.eq.0) then
               ct1=2d0*x(5)-1d0
               st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            end if
            if (idens.eq.1) wpsi(3)=dabs(s3-s2)/8d0/s3*4d0*pi
            goto 80
         end if
c t-channel (only for vzi(1)=+1):
         if (iout.ne.0) then
         if (vzi(1).lt.0d0) write(iout,*)'warning: vzi(1) must be +1!'
         if (mapi(8).eq.0.or.mapi(7).gt.0) 
     $        write(iout,*)'warning: mapi(8,7) must be 1(or 2) and 0!'
         end if
         pa10=(s3-t)/2d0/rs3
         if (vzi(2).gt.0d0) then
            tm=-s2/s3*t
            tp=-(s2-s3+t)
            if (tm.le.0d0.or.tp.le.0d0.and.iout.ne.0) 
     $           write(iout,*)'53,3',tm,tp
         end if
         if (vzi(2).lt.0d0) then
            tm=0d0
            tp=(s3-t)*(s3-s2)/s3
            if (tp.le.0d0.and.iout.ne.0) write(iout,*)'53,3',tp
c implementation of experimental cuts:
            if (ccuts(2).eq.1) then
               tm=2d0*bh(4,1)*ecut(ii(4)+2)*(1d0-ccut(1,ii(4)+2))
            end if
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning510:',tm,tp
               return
            end if
            call tmap(mapi(3),x(5),tm,tp,nu(3),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'53,4',xt
            t1=-xt
            if (vzi(2).gt.0d0) ct1=(2d0*s3*(t1-s2)+(s3-t)*(s3+s2))/
     $           (s3-s2)/(s3-t)
            if (vzi(2).lt.0d0) ct1=(2d0*s3*t1+(s3-t)*(s3-s2))/
     $           (s3-s2)/(s3-t)
            st1=dsqrt(dabs((1d0-ct1)*(1d0+ct1)))
            goto 80
         end if
         if (idens.eq.1) then
            if (vzi(2).gt.0d0) xt=-(s2-sinv(1,ii(3)+2)-
     $           sinv(1,ii(1)+2)-sinv(1,ii(2)+2))
            if (vzi(2).lt.0d0) xt=sinv(1,ii(4)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d53,4',tp,xt
            t1=-xt
            call tdens(mapi(3),tm,tp,xt,nu(3),wpsi(3))
            wpsi(3)=wpsi(3)/4d0/(s3-t)*2d0*pi
         end if
 80      continue

c decay: k2->k1+pi3: mapi(4)=0 s-channel, mapi(4)>=1: t-channel
         k10=(s2+s1)/2d0/rs2
         k1b=dabs(s2-s1)/2d0/rs2
         pi30=k1b
         g10=k10/rs1
         g1=k1b/rs1
c s-channel:
         if (mapi(4).eq.0) then
            if (mapi(5).gt.0.and.iout.ne.0) 
     $           write(iout,*)'warning: mapi(5) must be 0!'
            if (idens.eq.0) then
               ct2=2d0*x(6)-1d0
               st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))	   
            end if
            if (idens.eq.1) wpsi(4)=dabs(s2-s1)*4d0*pi/8d0/s2
            goto 85
         end if
c t-channel (only for vzi(1)=+1 and vzi(2)=+1):
         if (iout.ne.0) then
         if (vzi(1).lt.0d0.or.vzi(2).lt.0d0) 
     $        write(iout,*)'warning: vzi(1,2) must be +1,+1!'
         if (mapi(3).eq.0.or.mapi(8).eq.0.or.mapi(7).gt.0.or.
     $        mapi(2).gt.0.and.iout.ne.0) write(iout,*)
     $        'warning: mapi(3,8,7,2) must be 1(or 2),1(or 2),0,0!'
         end if
         pa20=(s2-t1)/2d0/rs2
         if (vzi(3).gt.0d0) then
            tm=-s1/s2*t1
            tp=-(s1-s2+t1)
            if (tm.le.0d0.or.tp.le.0d0.and.iout.ne.0) 
     $           write(iout,*)'53,5',tm,tp
         end if
         if (vzi(3).lt.0d0) then
            tm=0d0
            tp=(s2-t1)*(s2-s1)/s2
            if (tp.le.0d0.and.iout.ne.0) write(iout,*)'53,5',tp
c implementation of experimental cuts:
            if (ccuts(2).eq.1) then
               tm=2d0*bh(4,1)*ecut(ii(3)+2)*(1d0-ccut(1,ii(3)+2))
            end if
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning511:',tm,tp
               return
            end if
            call tmap(mapi(4),x(6),tm,tp,nu(4),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'53,6',xt
            t2=-xt
            if (vzi(3).gt.0d0) ct2=(2d0*s2*(t2-s1)+(s2-t1)*(s2+s1))/
     $           (s2-s1)/(s2-t1)
            if (vzi(3).lt.0d0) ct2=(2d0*s2*t2+(s2-t1)*(s2-s1))/
     $           (s2-s1)/(s2-t1)
            st2=dsqrt(dabs((1d0-ct2)*(1d0+ct2)))
            goto 85
         end if
         if (idens.eq.1) then
            if (vzi(3).gt.0d0)
     $           xt=-(s1-sinv(1,ii(1)+2)-sinv(1,ii(2)+2))
            if (vzi(3).lt.0d0) xt=sinv(1,ii(3)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d53,6',xt
            t2=-xt
            call tdens(mapi(4),tm,tp,xt,nu(4),wpsi(4))
            wpsi(4)=wpsi(4)/4d0/(s2-t1)*2d0*pi
         end if
 85      continue

c decay: k1->pi1+pi2: mapi(5)=0 s-channel, mapi(5)>=0: t-channel
         pi10=rs1/2d0
         pi20=pi10
         if (mapi(5).eq.0) then
            if (idens.eq.0) then
               ct3=2d0*x(7)-1d0
               st3=dsqrt(dabs((1d0-ct3)*(1d0+ct3)))
            end if
            if (idens.eq.1) wpsi(5)=4d0*pi/8d0
            goto 90
         end if
c t-channel:
c always: vzi(1)=+1, vzi(2)=+1 and vzi(3)=+1!
         if (iout.ne.0) then
         if (vzi(1).lt.0d0.or.vzi(2).lt.0d0.or.vzi(3).lt.0d0) 
     $        write(iout,*)'warning: vzi(1,2,3) must be +1,+1,+1!'
         if (mapi(3).eq.0.or.mapi(8).eq.0.or.mapi(4).eq.0.or.
     $        mapi(7).gt.0.or.mapi(2).gt.0.or.mapi(1).gt.0) then
            write(iout,*)'warning: mapi(3,8,4,7,2,1) must be' 
            write(iout,*)'1(or 2),1(or 2),1(or 2),0,0,0 !'
         end if
         end if
         pa30=(s1-t2)/2d0/rs1
         tm=0d0
         tp=s1-t2
         if (tp.le.0d0.and.iout.ne.0) write(iout,*)'53,7',tp
c implementation of cuts: 
         if (ccuts(2).eq.1) then
            tm=2d0*bh(4,1)*ecut(ii(1)+2)*(1d0-ccut(1,ii(1)+2))
         end if
         if (idens.eq.0) then
            if ((dabs(tm).lt.1d-10.and.dabs(tp).lt.1d-10).or.
     $           (dabs(tp).le.dabs(tm))) then
               icut=1
c               write(iout,*)'twarning512:',tm,tp
               return
            end if
            call tmap(mapi(5),x(7),tm,tp,nu(5),xt)
            if (xt.le.0d0.and.iout.ne.0) write(iout,*)'53,8',xt
            t3=-xt
            ct3=(2d0*t3+s1-t2)/(s1-t2)
            st3=dsqrt(dabs((1d0-ct3)*(1d0+ct3)))
            goto 90
         end if
         if (idens.eq.1) then
            xt=sinv(1,ii(1)+2)
            if(xt.le.0d0.and.iout.ne.0) write(iout,*)'d53,8',xt
            t3=-xt
            call tdens(mapi(5),tm,tp,xt,nu(5),wpsi(5))
            wpsi(5)=wpsi(5)/4d0/(s1-t2)*2d0*pi
         end if
 90      continue

         if (idens.eq.1) then
            do i=1,8
               wps=wps/wpsi(i)
            end do
            goto 200
         end if

         ph1=2d0*pi*x(8)
         ph2=2d0*pi*x(9)
         ph3=2d0*pi*x(10)
         ph=2d0*pi*x(11)

         p(1,ii(5))=-vzi(1)*pi50*st*dcos(ph)
         p(2,ii(5))=-vzi(1)*pi50*st*dsin(ph)
         p(3,ii(5))=-vzi(1)*pi50*ct
         p(4,ii(5))=pi50
         
         p(1,ii(4))=-vzi(2)*pi40*st1*dcos(ph1)
         p(2,ii(4))=-vzi(2)*pi40*st1*dsin(ph1)
         p(3,ii(4))=-vzi(2)*pi40*ct1
         p(4,ii(4))=pi40
         if (mapi(3).gt.0) then
            st1s=-rs/2d0*st/pa10
            ct1s=rs/2d0*(g30*ct-g3)/pa10
            call rotation_1(1d0,st1s,ct1s,p(1,ii(4)),p(3,ii(4)))
         end if
         call boost_z(g30,g3,p(4,ii(4)),p(3,ii(4)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(4)),p(2,ii(4)),p(3,ii(4)))
         
         p(1,ii(3))=-vzi(3)*pi30*st2*dcos(ph2)
         p(2,ii(3))=-vzi(3)*pi30*st2*dsin(ph2)
         p(3,ii(3))=-vzi(3)*pi30*ct2
         p(4,ii(3))=pi30
         if (mapi(4).gt.0) then
            st2s=-pa10*st1/pa20
            ct2s=pa10*(g20*ct1-g2)/pa20
            call rotation_1(1d0,st2s,ct2s,p(1,ii(3)),p(3,ii(3)))
         end if
         call boost_z(g20,g2,p(4,ii(3)),p(3,ii(3)))
         call rotation_2(vzi(2),st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(3)),p(2,ii(3)),p(3,ii(3)))
         if (mapi(3).gt.0) then
            call rotation_1(1d0,st1s,ct1s,p(1,ii(3)),p(3,ii(3)))
         end if
         call boost_z(g30,g3,p(4,ii(3)),p(3,ii(3)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(3)),p(2,ii(3)),p(3,ii(3)))

         p(1,ii(1))=pi10*st3*dcos(ph3)
         p(2,ii(1))=pi10*st3*dsin(ph3)
         p(3,ii(1))=pi10*ct3
         p(4,ii(1))=pi10
         p(1,ii(2))=-pi20*st3*dcos(ph3)
         p(2,ii(2))=-pi20*st3*dsin(ph3)
         p(3,ii(2))=-pi20*ct3
         p(4,ii(2))=pi20
         if (mapi(5).gt.0) then
            st3s=-pa20*st2/pa30
            ct3s=pa20*(g10*ct2-g1)/pa30
            call rotation_1(1d0,st3s,ct3s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st3s,ct3s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g10,g1,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(vzi(3),st2,ct2,
     $        dsin(ph2),dcos(ph2),p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g10,g1,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(vzi(3),st2,ct2,
     $        dsin(ph2),dcos(ph2),p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))
         if (mapi(4).gt.0) then
            call rotation_1(1d0,st2s,ct2s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st2s,ct2s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g20,g2,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(vzi(2),st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g20,g2,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(vzi(2),st1,ct1,
     $        dsin(ph1),dcos(ph1),p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))
         if (mapi(3).gt.0) then
            call rotation_1(1d0,st1s,ct1s,p(1,ii(1)),p(3,ii(1)))
            call rotation_1(1d0,st1s,ct1s,p(1,ii(2)),p(3,ii(2)))
         end if
         call boost_z(g30,g3,p(4,ii(1)),p(3,ii(1)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(1)),p(2,ii(1)),p(3,ii(1)))
         call boost_z(g30,g3,p(4,ii(2)),p(3,ii(2)))
         call rotation_2(vzi(1),st,ct,
     $        dsin(ph),dcos(ph),p(1,ii(2)),p(2,ii(2)),p(3,ii(2)))
      end if
 100  continue
c
c check of four-momentum conservation:	
c
      if (iout.ne.0) then
      checkx=b(1,1)+b(1,2)-(p(1,ii(5))+p(1,ii(4))+p(1,ii(3))
     $     +p(1,ii(1))+p(1,ii(2)))
      if (dabs(checkx).gt.1d-10) 
     $     write(iout,*)'warning: x-comp. is not conserved',
     $     checkx
      checky=b(2,1)+b(2,2)-(p(2,ii(5))+p(2,ii(4))+p(2,ii(3))
     $     +p(2,ii(1))+p(2,ii(2)))
      if (dabs(checky).gt.1d-10) 
     $     write(iout,*)'warning: y-comp. is not conserved',
     $     checky
      checkz=b(3,1)+b(3,2)-(p(3,ii(5))+p(3,ii(4))+p(3,ii(3))
     $     +p(3,ii(1))+p(3,ii(2)))
      if (dabs(checkz).gt.1d-10) 
     $     write(iout,*)'warning: z-comp. is not conserved',
     $     checkz
      checke=b(4,1)+b(4,2)-(p(4,ii(5))+p(4,ii(4))+p(4,ii(3))
     $     +p(4,ii(1))+p(4,ii(2)))
      if (dabs(checke).gt.1d-10) 
     $     write(iout,*)'warning: energy is not conserved',
     $     checke,b(4,1)+b(4,2)
      end if
 200  continue
      return
      end
